*CMZ :          04/07/96  17.17.41  by  Hartwig Albrecht
*CMZ :  2.01/02 30/01/96  16.23.24  by  Hartwig Albrecht
*CMZ :  2.01/01 20/12/95  11.07.30  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   20/12/95

      SUBROUTINE ALFDAT

************************************************************************
*
* Description: Quasi Block-Data for Fritiof
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,KSZ1
      PARAMETER (KSZ1=20)
      INTEGER KFR,IDKFR(KSZ1),IPT,NNUC,IDNNUC(27),NPROT,
     + IDNPROT(27),KCD,IDKCD(27)
      REAL VFR,FDVFR(KSZ1),RO1,FDRO1(27,2),EXMA,FDEXMA(9,2)
      CHARACTER*4 PACD,CDPACD(27)
      COMMON/FRPARA1/KFR(KSZ1),VFR(KSZ1)
C mixing of character and other types in the same common is filthy !!! (HA)
      COMMON/FRCODES/IPT(2),PACD(27),NNUC(27),NPROT(27),KCD(27)
     >           ,RO1(27,2),EXMA(9,2)
      SAVE /FRPARA1/,/FRCODES/

         DATA IDKFR/1,1,0,1,0, 2,1,1,1,1, 0,0,0,0,0, 5*0/
CHA      DATA IDKFR/1,1,0,1,0, 2,1,1,1,1, 0,2,0,0,0, 5*0/

      DATA FDVFR/0.,0.2,0.8,0.2,0.1, 0.01,0.30,.75,.75,0.,
     >         0.,1.0,0.167,.333,.5, .5,4*0./

C.....The following are particles in store.  In particulare RO1 are the
C.....parameters for nuclei density.  For A<,=16, shell model harmonic
C.....oscilator density, RO1(j,1) gives the nuclear root-mean-square-
C.....(charge) radius.  For A>16 RO1(j,2) gives the two parameters r0 and C
C.....to the Wood-Saxon density.
C.....EXMA(J,1) AND EXMA(J,2) correspond to the "minimum excitation mass"
C.....and "diffractive mass" respectively.

      DATA CDPACD
     >         /'NEW1','NEW2','PI+ ','PI- ','K+  ','K-  ','N   ','P   '
     >         ,'PBAR','D   ','HE  ','BE  ','B   ','C   ','O   ','AL  '
     >         ,'SI  ','S   ','AR  ','CA  ','CU  ','AG  ','XE  ','W   '
     >         ,'AU  ','PB  ','U   '/
      DATA IDNNUC/  1,     1,     1,     1,     1,     1,     1,     1,
     >            1,     2,     4,     9,    11,    12,    16,    27,
     >           28,    32,    40,    40,    64,   108,   131,   184,
     >          197,   207,   238/
      DATA IDNPROT/ 0,    0,      1,    -1,     1,    -1,     0,     1,
     >           -1,    1,      2,     4,     5,     6,     8,    13,
     >           14,   16,     18,    20,    29,    47,    54,    74,
     >           79,    82,    92 /
      DATA IDKCD /  0,    0,    211,  -211,   321,   -321, 2112,  2212,
     >        -2212,  18*0 /

C.....Source for RO1: RO(j,1) for A<17 is from ref. BJ; and RO(j,1-2) for
C.....A>17 are taken from FRITIOF 6.0, where RO(j,1)=r0=1.16*(1.-1.16/A**(2/3)):

      DATA FDRO1
     >         / 0.,    0.,    0.,    0.,     0.,    0.,    0.,    0.,
     1           0., 2.095,  1.74, 2.519,  2.37, 2.446, 2.724,   1.01,
     1        1.014, 1.027, 1.045, 1.045, 1.076, 1.101, 1.108,  1.118,
     1        1.120, 1.122, 1.125,
     2           0.,    0.,    0.,    0.,     0.,    0.,    0.,    0.,
     2           0.,    0.,    0.,    0.,     0.,    0.,    0., 0.478,
     2        0.480, 0.490, 0.490, 0.490,  0.490, 0.495,  0.52, 0.530,
     2        0.540, 0.545,  0.55 /

C.....RO1 follows are taken from experimental measurements from ref. BJ,
C.....and some unfound in the book are hand-picked. Not going to be used.
C
C      DATA FDRO1
C     >         / 0.,    0.,    0.,    0.,     0.,    0.,    0.,    0.,
C     1           0., 2.095,  1.74, 2.519,  2.37, 2.446, 2.724,  0.947,
C     1        1.035, 1.016,  1.00, 1.023, 1.068, 1.119, 1.114,  1.116,
C     1        1.109, 1.121, 1.123,
C     2           0.,    0.,    0.,    0.,     0.,    0.,    0.,    0.,
C     2           0.,    0.,    0.,    0.,     0.,    0.,    0., 0.569,
C     2        0.537, 0.540, 0.543,  0.55,  0.579, 0.523,  0.52, 0.525,
C     2        0.535, 0.535,  0.55 /

      DATA FDEXMA
     >         /0.00,  0.00,   0.14,   0.14,  0.50,  0.50,  0.94,  0.94,
     1          0.94,
     2          0.00,  0.00,   0.40,   0.40,  0.75,  0.75,  1.20,  1.20,
     2          1.20 /

C.....Reference. BJ:  R.C. Barrett and D.F.Jackson,
C.....Nuclear Sizes and Structure. However Ca, S, Ar, Xe, W can not be found
C.....in the book.

      DO I = 1, KSZ1
        KFR(I) = IDKFR(I)
        VFR(I) = FDVFR(I)
      END DO

      DO I = 1, 27
        PACD(I) = CDPACD(I)
        NNUC(I) = IDNNUC(I)
        NPROT(I) = IDNPROT(I)
        KCD(I) = IDKCD(I)
        RO1(I,1) = FDRO1(I,1)
        RO1(I,2) = FDRO1(I,2)
      END DO

      DO I = 1, 9
        EXMA(I,1) = FDEXMA(I,1)
        EXMA(I,2) = FDEXMA(I,2)
      END DO

      END

************************************************************************
* End of ALFDAT
************************************************************************
