*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATCC

************************************************************************
*
* Description: make include files *.hh from the DATT command
*
* NEW STYLE!
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4, LENOCC, CHCMPN
      INTEGER IFF, IFH, IFB, IFU, IFC
      CHARACTER CC*200, CN*80, CA*80, CB*80

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)
      CALL CHCTOH ('H', IFH, 1)
      CALL CHCTOH ('B', IFB, 1)
      CALL CHCTOH ('U', IFU, 1)
      CALL CHCTOH ('C', IFC, 1)

      CALL DDOPEN ('auto', 'hh')
      CALL DDNDEF ('AUTO', 'HH')

C structure declarations

        CC = 'struct'
        DO 10 K1 = 1, NDDEF()
          IF (IDDEF_FLAG(K1) .NE. LDDEF_NAM)  GO TO 10
          CC(8:) = ' '
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CA)
          CALL CHAPBC (CC, CA)
          CALL DDCSTS (CC)
 10     CONTINUE

C loop over tables: declarations for attributes and relations

      DO 50 K1 = 1, NDDUSR

        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 50
        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
        CC = 'struct'
        CALL CHAPBC (CC, CN)
        CALL CHAPBC (CC, '{')
        CALL DDCSTO (CC)

        DO 30 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 40

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CUTOL (CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
            K4 = IDDEF_DIM(K2)
            CC = 'int'
            IF (HDDEF_NAM2(1,K2) .EQ. IFF)  THEN
              CC = 'float'
            ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFH .OR. 
     +               HDDEF_NAM2(1,K2) .EQ. IFC)  THEN
              CC = 'char'
              K4 = 4 * MAX (K4, 1)
            ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFB  .OR.
     +               HDDEF_NAM2(1,K2) .EQ. IFU)  THEN
              CC = 'unsigned'
            END IF

            CALL CHAPBC (CC, CA)

            IF (K4 .NE. 0)  THEN
              CALL CHAPPC (CC, '[')
              CALL CHAPPI (CC, K4)
              CALL CHAPPC (CC, ']')
            END IF
            CALL DDCSTS (CC)
            GO TO 30

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            CC = 'ArtePointer<'
            CALL DDIREL (K2, K3)
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CB)
            CALL CHAPPC (CC, CB)
            CALL CHAPPC (CC, '>')
            CALL CHAPBC (CC, CA)
            CALL DDCSTS (CC)
            GO TO 30

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM) THEN
            CC = 'ArteManRelationPointer<'
            GO TO 20
          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN
            CALL DDIREL (K2, K3)
            CC  = ' error in arte/ddatcc '
            DO K4 = K3 + 1, NDDEF()
              IF (CHCMPN (IQ(HQDDEF_NAM3(1,K2)), IQ(HQDDEF_NAM3(1,K4)))
     +            .NE. 0)  THEN
                IF (IDDEF_FLAG(K4) .EQ. LDDEF_RE1)  THEN
                  CC = 'ArteInvOneRelationPointer<'
                  GO TO 20
                ELSE IF (IDDEF_FLAG(K4) .EQ. LDDEF_REM)  THEN
                  CC = 'ArteInvManRelationPointer<'
                  GO TO 20
                END IF
              END IF
            END DO
          ELSE
            GO TO 30
          END IF

 20       CALL CHHTOC (IQ(HQDDEF_NAM3(1,K2)), CB)
          CALL CHAPPC (CC, CB)
          CALL CHAPPC (CC, ',')
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CB)
          CALL CHAPPC (CC, CB)
          CALL CHAPPC (CC, '>')
          CALL CHAPBC (CC, CA)
          CALL DDCSTS (CC)

 30       CONTINUE

 40     CONTINUE

        CALL DDCSTO ('#ifdef USE_ROOT')
        CALL DDCSTS ('  void Streamer(TBuffer &R__b)')
        CALL DDCSTO ('#endif')
        CALL DDCSTS ('}')

 50   CONTINUE

      CALL DDCSTO ('#ifndef CREATELINKS')
      CALL DDCSTO ('extern')
      CALL DDCSTO ('#endif')
      CALL DDCSTO ('struct ArteLinkStruct{')
      CALL DDCSTO ('#ifndef NO_ARTE')
      CALL DDCSTO ('ArteVector<MEMO> larln1,larlnl,narlnk,jlink;')
      CALL DDCSTO ('#endif')

C ArteVector / ArteRelVector

      DO 80 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_NAM)  GO TO 80
        DO 60 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .NE. LDDEF_TAB)  GO TO 60
          IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)), IQ(HQDDEF_NAME(1,K2)))
     +    .NE. 0)  THEN
            CC = 'ArteVector<'
            GO TO 70
          END IF
 60     CONTINUE
        CC = 'ArteRelVector<'
 70     CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
        CALL CHAPPC (CC, CN)
        CALL CHAPPC (CC,'>')
        CALL CUTOL (CN)
        CALL CHAPBC (CC, CN)
        CALL DDCSTS (CC)
 80   CONTINUE

      CALL DDCSTS ('ArteVector<MEMO> jlast')
      CALL DDCSTS ('} artelink_')

C member functions

      DO 120 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .EQ. LDDEF_TAB)  THEN
          CC = 'inline ArteVector<'
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '>& ArteTable<')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '>::getLink()')
          CALL DDCSTO (CC)
          CC = '{ return artelink_.j'
          CALL CUTOL (CN)
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC,'; }')
          CALL DDCSTO (CC)
        ELSE IF (IDDEF_FLAG(K1) .EQ. LDDEF_REM)  THEN
          CA = 'ArteManRelationPointer<'
          GO TO 110
        ELSE IF (IDDEF_FLAG(K1) .EQ. LDDEF_INM)  THEN
          DO K2 = 1, NDDEF()
            IF (CHCMPN (IQ(HQDDEF_NAM3(1,K1)), IQ(HQDDEF_NAM3(1,K2)))
     +          .NE. 0)  THEN
              IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1)  THEN
                CA = 'ArteInvOneRelationPointer<'
                GO TO 110
              ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM)  THEN
                IF (K1 .EQ. K2)  GO TO 120
                CA = 'ArteInvManRelationPointer<'
                GO TO 110
              END IF
            END IF
          END DO
        END IF
        GO TO 120

 110    CC = 'inline ArteRelVector<'
        CALL CHHTOC (IQ(HQDDEF_NAM3(1,K1)), CB)
        CALL CHAPPC (CC, CB)
        CALL CHAPPC (CC, '>&')
        CALL CHAPBC (CC, CA)
        CALL CHAPPC (CC, CB)
        CALL DDIREL (K1, K2)
        CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CN)
        CALL CHAPCC (CC, CN)
        CALL CHAPPC (CC, '>::getLink()')
        CALL DDCSTO (CC)
        CC = '{ return artelink_.j'
        CALL CUTOL (CB)
        CALL CHAPPC (CC, CB)
        CALL CHAPPC (CC,'; }')
        CALL DDCSTO (CC)

 120  CONTINUE

      CALL DDCSTO ('#endif  /* defined(_AUTO_HH_) */')

      END

************************************************************************
* End of DDATCC
************************************************************************
