
// *********************************************************************
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/arte/include/arte.hh,v $
// $Revision: 1.8 $
// $Author: natasha $
// $Date: 1999/07/02 10:25:11 $
//
// Created: 03-97,   C. Borgmeier
//
// *********************************************************************

//
// This file is part of the C++ interface for Arte
// the HERA-B reconstruction and analysis tool
//

#ifndef __ARTE_HH__
#define __ARTE_HH__

//
// This part is copied from Gate/Object.h
//
#ifdef USE_ROOT
# include <TObject.h>
#else
# ifndef _TOBJECT_
class TObject {};

#ifdef USE_GATE
# include  <vector>
typedef vector<TObject*> TObjArray;
#endif /* USE_GATE */

typedef int            Int_t;       //int 4 bytes
// from Rtypes.h
typedef float          Float_t;     //Float 4 bytes
typedef double         Double_t;    //Float 8 bytes
typedef char           Text_t;      //General string
typedef unsigned char  Bool_t;      //Boolean (0=false, 1=true)
typedef unsigned char  Byte_t;      //Byte (8 bits)
typedef short          Version_t;   //Class version identifier
typedef short          Short_t;     //Class version identifier
typedef long           Long_t;     //Class version identifier
typedef char           Option_t;    //Option string
typedef int            Ssiz_t;      //String size
typedef float          Real_t;      //TVector and TMatrix element type
#define _TOBJECT_

#endif /* _TOBJECT_ */
#endif /* USE_ROOT */


#if defined(USE_ROOT) && !defined(__CINT__)
#include <TClass.h>
#endif


#ifdef NO_ARTE
#include <Gate/RtypesT.h>

struct ArteLink
{
};


class ArteVector
{
friend class SubEvent;
public:
private:
  void* vec;
};

#ifndef STUPID_DEF6
#define STUPID_DEF6


class ArtePointerBase;

template<class T>
class ArteRelVector: public ArteLink
{
public:
  ArteRelVector();
  ~ArteRelVector();
  void setRelation( ArtePointerBase left, ArtePointerBase right );
private:
  void* vec;
};

#endif /* STUPID_DEF6 */

#else               /*   ARTE   */


class ArteLink
{
public:
public:
  inline int& getRef() { return i; }
  inline int& getInt() { return i; }
#if !defined(ARTE_CXX_COMPAT_MODE) || ARTE_CXX_COMPAT_MODE==1
  inline int operator()() { return i; }
#endif
  
protected:
  int i;
};


class ArteVector: public ArteLink
{
public:
  inline const int & operator()() { return getInt(); };
};


class ArtePointerBase;

template<class T>
class ArteRelVector: public ArteVector
{
public:
  ArteRelVector() {}
  ~ArteRelVector() {}
  void setRelation( ArtePointerBase, ArtePointerBase );
};


#ifndef STUPID_DEF3
#define STUPID_DEF3


extern struct {
  int nzebra, gversn;
  float zversn;
  int ixstor, ixevnt, ixcons, fendq[16], lq[8], iq[1];
} gcbank_;


#include "arte/ArteProto.hh"

#endif /* STUPID_DEF3 */
#endif               /*    ARTE    */

#ifndef STUPID_DEF2
#define STUPID_DEF2

/*
#ifdef USE_GATE
template <class T> class GClonesArray;

template <class T>
class GClonesArrayLink: public ArteVector
{
public:
  GClonesArrayLink( GClonesArray<T*>* a )
    : array( a ) {}

  GClonesArray<T*>* array;
};
#endif
*/
#include "ArteTable.hh"

#endif /* STUPID_DEF2 */

//
// include the table definitions
//
#ifndef STUPID_DEF5
#define STUPID_DEF5

template <class T>
bool ArteTable<T>::isArteTable()
{
  return true;
}


#include <auto/auto.hh>

#endif /* STUPID_DEF5 */

#ifndef STUPID_DEF4
#define STUPID_DEF4

struct MTRA;
struct MTMT;

inline void createRelation( ArtePointer<MTRA> el1, ArtePointer<MTRA> el2,
		     ArteInvOneRelationPointer<MTMT,MTRA> MTRA::* = 0
		     )
{
#ifndef NO_ARTE
  mmbrel_(  ArteInvOneRelationPointer<MTMT,MTRA>::getLink().getInt(),
	    el1, el2 );
#else
#endif
}


struct RSEG;
struct RSRS;

inline void createRelation( ArtePointer<RSEG> el1, ArtePointer<RSEG> el2,
		     ArteManRelationPointer<RSRS,RSEG> RSEG::* = 0
		     )
{
#ifndef NO_ARTE
  mmbrel_(  ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	    el1, el2 );
#else
#endif
}


#include "arte/ArteTable.icc"

#endif /* STUPID_DEF4 */
#endif
