*-- Author :    Hartwig Albrecht   11/07/95

      SUBROUTINE MMRUPD (IL)

************************************************************************
*
* Description: invert relations and update specific tables
*
* Called from: MMREAD, MMRMIX
*
* External references: MMIREL
*
* Argument in/out description
*   IL     in     link number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMS.fi"
#include "auto/MTRA.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"

      INTEGER IL, I, J

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"
#include "auto/MTRA.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

C fill tables MTRA and MVER

      IF (JMTRA .EQ. 0)  GO TO 50
      DO 40 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
        IF (JLINK(IMEMS_SUB(I)) .NE. JMTRA)  GO TO 40

        DO 30 J = 1, NMTRA()
          IF (IMTRA_FLAG(J) .EQ. 2)  THEN
C resonance
            Q(QMTRA_MASS(J)) = FMTRA_ML(J)
            Q(QMTRA_LENG(J)) = 0.
          ELSE
C stable particle
            Q(QMTRA_MASS(J)) = FTOPP_MASS(OMTRA_TOPP(J))
            Q(QMTRA_LENG(J)) = FMTRA_ML(J)
          END IF

C relations to MVER

          IF (IMTRA_ORIG(J))  10, 30, 20
 10       IQ(L_A(JMTRA_BTRA,J,JMTRA)) = -IMTRA_ORIG(J)
          IQ(L_A(JMTRA_BVER,J,JMTRA)) = OMTRA_BVER(-IMTRA_ORIG(J))
          GO TO 30
 20       IQ(L_A(JMTRA_BTRA,J,JMTRA)) = OMVER_BTRA(IMTRA_ORIG(J))
          IQ(L_A(JMTRA_BVER,J,JMTRA)) = IMTRA_ORIG(J)

 30     CONTINUE
        GO TO 50

 40   CONTINUE

C invert relations

 50   DO 60 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)

        IF (IMEMO_FLAG(IMEMS_SUB(I)) .GT. 0)
     +    CALL MMIREL (JLINK(IMEMS_SUB(I)))

 60   CONTINUE

c     copy NEDE to GEDE 
      IF(JLINK(IL) .EQ. JNGHD .AND. JNGHD .NE. 0)   CALL CRGEHD    

C relation between TOPP and TDEC
      IF (JLINK(IL) .EQ. JTOPP .AND. JTOPP .NE. 0)  CALL TPRELA
      
C     Fill MIM1-MIML in GEDE
      IF (JLINK(IL) .EQ. JEVHD .AND. JEVHD .NE. 0)  CALL CRGEPT

C copy DEVT into DNNN
      IF (JLINK(IL) .EQ. JEVHD .AND. JDEVT .NE. 0)  CALL UTDEVT

 90   END

************************************************************************
* End of MMRUPD
************************************************************************
