*-- Author :    Hartwig Albrecht   16/07/95

      SUBROUTINE MMWEVT

************************************************************************
*
* Description: write one event
*
* Called from: ATEVNT
*
* External references: MMWRIT, MZWIPE
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"
#include "auto/EVFN.fi"
#include "auto/GEO.fi"

      INTEGER NUN, LUN(3), I, J, IL, IOS, LOCF

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"
#include "auto/EVFN.ff"
#include "auto/GEO.ff"

      IF (JEVHD .EQ. 0)  GO TO 900
      IF (EVENTOUT .LE. 0)  THEN
        CALL MEMESC (6451355, 1, ILARGEST,
     +        'MMWEVT: event output flag EVENTOUT <= 0: no output')
        GO TO 90
      END IF

      NUN = 0

      IF (IMEIO_FLAG(LDSTO) .GT. 0)  THEN
        CALL MEMESC (9236634, 1, ILARGEST,
     +        'MMWEVT: event output on DST')
        NUN = NUN + 1
        LUN(NUN) = LDSTO
      END IF

      IF (IMEIO_FLAG(LMINIO) .GT. 0)  THEN
        CALL MEMESC (1346354, 1, ILARGEST,
     +        'MMWEVT: event output on MINI')
        NUN = NUN + 1
        LUN(NUN) = LMINIO
      END IF

      IF (IMEIO_FLAG(LNOTEO) .GT. 0)  THEN
        CALL MEMESC (1346736, 1, ILARGEST,
     +        'MMWEVT: event output on NOTE')
        NUN = NUN + 1
        LUN(NUN) = LNOTEO
        CALL MMOPEN (LNOTEO, 1, IOS)
      END IF

      IF (NUN .EQ. 0)  THEN
        CALL MEMESC (512344, 1, ILARGEST,
     +      'MMWEVT: no event output file declared')
        GO TO 90
      ENDIF

      IL = LOCF (JEVHD) - LARLN1

      IF (BITTEST(BMEMO_IOA(IL),2) .EQ. 0)  THEN
        CALL MEMESC (8345345, 1, ILARGEST,
     +        ' MMWEVT: event header EVHD is flagged for non-output')
        GO TO 90
      END IF

C file name
      CALL MMBOOK (JEVFN, 1)

      DO 20 I = 1, NUN

        DO J = 1, NEVFN_NAME
          IQ(HQEVFN_NAME_L(J)) = HMEMO_NAME(J,IMEIO_CURRENT(LUN(I)))
        END DO

        CALL MMWRIT (LUN(I), JEVHD, IOS)
        
        IF (IOS .GE. 0)  GO TO 20

        C78 = 'MMWEVT: no more output files for unit'
        CALL CH78BI (LUN(I))
        CALL ME78EC (5134563)

 20   CONTINUE

C write out calibration / alignment constants

 90   CALL ACWRITE

C drop event

      CALL MMWIPE (IXEVNT)

C delete relation TOPP -> MTRA

      CALL MMDREL (LOCF(JMTTO) - LARLN1)

C delete MIM1-MIML, DIG1-DIGL, HIT1-HITL from GEDE-BANK
      DO I=1,NGEDE()
      IQ(IQGEDE_MIM1(I)) = 0
      IQ(IQGEDE_MIML(I)) = -1
      IQ(IQGEDE_DIG1(I)) = 0
      IQ(IQGEDE_DIGL(I)) = -1
      IQ(IQGEDE_HIT1(I)) = 0
      IQ(IQGEDE_HITL(I)) = -1
      ENDDO
      DO I=1,NGCAL()
      IQ(IQGCAL_MIM1(I)) = 0
      IQ(IQGCAL_MIML(I)) = -1
      IQ(IQGCAL_DIG1(I)) = 0
      IQ(IQGCAL_DIGL(I)) = -1
      IQ(IQGCAL_HIT1(I)) = 0
      IQ(IQGCAL_HITL(I)) = -1
      ENDDO

 900  END

************************************************************************
* End of MMWEVT
************************************************************************
