//                              -*- Mode: C++ -*-
//: CmdCareDump.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCAREDUMP_HH_
#define CMDCAREDUMP_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"

enum DUMPTYPES {HFLAG,CFLAG,CTFLAG,LABFLAG,END};

/*
CLASS
  CmdCareDump
  Base class to deal with the care/dump kuip command
*/

class CmdCareDump : public CmdBase {
public:
  //-- Constructors
  CmdCareDump();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareDump();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();
  //--
  //   Static access member function
  static bool get(int i);
  //--
  //  Static set internal data
  static void setDump(bool flag1, bool flag2, bool flag3, bool flag4);

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  static bool dumpdata[END];
};

#endif  //   CMDCAREDUMP_HH_
