//                              -*- Mode: C++ -*-
//: CmdCareMinims.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
/* $Log: CmdCareMinims.hh,v $
 * Revision 1.4  1999/05/19 10:25:01  natasha
 * Extended kuip command MINIMS to allow an "offset" parameter.
 *
 */

#ifndef CMDCAREMINIMS_HH_
#define CMDCAREMINIMS_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"
/**
class  CmdCareMinims
  Class to deal with the Minims kuip command
*/

class CmdCareMinims : public CmdBase {
public:
  /// Constructor
  CmdCareMinims();
  /// Destructor
  virtual ~CmdCareMinims();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  ///   Read a command from external source
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();
  //--
  ///    Set internal data
  void setMinims(Energy_t  inn, Energy_t mid, Energy_t out, int offset);

private:
  //--
  Energy_t  inner,middle,outer;
  int minoffset;
};

#endif  //   CMDCAREMINIMS_HH_
