# ifndef __HBOOK_H
# define __HBOOK_H

#ifdef __cplusplus
extern "C" {
#endif

#include <string.h>

#ifndef TRUE
#define TRUE                     (1==1)
#endif
#ifndef FALSE
#define FALSE                    (1==0)
#endif

/*------------ Warning: maybe here are some typos!! --------------*/

/*
 *----------------------------------------------------------------------------
 * CERN Library declarations
 *----------------------------------------------------------------------------
 */
extern void hbprof_(int *, char *, int *, float *, float *, float *,
		    float *, char *, int, int);
extern void hdelet_(int *);
extern void hexist_(int *);
extern void hf1_   (int *, float *, float *);
extern void hf2_   (int *, float *, float *, float *);
extern void hfill_ (int *, float *, float *, float *);
extern void hlimit_(int *);
extern void hmaxim_(int *, float *);
extern void hminim_(int *, float *);
extern void hopera_(int *, char *, int *, int *, float *, float *, int);
extern void hpak_  (int *, float *);
extern void hpakad_(int *, float *);
extern void hpake_ (int *, float *);
extern void hprint_(int *);
extern void hrput_ (int *, char *, char *, int, int);
extern void hbook1_(int *, char *, int *, float *, float *, float *, int);
extern void hbook2_(int *, char *, int *, float *, float *, int *, float *,
                    float *, float *, int);
extern void hfn_   (int *, float *);
extern void hreset_(int *, char *, int);
extern void hproj1_(int *, int *, int *, int *, int *, int *, int *);
extern void hbookn_(int *, char *, int *, char *, int *, char *, int,
		    int, int);
extern void hgive_ (int *, char *, int *, float *, float *, int *,
		    float *, float *, int *, int *);
extern void hfithn_(int *, char *, char *, int *, float *, float *, float *,
		    float *, float *, float *, int, int);
extern void hgfit_ (int *, int *, int *, float *, float *, float *, char *);
extern void hf1e_  (int *, float *, float *, float *);
extern float hi_    (int *, int *);
extern float hij_   (int *, int *, int *);
extern float hx_    (int *, float *);
extern float hxy_   (int *, float *, float *);

/*
 *----------------------------------------------------------------------------
 * original HBOOK calls
 *----------------------------------------------------------------------------
 */
#define Hdelet(A)   do{int a=(A); hdelet_(&a);                        }while(FALSE)
#define Hexist(A)   do{int a=(A); hexist_(&a);                        }while(FALSE)
#define Hlimit(A)   do{int a=(A); hlimit_(&a);                        }while(FALSE)
#define Hmaxim(A,B) do{int a=(A); float b=(B); hmaxim_(&a, &b);       }while(FALSE)
#define Hminim(A,B) do{int a=(A); float b=(B); hminim_(&a, &b);       }while(FALSE)
#define Hpak(A,B)   do{int a=(A); hpak_(&a, (B));                     }while(FALSE)
#define Hpakad(A,B) do{int a=(A); hpakad_(&a, (B));                   }while(FALSE)
#define Hpake(A,B)  do{int a=(A); hpake_(&a, (B));                    }while(FALSE)
#define Hprint(A)   do{int a=(A); hprint_(&a);                        }while(FALSE)
#define Hfn(A,B)    do{int a=(A); hfn_(&a,(B));                       }while(FALSE)

static float Hi (int a, int b)            { return hi_(&a, &b); }
static float Hij(int a, int b, int c)     { return hij_(&a, &b, &c); }
static float Hx (int a, float b)          { return hx_(&a, &b); }
static float Hxy(int a, float b, float c) { return hxy_(&a,&b,&c); }

#define Hreset(A,B)              \
do{                              \
  int  a=(A);                    \
  hreset_(&a, (B), strlen((B))); \
}while(FALSE)

#define Hbprof(A,B,C,D,E,F,G,H)                                        \
do{                                                                    \
  int   a=(A), c=(C);                                                  \
  float d=(D), e=(E), f=(F), g=(G);                                    \
  hbprof_(&a, (B), &c, &d, &e, &f, &g, (H), strlen((B)), strlen((H))); \
}while(FALSE)

#define Hf1(A,B,C)     \
do{                    \
  int   a=(A);         \
  float b=(B), c=(C);  \
  hf1_(&a,&b,&c);      \
}while(FALSE)

#define Hf2(A,B,C,D)         \
do{                          \
  int   a=(A);               \
  float b=(B), c=(C), d=(D); \
  hf2_(&a, &b, &c, &d);      \
}while(FALSE)

#define Hfill(A,B,C,D)       \
do{                          \
  int   a=(A);               \
  float b=(B), c=(C), d=(D); \
  hfill_(&a, &b, &c, &d);    \
}while(FALSE)

#define Hopera(A,B,C,D,E,F)                      \
do{                                              \
  int   a=(A), c=(C), d=(D);                     \
  float e=(E), f=(F);                            \
  hopera_(&a, (B), &c, &d, &e, &f, strlen((B))); \
}while(FALSE)

#define Hrput(A,B,C)                              \
do{                                               \
  int a=(A);                                      \
  hrput_(&a, (B), (C), strlen((B)), strlen((C))); \
}while(FALSE)

#define Hbook1(A,B,C,D,E,F)                      \
do{                                              \
  int   a=(A), c=(C);                            \
  float d=(D), e=(E), f=(F);                     \
  hbook1_(&a, (B), &c, &d, &e, &f, strlen((B))); \
}while(FALSE)

#define Hbook2(A,B,C,D,E,F,G,H,I)                            \
do{                                                          \
  int   a=(A), c=(C), f=(F);                                 \
  float d=(D), e=(E), g=(G), h=(H), i=(I);                   \
  hbook2_(&a, (B), &c, &d, &e, &f, &g, &h, &i, strlen((B))); \
}while(FALSE)

#define Hproj1(A, B, C, D, E, F, G)                    \
do{                                                    \
  int a=(A), b=(B), c=(C), d=(D), e=(E), f=(F), g=(G); \
  hproj1_(&a, &b, &c, &d, &e, &f, &g);                 \
}while(FALSE)

#define Hbookn(A, B, C, D, E, F)                               \
do{                                                            \
  int a=(A), c=(C), e=(E);                                     \
  hbookn_(&a, (B), &c, (D), &e, (F), strlen((B)), strlen((D)), \
	  strlen((F)));                                        \
}while(FALSE)

#define Hgive(A,B,C,D,E,F,G,H)              \
do{                                         \
  int    a=(A), i, j;                       \
  int   *c=(C), *f=(F);                     \
  float *d=(D), *e=(E), *g=(G), *h=(H);     \
  char  b[80];                              \
  hgive_(&a, b, c, d, e, f, g, h, &i, &j);  \
  *(B) = strdup(b);                         \
}while(FALSE)

#define Hfithn(A,B,C,D,E,F,G,H,I,J)                                       \
do{                                                                       \
  int    a=(A),  d=(D);                                                   \
  float *e=(E), *f=(F), *g=(G), *h=(H), *i=(I);                           \
  float  j=(J);                                                           \
  hfithn_(&a, (B), (C), &d, e, f, g, h, i, &j, strlen((B)), strlen((C))); \
}while(FALSE)

#define Hgfit(A,B,C,D,E,F,G)        \
do{                                 \
   int   a=(A),  b=(B),  c=(C);     \
   float d=(D), *e=(E), *f=(F);     \
   char *g=(G);                     \
   hgfit_(&a, &b, &c, &d, e, f, g); \
}while(FALSE)

#define Hf1e(A,B,C,D)        \
do{                          \
  int a=(A);                 \
  float b=(B), c=(C), d=(D); \
  hf1e_(&a, &b, &c, &d);     \
}while(FALSE)

/*
 *----------------------------------------------------------------------------
 * higher level adaption(s) and/or modifications
 *----------------------------------------------------------------------------
 */
#define hbprof(A,B,C,D,E,F,G,H)      Hbprof(A,B,C,D,E,F,G,H)
#define hdelet(A)                    Hdelet(A)
#define hexist(A)                    Hexist(A)
#define hf1(A,B,C)                   Hf1(A,B,C)
#define hf2(A,B,C,D)                 Hf2(A,B,C,D)
#define hfill(A,B,C,D)               Hfill(A,B,C,D)
#define hlimit(A)                    Hlimit(A)
#define hmaxim(A,B)                  Hmaxim(A,B)
#define hminim(A,B)                  Hminim(A,B)
#define hopera(A,B,C,D,E,F)          Hopera(A,B,C,D,E,F)
#define hpak(A,B)                    Hpak(A,B)
#define hpakad(A,B)                  Hpakad(A,B)
#define hpake(A,B)                   Hpake(A,B)
#define hprint(A)                    Hprint(A)
#define hrput(A,B,C)                 Hrput(A,B,C)
#define hfn(A,B)                     Hfn(A,B)
#define hreset(A,B)                  Hreset(A,B)
#define hgive(A,B,C,D,E,F,G,H)       Hgive(A,B,C,D,E,F,G,H)
#define hfithn(A,B,C,D,E,F,G,H,I,J)  Hfithn(A,B,C,D,E,F,G,H,I,J)
#define hgfit(A,B,C,D,E,F,G)         Hgfit(A,B,C,D,E,F,G)
#define hf1e(A,B,C,D)                Hf1e(A,B,C,D)
#define hi(A,B)                      Hi(A,B)
#define hij(A,B,C)                   Hij(A,B,C)
#define hx(A,B)                      Hx(A,B)
#define hxy(A,B,C)                   Hxy(A,B,C)


#define hbook1(A,B,C,D,E)                        \
do{                                              \
  int   a=(A), c=(C);                            \
  float d=(D), e=(E), f=0.;                      \
  hbook1_(&a, (B), &c, &d, &e, &f, strlen((B))); \
}while(FALSE)

#define hbook2(A,B,C,D,E,F,G,H)                              \
do{                                                          \
  int a=(A), c=(C), f=(F);                                   \
  float d=(D), e=(E), g=(G), h=(H), i=0.;                    \
  hbook2_(&a, (B), &c, &d, &e, &f, &g, &h, &i, strlen((B))); \
}while(FALSE)

#define hproj(A, B, C)                                             \
do{                                                                \
  int a = (A), b = (B), c = 0, d = 1, e = 1, f = 9999999, g = (C); \
  hproj1_(&a, &b, &c, &d, &e, &f, &g);                             \
}while(FALSE)

/*-----------------------------------------------------------------------------
 * modified subroutine hbookn: the number of variables in the ntuple
 * and the  tags for all variables are extracted from the string D
 *
 * Author: Joerg Rieling / Michael Schmelling 
 *---------------------------------------------------------------------------*/
#define hbookn(A, B, C, D)                                       \
do{                                                              \
  int id = (A);                                                  \
  int n=0, l=0, j=0, elli = 0, bufsiz = 1000;                    \
  char *c, *calloc;                                              \
\
  for (c=(D); *c != '\0'; c += 1)                                \
    if (!strncmp( c, ",", 1)){                                   \
      n++;                                                       \
      if (!elli) { exit (999); }                                 \
      if (l<elli) l = elli;                                      \
      elli = 0;                                                  \
    }else{                                                       \
      elli++;                                                    \
    }                                                            \
\
  calloc = malloc ((l*(n+1)+1) *  sizeof(char));                 \
  j = elli = 0;                                                  \
\
  for (c=(D); *c != '\0'; c += 1)                                \
    if (!strncmp( c, ",", 1)){                                   \
      while (elli<l)                                             \
      {                                                          \
        calloc[j++] = *" ";                                      \
        elli++;                                                  \
      }                                                          \
      elli = 0;                                                  \
    }else{                                                       \
      calloc[j++] = *c;                                          \
      elli++;                                                    \
    }                                                            \
\
  while (elli<l)                                                 \
  {                                                              \
    calloc[j++] = *" ";                                          \
    elli++;                                                      \
  }                                                              \
\
  calloc [j] = '\0';                                             \
  n++;                                                           \
\
  hbookn_ (& id, (B), & n, (C), & bufsiz, calloc, strlen((B)),   \
           strlen((C)), l);                                      \
\
  free ((void *) calloc);                                        \
}while(FALSE)

#ifdef __cplusplus
           }
#endif
# endif
