#ifndef _DBARTEBRIDGE_H_

#   include <sys/types.h>
#   include "mizzi/table.h"

#   define DB_MAX_NAME_SIZE		80
#   define DB_MAX_TABLE_NAME_SIZE	16
#   define TABLE_DESC_LEN               5000
#   define MAX_KEYS_NUMBER              256

#   define _DBARTEBRIDGE_H_

typedef struct {
	char Name[DB_MAX_NAME_SIZE+1];
	char Comm[DB_MAX_NAME_SIZE+1];
	char Fmt[TABLE_DESC_LEN];
	char Type[64];
	int Dim[64];
	int Entries;
	} DbTableDesc;

typedef struct _FileDesc {
	int  lun;
	char Name[256];
	char Csym[DB_MAX_NAME_SIZE+1];
	Tables Id;
	int active;
	int rwflag;
	struct _FileDesc *next;
	} DbFileDesc;



void DbOpen (int  lun, char *fname, int rwflag, int *ierr);

void DbClose(int  lun, int *ierr);

void DbWriteHeader(int  lun, int *Mlink, int  major, int  minor, int *ierr);
void DbWriteTable (int  lun, int *Mlink, int  major, int  minor, int *ierr);

void DbReadHeader(int  lun, int *Mlink, int  maj, int  min, char *opt,int *ierr);
void DbReadTable (int  lun, int *Mlink, int  maj, int  min, char *opt,int *ierr);

void dbstop_(void);
void dbinit_(void);

void DbListFile(char *);

void DbStoreLedaRel(int lun, int reltab, int minor, int major, int *ierr);
void DbLoadLedaRel(int lun, int reltab, int minor, int major, char *opt, int *ierr);

extern int DbLedaCompatibility;

#endif




