#ifndef _RSEG_HH_
#define _RSEG_HH_
struct RSEG_RTRA;
struct RSEG_RBEG;
struct RSEG_HITB;
struct RSEG_RPNT;
struct RSEG_MTRA;
struct RSEG_RHIT;
struct RSEG_RCCL;
struct RSEG_REND;
struct RSEG {
   float zf;
   float xf;
   float yf;
   float txf;
   float tyf;
   float pf;
   float cvf[15];
   float time;
   float dtim;
   float ze;
   float xe;
   float ye;
   float txe;
   float tye;
   float pe;
   float cve[15];
   float chi;
   int fit;
   int cmp;
   ArteRelationPointer<RSEG_RTRA> rtra;
   ArteRelationPointer<RSEG_RBEG> rbeg;
   ArteRelationPointer<RSEG_HITB> hitb;
   ArteRelationPointer<RSEG_RPNT> rpnt;
   ArteRelationPointer<RSEG_MTRA> mtra;
   ArteRelationPointer<RSEG_RHIT> rhit;
   ArteRelationPointer<RSEG_RCCL> rccl;
   ArteRelationPointer<RSEG_REND> rend;
};
#include "auto/RTRA.hh"
#include "auto/RTRS.hh"
#include "auto/RSRS.hh"
#include "auto/HITB.hh"
#include "auto/RSHI.hh"
#include "auto/RPNT.hh"
#include "auto/RSRP.hh"
#include "auto/MTRA.hh"
#include "auto/RSMT.hh"
#include "auto/RHIT.hh"
#include "auto/RSRH.hh"
#include "auto/RCCL.hh"
#include "auto/RSRC.hh"
#include "auto/RSEG.icc"
#endif
