/************************************************************************
*
* cr_HepRot
* written by Siegmund Nowak, January 98
*
* class cr_HepRot contains CLHEP functions HepRot adapted to GEDE  
* Rotation tables (for use in digi) 
*
*       called from everywhere
*
************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "digi/cr_HepRot.hh"
#include "arte/Arte.hh"
#include "arte/ArteUtil.h"
#include "arte/ArteMessage.hh"
#include "auto/GEO.hh"

void cr_HepRot::set_HepRot(int ipl) {
      ArtePointer<GEDE> gede(ipl);
      rxx = gede->rot[0];
      rxy = gede->rot[3];
      rxz = gede->rot[6];
      ryx = gede->rot[1];
      ryy = gede->rot[4];
      ryz = gede->rot[7];
      rzx = gede->rot[2];
      rzy = gede->rot[5];
      rzz = gede->rot[8]; }

void cr_HepRot::rotate_Z(float pold[], float pnew[]) {  
      pnew[0] = rxx*pold[0] + rxy*pold[1];
      pnew[1] = ryx*pold[0] + ryy*pold[1];
      pnew[2] = pold[2];}

int  cr_HepRot::Checkxy_Grot(const float g[], float &angle) {
           angle =0.;
           if(g[8] < .99999) return 0;
           if(g[0]>.99999 && g[4]>.99999 ) return 1;
           if(fabs(g[0]) > .9999){angle=float(acos(g[0])*AR_RADDEG); return 1;} 
           else if(fabs(g[1]) > .9999)  {
	     angle=float(asin(g[1])*AR_RADDEG);  return 1;}
           return 0;}

void  cr_HepRot::Arot_par(float &xmin,float &xmax,float &ymin,float &ymax,
                                                       const float gr[]) { 
           float par[2], mean[2];
           mean[0]=.5*( (xmin + xmax)* gr[0] + (ymin + ymax)* gr[1]);  
           mean[1]=.5*( (xmin + xmax)* gr[3] + (ymin + ymax)* gr[4]);
           par[0]=fabs(.5*(gr[0]*(xmax-xmin) + gr[1]*(ymax-ymin))); 
           par[1]=fabs(.5*(gr[1]*(xmax-xmin) + gr[0]*(ymax-ymin))); 
           xmin = mean[0] - par[0];    xmax = mean[0] + par[0];
           ymin = mean[1] - par[1];    ymax = mean[1] + par[1];  }

void  cr_HepRot::Set_UnitMatrix(float gr[]) {
           gr[0] = gr[4] = gr[8] = 1.;
	   gr[1] = gr[2] = gr[3] = gr[5] = gr[6] = gr[7] = 0.;}





