
// *****************************************************************************
//
// source:    faCatchSIG.C
//
// type:      source code
//
// created:   23 Sep 97
// updated:    1 Jun 99
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:   include prototypes here (AG: 23 Feb 99)
//            polishing (AG: 11 Mar 99)
//            use atstopc_() (AG: 25 Mar 99)
//            put includes (AG: 1 Jun 99)
//
// *****************************************************************************

// includes
#include <iostream>
#include <signal.h>

#include "farm/fa.hh"

// C prototypes
extern "C" void atstopc_( const char *string , const int count );

// *****************************************************************************
//
// name:      faCatchSIG
//
// purpose:   catch signal and invoke atstopc_()
//
// input:     int  signal number
// return:    void
//
// *****************************************************************************

void
faCatchSIGINT( int sigNum )
{
#ifdef _OUT_
  cout << "faCatchSIGINT: sigNum=" << sigNum << " "
       << "invoking atstopc_ ..."             << endl;
#endif
  atstopc_( "Called from faCatchSIGINT()", 14 );
}

void
faCatchSIGQUIT( int sigNum )
{
#ifdef _OUT_
  cout << "faCatchSIGQUIT: sigNum=" << sigNum << " "
       << "invoking atstopc_ ..."              << endl;
#endif
  atstopc_( "Called from faCatchSIGQUIT()", 14 );
}

void
faCatchSIGTERM( int sigNum )
{
#ifdef _OUT_
  cout << "faCatchSIGTERM: sigNum=" << sigNum << " "
       << "invoking atstopc_ ..."              << endl;
#endif
  atstopc_( "Called from faCatchSIGTERM()", 14 );
}

