        subroutine crbox(material,csl,x1,x2,y1,y2,z1,z2)
******************************************************************
*
* Defines a Geant box.
*
* Called from: otrcov.F
*
* Arguments          in/out  Description
*
* material           in      material of wall
* csl                in      mother volume
* x1,x2,y1,y2,z1,z2  in      box coordinates in lab. frame
*
* Coordinates of the Geant volume center xp_sl,yp_sl,zp_sl are used.
*
* Alexander Lanyov     Mar 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "gean/otrgeo.fi"

        integer ip
        real par(8),xp,yp,zp,x1,x2,y1,y2,z1,z2
        character*4 material,csl

#include "arte/Arte.ff"
#include "auto/GEO.ff"

        xp = 0.5*(x1+x2) - xp_sl
        yp = 0.5*(y1+y2) - yp_sl
        zp = 0.5*(z1+z2) - zp_sl

        par(1) = 0.5*(x2-x1)
        par(2) = 0.5*(y2-y1)
        par(3) = 0.5*(z2-z1)

c        write (*,*) 'crbox called: ',material,' ',csl,x1,x2,y1,y2
        do ip=1,3
           if (par(ip).le.0.) then
              c78 = 'Illegal GEANT BOX parameter par('
              call ch78ai(ip)
              call ch78ac(') =')
              call ch78bf(par(ip),-3)
              call ch78bc('cm')
              call me78wa
           end if
        end do
 
        call crpos(material,csl,0,0,xp,yp,zp,0,'ONLY',par)

        return
        end
