
      SUBROUTINE CRGEDE(NAME,ILAY,ISEC)

************************************************************************
* CRGEDE
* written by Siegmund Nowak
*
* This routine books and fills the detector bank GEDE
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
************************************************************************
      IMPLICIT NONE

      INTEGER ILAY,ISEC,IUCOMP,I,IVOS,JVOS,LVOLS(15),LCOPY(15),NLEV,
     +        INDAUT,NN
      INTEGER MATNUM,NUMED,NMAT,NMM,LENOCC
      REAL POS(11),ROTM(9),XMS
      CHARACTER NAME*4,MATNAM*20

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcvolu.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGMOTH.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C     Book NEDE bank and connect it to NESL bank 
      IF(CURRSL.LE.0.OR.CURRSL.GT.NNESL()) 
     +                   CALL MEERRO('CRGEDE: current NESL entry = 0 ')
      CALL MMBOOK(JNEDE,1)
      NN = NNEDE()
c      IQ(JNEDE+2 + (NN-1)*NCNEDE()+JNEDE_NESL) = CURRSL
      CALL MMBREL(JNSND,CURRSL,NN)
      IF(INESL_FPL(CURRSL).EQ.0) IQ(IQNESL_FPL(CURRSL)) = NN   
      IQ(IQNESL_NPL(CURRSL)) = IQ(IQNESL_NPL(CURRSL)) + 1

C     get detector volume nr IVOL 
      IVOS = IUCOMP (NAME, IQ(JVOLUM+1), IQ(JVOLUM-1))
      IF(IVOS.EQ.0) CALL MEERRO('CRGEDE >> NONVALID VOLUME')
      JVOS = LQ(JVOLUM-IVOS)

c     define the volume tree into LVOLS,LCOPY
      CALL CRLVBK(IQ(JVOLUM+IVOS),NN,INDAUT,NLEV,LVOLS,LCOPY)
      IF(NLEV.LE.0) CALL MEERRO('CRGEDE: NLEV < 0 ')

c     call the transformation routine and fill the geometric data in
      CALL CRVTRM(NLEV,LVOLS,LCOPY,POS,ROTM)
      CALL UCOPY(POS    ,Q(QNEDE_XMIN_L()),6)
      CALL UCOPY(POS(7) ,Q(QNEDE_XMAD_L()),3)
      CALL UCOPY(POS(10),Q(QNEDE_COS_L()) ,2)
      CALL UCOPY(ROTM,Q(QNEDE_ROT_L(1)),9) 

c     fill the remaining data 
      IQ(IQNEDE_CMP_L()) = INESL_CMP(CURRSL)
      IQ(IQNEDE_SHP_L()) =  Q(JVOS+2)
      NUMED = Q(JVOS+4)
      NMAT = Q(LQ(JTMED-NUMED)+6)
      CALL UHTOC(Q(LQ(JMATE-NMAT)+1),4,MATNAM,20)
      NMM = MATNUM(MATNAM(1:LENOCC(MATNAM)))
      CALL MMBREL(JGMND,NMM,NN)
c      IQ(JNEDE+2 + (NN-1)*NCNEDE()+JNEDE_GMAT) 
c     +                        = MATNUM(MATNAM(1:LENOCC(MATNAM)))
      CALL GRADLN(IVOS,XMS)
      XMS = (POS(6)-POS(5))/XMS
      Q(QNEDE_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2
      IQ(HQNEDE_GVOL_L()) = IQ(JVOLUM+IVOS)

      IQ(IQNEDE_LAY_L()) = ILAY
      IQ(IQNEDE_SEC_L()) = ISEC

      RETURN
 101  FORMAT(1X,'DET ',I4,6(1X,F7.3),1X,F6.3,F2.0,I4)
 102  FORMAT(   'DET' ,I4,6(1X,F8.2),1X,F6.2,F2.0,I4)
      END




