
      SUBROUTINE HGCONS

************************************************************************
*
* written by Siegmund Nowak 97/03/20
*
* This routine defines default values for HBGEAN constants
*
* called from HGINIT
************************************************************************

      IMPLICIT NONE

      REAL ANGSPR
      COMMON /ZGSPRL/ ANGSPR
      INTEGER TURBFL
      COMMON /TURB/ TURBFL
#include "gean/gcphys.fi"
#include "gean/gctmed.fi"
#include "gean/ZGBEAM.fi"
#include "gean/ZGDETV.fi"
#include "gean/ZGESL.fi"

c     the default value will be 
      ILOSS = 1

c     maximal rotation angle for spiraling particles
      ANGSPR = 94.25                     ! 30*pi

c     switch for fast muon tracing
      TURBFL = 0 

c     Cerenkov photon generation will be switched on by default
      ITCKOV = 1

c     time spread of primary vertex will be switched off by default
      TIME_SWIT = 0

c     default values for DETV (long/short/user version)
      DETV = ' '
      DETV(LGESL_SIL:LGESL_SIL)   = 'S'
      DETV(LGESL_SML:LGESL_SML)   = 'S'
      DETV(LGESL_WCH:LGESL_WCH)   = 'L'
      DETV(LGESL_MSG:LGESL_MSG)   = 'S'
      DETV(LGESL_PTC:LGESL_PTC)   = 'L'
      DETV(LGESL_RIC:LGESL_RIC)   = 'S'
      DETV(LGESL_ECA:LGESL_ECA)   = 'L'
      DETV(LGESL_TAR:LGESL_TAR)   = 'L'
c      DETV(LGESL_FLD:LGESL_FLD)   = 'L'
      DETV(LGESL_HOD1:LGESL_HOD1) = 'L'
      DETV(LGESL_HOD2:LGESL_HOD2) = 'L'
      DETV(LGESL_HOD3:LGESL_HOD3) = 'L'
      DETV(LGESL_TRSL:LGESL_TRSL) = 'S'      
      DETV(LGESL_RPOT:LGESL_RPOT) = 'L'
      DETV(LGESL_MAG:LGESL_MAG)   = 'L'
      DETV(LGESL_PPIP:LGESL_PPIP) = 'S'
      DETV(LGESL_EPIP:LGESL_EPIP) = 'L'
      DETV(LGESL_MUON:LGESL_MUON) = 'L'
       
      RETURN
      END




