


>Name HGKUIP

>Menu HBGEAN
>Guidance
HBGEAN = HERA-B GEANT specific commandOss.
**********************************************************************
**********************************************************************
>Menu /HBGEAN/GENERAL
>Guidance
Possibilities of HBGEAN:

 HBGEAN consists of a set of subroutines and data files, which:
 - create geometry structures for use in GEANT and ARTE; alternatively
 these geometry structures can be read in if they were prepared in a
 previous run. The creation of geometry structures will be done from the
 HERA-B-database, as long as no data base exists from an ASCII file
 hbgeo.dat (other names are possible -  see menu geodat)

 - trace tracks through the detector and show up (write out)
 their interactions with detector components.
 - draw the detector or parts of it and also tracks.
 - make CAD files of the detector implementation.

 The HERA-B GEANT simulation software is organized with the Source Code
 Management System CMZ. The name of the cmz-file is hbgean.cmz. To get
 an executable program the CERN-library of GEANT (version 3.21)
 is required.

 The new versions (version 2.00/00 and bigger) of HBGEAN are
 implemented in the ARTE program. Therefore the main program must
 have a CALL ATMAIN. HBGEAN  will be activated by a steering command
 (card) GEAN in the ARTE command file.

 HBGEAN expects event or track data from an event generator
 or from files, they must be given in ARTE format (ZEBRA-banks). If
 reading from files events of different channels can be merged to one
 superevent before tracing through the detector. During the tracing
 histograms can be made and analysed directly or GEANT-hits (MIMPS)
 can be written out for further analysis in subsequent programs.

 Most of the general GEANT control cards are valid. For details see menu
 geankumac
.
**********************************************************************
***********************************************************************
>Menu /HBGEAN/STRUCTURE
>Guidance
 Structure of hbgean.cmz
 The hbgean.cmz is divided into the following subdirectories:
 GCDES321: all sequences/commons of CERN GEANT.
 hgcdes  : all sequences/commons for HBGEAN.
 hg      : interface routines to ARTE.
 geom    : subroutines for the detector geometry.
 media   : subroutines for the detector materials.
 kine    : subroutines for particle definition, kinematics, tracking.
 cr      : subroutines for creating ARTE banks.
 gobj    : subroutines which exist also in other libraries.
 pict    : some drawing routines.
 kuip    : all HBGEAN-KUIP routines for interactive work.
 data    : the hbgeo.dat file for the given hbgean-version and an example
           for geant-data cards inside the ARTE kumac file.
.
 To be shure that hbgean routines whose name exist also in other libraries
 will be taken, they should be always loaded as object files.

 The interplay between ARTE and HBGEAN will be realized by the following
 subroutines:
 ATINIT calls:
    HGVERS (gives out the HBGEAN version number).
    GINTRI (sets the keys for HBGEAN commands in the ARTE kumac file).
    GINIT  (sets the default values for GEANT variables).
 ATEXEC calls:
    KUEXEC which calls KAGEAN to activate HBGEAN by setting the variable
           GEANINIT =1 and calling HGINIT;
    HGINIT (initialization of GEANT Zebra banks, particle code, setting
            up the geometry  and the physical processes for tracing).
 ATEVNT calls:
    HGEVNT (event processing (called if GEANINIT=1) and call for HGKINE
            for setting up the event kinematic)..

 From here it follows that GEANT input card in the ARTE kumac file
 which control the physical processes or the geometry implementation
 must be given in before the activation of GEANT (command GEAN) - see
 the example file.

 Inside the event processing there is a GEANT specific routine USSTEP where
 the user can react in every tracing step (fill histograms etc);
**************************************************************************
**********************************************************************
>Menu /HBGEAN/hbgeodat
>Guidance
Explanation of hbgeo.dat and COMMONS ZGxxxx.

>Help_item ZGMOTH
>Guidance
Short description of MOTHER volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 XMOT(1..3) [XMOT,YMOT,2*ZMOT] Dimensions of the mother volumen (pyramid)
                               xmot, ymot are related to the small side
 ZZCO       [ZZERO]            position of the coordinate origin in mother
 THAN(1)    [THXMX1]           angular limit for chambers and rich in x
                               this is the opening angle in x of pyramid
 THAN(2)    [THXMX2]           angular limit for calo and muon system in x
 THAN(3)    [THYMX]            angular limit in y (opening angle in y)
 THAN(4)    [THMIN]            minimum cut for theta
 SXBM(10)   [SIGXBM]           HORIZONTAL BEAM WIDTH
 SYBM(11)   [SIGYBM]           VERTICAL BEAM WIDTH.


>Help_item ZGRPOT
>Guidance
Short description of RPOT volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 ZAPOT                 start position of roman pot
 DLPOT(2)              length in z of cylindrical and conical part
 RIPOT(2)              Inner wall radius of cylindrical and conical part
 WDPOT                 wall thickness of the roman pot
 RRPES                 inner radius of the spheric roman pot end plate
 ZAPES                 z-start value of the spheric endplate at beam position
 DLPES                 thickness of the endplate
 RIPES                 inner radius of the spheric endplate
 ROPES                 outer radius of the sheric endplate
 DLPET                 length in z of outer ring connecting endplate/rpot
 RIPET                 inner radius of outer ring connecting endplate/rpot
 WDPET                 wall thickness of outer ring connecting endplate/rpot
 DLPEC(3)              length in z of additional endplate conii (sockets)
 RISPET(3)             inner radius of additional endplate conii at lower z
 ROSPET(3)             outer radius of additional endplate conii at lower z
 RIEPET(3)             inner radius of additional endplate conii at high z
 ROEPET(3)             outer radius of additional endplate conii at high z
>Help_item ZGTARG
>Guidance
Short description of TARGET data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 NMXTAR                maximal allowed number of target wires
 NTARG                 real number of target wires
 XLTAR(I)              x-distance of a ribbon center from the z-axis
 YLTAR(I)              y-distance of a ribbon center from the z-axis
 ZLTAR(I)              z-position of ribbon center
 DXTAR(I)              length of the ribbon in x
 DYTAR(I)              length of the ribbon in y
 DZTAR(I)              length of the ribbon in z
 MATARG(I)             material name of Target (AL  ,BE  ,C   ,CU  )
 XBMTAR(I)             x-center of the GAUSS curve for target vertex distr
 YBMTAR(I)             y-center of the GAUSS curve for target vertex distr
 SXBTAR(I)             x-width of the GAUSS curve for target vertex distr
 SYBTAR(I)             y-width of the GAUSS curve for target vertex distr
>Help_item ZGSILD
>Guidance
Short description of RPOT volumen , TARGET and SILICON data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 NSLSI                 max number of silicon superlayers
 ZASI(I)               z-position of the silicon superlayer I
 DLSI(I)               length of silicon superlayer I
 OVSI(I)               overlap in x/y of adjacent counters
 NPLSI(I)   [NPSI]     number of layers in one superlayer
 ITPSI(I)              typ of Si superlayer I (1,2 = different parities with
                       respect to y axis; 3 outside  roman pot)
 DXBGSI/DYBGSI/DZBGSI  dimensions of the bags
 DXSISI/DYSISI/DZSISI  dimensions of the silicon chips
 DXA1SI/DYA1SI/DZA1SI  dimensions of the adaptors - front side
 DXA2SI/DYA2SI/DZA2SI  dimensions of the adaptors - back side
 DXHYSI/DYHYSI/DZHYSI  dimensions of the hybrids
 DXCiSI/DYCiSI/DZCiSI  dimensions of the carriers,i=1 inner, i=2 outer

 PXBGSI/PYBGSI/PZBGSI  positions of the bags (with respect to the carrier/SC)
 PXSISI/PYSISI/PZSISI  positions of the silicon chips    (dto)
 PXA1SI/PYA1SI/PZA1SI  positions of the adaptors         (dto) front side
 PXA2SI/PYA2SI/PZA2SI  positions of the adaptors         (dto) back side
 PXH1SI/PYH1SI/PZH1SI  positions of the hybrids          (dto) front side
 PXH2SI/PYH2SI/PZH2SI  positions of the hybrids          (dto) back side
 PXC1SI/PYC1SI/PZC1SI  positions of the carriers near the beam (rel to SC)
 PXC2SI/PYC2SI/PZC2SI  positions of the carriers far of the beam (rel to SC)
 PZLYSI                distance between SL center and sector center (SC)

 XRSI(I)               minimal distance between silicon and z axis
 XOSI(I)               max x/y of the beryllium plate
 XBAG(I)               minimal distance between bag and z axis
 IRSI(I)    [IROSI(I)] number of the rotation matrix for this chip
 DZMXSI                thickness of mixture in z

 RANDSI                distance between chip edge and first strip
 ANSI       [ANGSI]    angle of strips
 EFSI       [EFFSI]    effectivity of silicon counters
 ACSI       [SIGSI]    resolution
 PISI       [PITSI]    pitch of silicon counters
 DMSI                  double hit resolution

>Help_item ZGBPIP
>Guidance
Short description of proton and electron beam pipes
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 NPIP       [NPIP]     number of segments of the beam pipe to be read in
 ZPIP       [ZAPIP]    start position of the beampipe(1=AL,2=FE)
 DPIP(i)    [DLPIP(i)] length of tube segment i
 RPIP(i)    [ROPIP(i)] outer radius of the segment i
 WPIP(i)    [WDPIP(i)] thickness of the tube segment
 MPIP(i)    [MAPIP(i)] material of the pipe segment (1=Al,2=Fe)

 NFLN       [NFLAN]    number of flanges to be read in
 ZFLN(i)    [ZMFLAN]   z-position of the centre of the flange i
 DFLN(i)    [DLFLAN]   length of the flange i
 RFLN(i)    [RIFLAN]   inner radius of the flange i
 WFLN(i)    [WDFLAN]   thickness of the flange
 MFLN(i)    [MAFLAN(i)] material of the flange (1=Al,2=Fe)

 ZCCOIL(1..8)          z start positions of different e pipe section
 EBIM(1,2)  [XETUB/YETUB]    position of the electron beam tube
 EBDN(1..2) [RNTUB/WDNTUB] radius and thickness of the e-beam-tube
                                                    outside magnet
 EBDM(1..7) [RVATUB,ROUTUB,RMETUB,RINTUB]  transversal dimensions
                             of the e-beam tube inside magnet
 DIFTCH     [DIFTCH]   min distance tube/chamber in y without ch. division


>Help_item ZGOTR
>Guidance
Short description of WIRE CHAMBER volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 NSLWT                  MAX NUMBER OF WT SUPERLAYERS
 NSCWT                  Max number of sectors
 DEWT(I)                NAME OF CHAMBER SUPERLAYER I
 ZAWT(I),DLWT(I)        CENTRAL POSITION AND THICKNESS IN Z FOR SUPERLAYERS
 NPWT(I)    [NPLWT(I)]  NUMBER OF PLANES in SUPERLAYER I
 NSWT(I)    [NSECWT(I)] NUMBER OF sectors in SUPERLAYER I
 NWWT(ISL,ISEC)[NWIRWT] number of wires in sector ISEC of superlayer ISL
                        if le 0 no sector ISEC exists
 IRWT(I)    [IROWT(I)]  rotation sign of the planes ie. for NPLWT=6
                        102102= +0-0+0- for single layers, add 3 for double
 DIWT(1.14) [DLWAWT,DLTOWT(4),DLS1WT,DLS2WT,DLCLWT(4),DLWEWT,DLOVWT,XYOVWT]
                        thickness of support wall, total width of one
                        layer(4 types), straw material (2 components are
                        possible), cell thickness (4 types), dividing foils
                        between chambers, overlap in z and x/y direction
 ANWT       [ANGWT]     angle of the stereo chambers (common for all SLs)
 EFWT       [EFFWT]     efficency for honeycomb chambers
 ACWT(1..4) [SIGWT(4)]  resolution for four chamber types
 PIWT(1..4) [PITWT(4)]  wire distance for honeycomb chambers
 DMWT(1..4) [DIMXWT(4)] maximal drift distance in honeycomb chambers
 XOWT(ISL,ISEC)         outer x boundary for superlayer ISL
 YOWT(ISL,ISEC)         outer y boundary for superlayer ISL
 XLWT(ISL,ISEC)         left side boundary for sectors (see sketch )
 XRWT(ISL,ISEC)         right side boundary for sectors (see sketch )
 YLWT(ISL,ISEC)         low side boundary for sectors (see sketch )
 YRWT(ISL,ISEC)         up side boundary for sectors (see sketch )
                        first index superlayer, second index sector
 Four Chamber types : 1  Aachen type single layers 10 mm cell diameter
                      2    "     "     "      "     5 mm  "      "
                      3    "     "   double   ""    10 mm  "      "
                      4    "     "     "      "     5 mm  "      "
 Aachen type means:
                                                      _   _   _   _    .
                                                     / \_/ \_/ \_/ \_  .
              _   _   _                              \_/ \_/ \_/ \_/   .
   single   _/ \_/ \_/ \_/             double       _/ \_/ \_/ \_/ \_  .
             \_/ \_/ \_/ \                           \_/ \_/ \_/ \_/   .
            _/ \_/ \_/ \_/                          _/ \_/ \_/ \_/ \_  .
.
 WTDT(1..8)             Name of the four chamber types outside and inside
                        magnetic field (CHUDET in GSDET)
.

    ------------------------------------------------------------ +YO
    |           |      |                   |       |           |
    |           |      |(15)    1      (13)|       |           |
    |           |      |                   |       |           |
    |           |   9  |-------------------|   7   |           | +YR
    |           |      |    |         |    |       |           |
    |           |      |  5 |         | 3  |       |           |
    |    12     |------+----|         |----+-------|     11    |   0
    |           |      |    |         |    |       |           |
    |           |      |  6 |         | 4  |       |           |
    |           |      |-------------------|       |           | -YR
    |           |  10  |                   |   8   |           |
    |           |      |(16)    2      (14)|       |           |
    |           |      |                   |       |           |
    ------------------------------------------------------------ -YO

   -XO         -XM    -XI  -XR   0   +XR  +XI     +XM         +XO

    (13) - (16) are the dummy (insensitive) prolongations of 3 - 6
.

>Help_item ZGITR
>Guidance
Short description of ITR (MSGS) volumen data cards.
.
First name =hbgeo.dat name, inside [] =names in Common; no[] =identical name
.
 NSLMT                  MAX NUMBER OF MT SUPERLAYERS
 DEMT(I)                NAMES OF STRIP SUPERLAYERS
 ZAMT(I),DLMT(I)        START POSITION AND THICKNESS IN Z FOR SUPERLAYERS
 NPMT(I)    [NPLMT(I)]  NUMBER OF PLANES OF A SUPERLAYER
 IRMT(I)    [IROMT(I)]  rotation sign of the planes ie for NPLWT=6
                        010201 = 0+0-0+
 DIMT(1..10)[DWALMT,DCELMT,DGL1MT,DGL2MT,DGASMT,DAUXMT,DWEXMT,RANDMT,
            DLOVMT,XYOVMT]
                        thickness of front wall, total thickness of one
                        layer, twice strip chamber glas, gas, gold, end
                        wall of chambers, distance between edge and first
                        wire and distance for overlaps
 DEMT(1..3) [DECHMT,BRELMT,YEOVMT] thickness, width in y and overlap with
                        MSGC corpus in y
 ANMT       [ANG_MT]    angle (common) of the stereo chambers
 EFMT       [EFFMT]     efficency for strip chambers
 ACMT       [SIGMT]     resolution for outer, medium and inner ring
 PIMT       [PITMT]     wire distance for strip chambers
 DMMT       [DIMXMT]    double hit resolution in strip chambers
 XOMT,XIMT(I)           outer and inner dimensions for superlayer I
 XMMT YMMT              dimension of the honeycomb basic structure
 XLMT,XRMT,YLMT,YRMT(ISL,ISEC) left and right, lower and upper boundaries
                        of sector ISEC and superlayer ISL (see sketch)
.

    --------------------------------------------------------
    |                 |        |        |                  |
    |                 |    8   |   1    |                  |
    |                 |        |        |                  |
    |        7        |-----------------|         2        |
    |                 |                 |                  |
    |                 |                 |                  |
    |-----------------|                 |------------------|   0
    |                 |                 |                  |
    |                 |                 |                  |
    |                 |-----------------|                  |
    |        5        |        |        |         4        |
    |                 |    6   |   3    |                  |
    |                 |        |        |                  |
    --------------------------------------------------------

.
>Help_item ZGPTCA
>Guidance
Short description of B->pi+pi- Trigger Pad Chambers volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 DEPT          [DEPT]      Names of Pad Chamber Detector Layers
 ZPTC(1..NLPT) [ZAPTCA]    Start Position of the  Pad Chamber Layers
 NSPT          [NSPTCA]    Number of Section in the (i)th Layer
 ITPT(1..NLPT) [ITPTCA]    Shift-flag of the Superlayer
 XSPT(1..NSPT) [XSPTCA]    X position   for (i)th section in the 1st Layer
 XAPT(1..NSPT) [XAPTCA]    X SIZE   for (i)th section in the 1st Layer
 YSPT(1..NSPT) [YSPTCA]    Y position   for (i)th section in the 1st Layer
 YAPT(1..NSPT) [YAPTCA]    Y SIZE   for (i)th section in the 1st Layer
 ZSPT(1..NSPT) [ZSPTCA]    Z-shift with respect to Z=ZPTC for (i)th Section
 DSPT(1..NSPT) [DSPTCA]    Thickness   for (i)th section in the 1st Layer
 IMPT(1..NSPT) [IMPTCA]    Media flag for (i) section
 NXPT(1..NSPT) [NXPTCA]    Number of X subdivision in (i)th section
 NYPT(1..NSPT) [NYPTCA]    Number of Y subdivision in (i)th section
 TPPT(1...5  ) [TPTG1N..]  thickness of different materials
 ADPT(1..100)  [ADPTCA]    Some additional parameters
 IDPT(1..100)  [IDPTCA]    Some additional parameters
>Help_item ZGRICH
>Guidance
Short description of RICH volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 ZARI(1..7) [ZARI,ZAGARI,ZAFWRI,ZAEWRI,ZAFMRI,ZAEMRI,ZASPRI,ZAPDRI]
                     START POSITIONS of the RICH, the gas, the front and
                     end wall, the front and end mirror, the end mirror
                     support, the photon detector;
 DLRI(1..7) [DLRI,DLGARI,DLFWRI,DLEWRI,DLFMRI,DLEMRI,DLSPRI,DLPDRI]
                     Thickness for elements as above;
 XORI(1..7) [XORI,XOFWRI,XOEWRI,XOFMRI,XOEMRI,XOSPRI,XOPDRI] Outer x-dimen-
                     sions of the elements (except for gas)
 YORI(1..9) [YORI,YOFWRI,YOEWRI,YOFMRI(2),YOEMRI,YOSPRI,YOPDRI(2)] y-dimen-
                     sions of the elements (except for gas), in general
                     outer boundaries, array only for YOFMRI(2) / YOPDRI(2)
                     as the inner boundaries;


>Help_item ZGTRDE
>Guidance
Short description of TRD (tracker and no tracker) volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
            [NSLTS]  maximal number of TRD BLOCKS
 ZATS,DLTS           START POSITION AND LENGTH OF forward TRD
 RATS       [DLRATS] THICKNESS OF RADIATOR
 STTS       [DLSTTS] THICKNESS OF STRAW MATERIAL
 GATS       [DLGATS] THICKNESS OF STRAW GAS
 WITS       [DLWITS] THICKNESS OF WIRES
 WATS       [DLWATS] THICKNESS OF WALL SUPPORT
 NPTS(i) [NPLTS] NUMBER OF RADIATOR PLANES IN forward TRD superlayer i
 XLTS(i),XRTS(i),YLTS(i),YRTS(i) - foreseen for x/y structure
 XITS,YITS           x/y dimensions of beam hole (half width)
 ALTS,BETS  [ALFATS,BETATS] angles of geometrical configuration (x and y)
.


>Help_item ZGCALO
>Guidance
Short description of CALO volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 CADE                     Name of calorimeter superlayer
 ZCAL(1..10)   [ZACAL(I)]  START POSITION OF
                     1     entire calorimeter
                     2     outer      dto
                     3     medium     dto
                     4     inner      dto
                     5     first alu chip in outer calorimeter
                     6     second "    "   "  "       dto
                     7     first  "    "   " medium   "
                     8     second "    "   "   "      dto
                     9     first  "    "   "   "      dto
                    10     second "    "   "   "      dto
       ZACAL(1) with respect to target, all others with respect to ZACAL(1)
 DCAL(1,10)    [DLCAL(I)]  LENGTH IN Z for the elements above
 CABA_SIZE                Module size in x and y
 NCALX/NCALY              number of modules in x/y direction
 NCALD                    number of subdivision of modules in o m i calor
 CAST(1..50)  [CALSTR]    Calorimeter structure

>Help_item ZGMUON
>Guidance
Short description of MUON system volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 DEMU(1..4)              names of the muon superlayers

 NMPT   NMUPTB           number of volums in proton beam pipe
 RMPT   RMUPTB(75)       5*NMPTMX parameters of volums in proton beam pipe

 ZMUF   ZAMUF(5)         Z start position of muon superlayer shields
 NMUF   NLMUF(5)         number of shield layers inside superlayer
 DZMF   DZMUF(20)        Z-length of shield layers
 NAMF   NAMUF(20)        number of absorber blocks in the shield layer
 NMMF   NMMUF(240)       absorber block material (1=iron,2=beton-iron mixture)
 XMUF   XAMUF(240)       X-position of absorber block low left corner
 DXMF   DXMUF(240)       X-length of absorber block
 YMUF   YAMUF(240)       Y-position of absorber block low left corner
 DYMF   DYMUF(240)       Y-length of absorber block

 ANMU   ANG_MU           angle of L+ and L- chambers
 ZMUO   ZMUPOS(1..4)     start z-position the superlayer
 DZMU   DZMUSL(1..4)     dz for this superlayer
 XMUI   X_MU_IN          x-dimension of the inner chambers
 YMUI   Y_MU_IN          y-dimension of the inner chambers
 XMOU   X_MU_OU          x-dimension of the outer chambers
 YMOU   Y_MU_OU          y-dimension of the outer chambers

 MUDI   DMU_ECUP         end cup width,
        DMU_CHIP         electronics chip width,
        DMU_SUPP         space for support structure ( in z ),
        DMU_DIST         space ( in z ) between 2-nd
                         and 3-rd ( with large overlap ) layers,
        DMU_CC           width of inner chamber

 PIMU   PIMU             pitch in muon chambers
C*  EFMU   EFMU             effectivity of muon chambers
 EFMU   EFMU(3)          efficiency of muon chambers(1-wire,2-pad,3-pixel)
 ACMU   ACMU             accuracy of muon chambers

 MUCC   MUCC(1..4)       names of inner chambers
 MU00   MU00(1..4)       names of L0 chambers
 MUPL   MUPL(1..4)       names of L+ chambers
 MUMI   MUMI(1..4)       names of L- chambers

 NMU0   NMU0(1..8)       the number of 0 degree chambers in a row
 NMUP   NMUP(1..4)       the number of + degree chambers in a row
 NMUM   NMUM(1..4)       the number of - degree chambers in a row

 XMU0   XMU0(1..8)       x coord. of right low corner of a chamber (0 deg)
 XMUP   XMUP(1..4)       + deg  ! for the first chamber in row !!!!!!
 XMUM   XMUM(1..4)       - deg  !

 YMU0   YMU0(1..8)       y coord. of right low corner of a chamber (0 deg)
 YMUP   YMUP(1..4)       + deg  ! for the first chamber in row !!!!!
 YMUM   YMUM(1..4)       - deg  !

 ZMU0   ZMU0(1..8)       z coord. of start of chamber (0 deg)
 ZMUP   ZMUP(1..4)       + deg  ! for the first chamber in row !!!!!
 ZMUM   ZMUM(1..4)       - deg  !

 DXMU   DXMUO(1..4)      width of chambers in different superlayers

 DZU0   DZMU0(1..8)      width of chamber in z direction (0 deg)
 DZUP   DZMUP(1..4)       + deg  ! for the first chamber in row !!!!!
 DZUM   DZMUM(1..4)       - deg  !

 FY01   DDYU0(1..70)  diff. in y for right low corn. Y_i - Y_(i-1)  MU1
 FYP1   DDYUP(1..70)       + deg
 FYM1   DDYUM(1..70)       - deg

 FX01   DDXU0(1..70)  diff. in x for right low corn. X_i - X_(i-1)  MU1
 FXP1   DDXUP(1..70)       + deg
 FXM1   DDXUM(1..70)       - deg

 DY01   DYMU0(1..70)    y size of a chamber                         MU1
 DYP1   DYMUP(1..70)       + deg
 DYM1   DYMUM(1..70)       - deg

 FY02   DDYU0(71..140)  diff. in y for right low corn. Y_i - Y_(i-1)  MU2
 FYP2   DDYUP(71..140)       + deg
 FYM2   DDYUM(71..140)       - deg

 FX02   DDXU0(71..140)  diff. in y for right low corn. X_i - X_(i-1)  MU2
 FXP2   DDXUP(71..140)       + deg
 FXM2   DDXUM(71..140)       - deg

 DY02   DYMU0(71..140)    y size of a chamber                         MU2
 DYP2   DYMUP(71..140)       + deg
 DYM2   DYMUM(71..140)       - deg

 FY03   DDYU0(141..210)  diff. in y for right low corn. Y_i - Y_(i-1)  MU3
 FX03   DDXU0(141..210)  diff. in x for right low corn. X_i - X_(i-1)  MU3
 DY03   DYMU0(141..210)    y size of a chamber                         MU3

 FY04   DDYU0(211..280)  diff. in y for right low corn. Y_i - Y_(i-1)  MU4
 FX04   DDXU0(211..280)  diff. in x for right low corn. X_i - X_(i-1)  MU4
 DY04   DYMU0(211..280)    y size of a chamber                         MU4

 OVMU   OVMUO            overlap between 2 chambers
 FWMU   DXFWMU       distance between the first wire and edge of chamber
 NWMU   NUMWMU       the number of wires in one layer of chamber

 XLX1   XLMUX(1..4)  x left for i-th section of pixel chamber       MX1
 XRX1   XRMUX(1..4)  x right for i-th section of pixel chamber      MX1
 YLX1   YLMUX(1..4)  y low for i-th section of pixel chamber        MX1
 YUX1   YUMUX(1..4)  y upper for i-th section of pixel chamber      MX1
 ZPX1   ZMUX(1..4)   z start of i-th section of pixel chamber       MX1
 DZX1   DZMUX(1..4)  width in z for i-th section of pixel chamber   MX1

 XLX2   XLMUX(5..8)  x left for i-th section of pixel chamber       MX2
 XRX2   XRMUX(5..8)  x right for i-th section of pixel chamber      MX2
 YLX2   YLMUX(5..8)  y low for i-th section of pixel chamber        MX2
 YUX2   YUMUX(5..8)  y upper for i-th section of pixel chamber      MX2
 ZPX2   ZMUX(5..8)   z start of i-th section of pixel chamber       MX2
 DZX2   DZMUX(5..8)  width in z for i-th section of pixel chamber   MX2

 XLX3   XLMUX(9..12)  x left for i-th section of pixel chamber       MX3
 XRX3   XRMUX(9..12)  x right for i-th section of pixel chamber      MX3
 YLX3   YLMUX(9..12)  y low for i-th section of pixel chamber        MX3
 YUX3   YUMUX(9..12)  y upper for i-th section of pixel chamber      MX3
 ZPX3   ZMUX(9..12)   z start of i-th section of pixel chamber       MX3
 DZX3   DZMUX(9..12)  width in z for i-th section of pixel chamber   MX3

 XLX4   XLMUX(13..16)  x left for i-th section of pixel chamber       MX4
 XRX4   XRMUX(13..16)  x right for i-th section of pixel chamber      MX4
 YLX4   YLMUX(13..16)  y low for i-th section of pixel chamber        MX4
 YUX4   YUMUX(13..16)  y upper for i-th section of pixel chamber      MX4
 ZPX4   ZMUX(13..16)   z start of i-th section of pixel chamber       MX4
 DZX4   DZMUX(13..16)  width in z for i-th section of pixel chamber   MX4

 OVMX   OVMUX(1..2)  overlap in x and y direction for muon pixel chamber MX
 RMUX   RMUX         radius of the hole in a section                     MX
 RSMX   RSENMX(1..4) radius of the hole in a sensitive area of section   MX

 MUPX   DXMUPD(1..12) x,z structure of pads in MU3 and MU4
 MUPY   DYMUPD(1..12) y structure of pads in MU3 and MU4

 NXPX   NXMUPX(1..4) number of connected cells in x direction
 NXPY   NYMUPX(1..4) number of connected cells in y direction

 NTPX   NXMUTO(1..4) total number of cells in a row
 NTPY   NYMUTO(1..4) total number of cells in a column

 DXPX   DXMUPX(1..4) x size of pixel
 DYPX   DYMUPX(1..4) y size of pixel


**********************************************************************
************************************************************************
>MENU /HBGEAN/geankumac
>Guidance
Example of a arte.kumac file used for HBGEAN

 For HBGEAN most of the general GEANT interactive commands (see GEANT
 manual section XINT) are valid. Note that due to ambiguities some of
 GEANT command should be preceeded by GEANT/CONTROL/, GEANT/GEOMETRY/ or
 GEANT/PHYS. This is valid for instance for:
 GEANT/CONTROL/DEBUG
 GEANT/CONTROL/PRINT
 GEANT/PHYS/CUTS

 The following command must be replaced:
 TRIG by RUN
 NEXT by CLEAR

 If commands are not explicitely given the default values of GEANT (see
 GEANT manual BASE040) will be taken.
 .
 All drawing commands will work only, if grafic initialization is made
 before by the command PRISM

 Below an example of a arte.kumac file for usage of GEANT is given.

 *  seed 999 999
 *  LUND bb in 4. -b.
 *  exec /home/hydra/albrecht/anew/psik0
 *  IOFILE   GEOMIN hb1.geo
 IOFILE   READ geo.dat
 IOFILE   GEOMOUT hbm.geo  0  O
 IOFILE   EVIN1 /net/sgi/herab/data/jpsik0sal.dst
 IOFILE   EVIN2 /net/sgi/herab/data/inelal.dst
 IOFILE   PRISM hist.ps
 IOFILE   RAW bb.dst 0 O
 IOMIX    -1.  4.
 HBOOK gean.his -O
 GEANT/CONTROL/DEBUG  ON
 GEANT/CONTROL/SWIT 1 0
 GEANT/CONTROL/KINE 2
 GEANT/PHYS/CUTS .001 .001 .01 .01 .01 -1. -1. -1. -1. .01
 DETV TARL SIDL WTDL MTDL PTLL RICS CALL MUDL TRDS FLDS
 GEAN
 MIMP ON
 MMWRIT GEOMOUT GEHD
 RUN 3
 ENDKUMAC

 Most of the cards are explained in ARTE.
 Here the command MIMP tells the program whether MIMP should be written out
 (ON) or not (OF).  GEANT/CONTROL/SWIT 1 1 sets the Variable ISWIT(1) to 1,
 activating the event drawing ((if grafics was initiated by PRISM) .
 Otherwise the event drawing will be supressed (default). ISWIT(1) is the
 only switch used by HBGEAN, ISWIT(2-10) can be used by the user. If a
 command  IOFILE   GEOMOUT exists MMWRIT GEOMOUT GEHD  writes out the
 ARTE geometry banks. DETV and KINE will explained below:

**********************************************************************
**************************************************************************
>MENU /HBGEAN/COMMANDS
>Guidance 
Specific GEAN commands for HERA-B
***************************
>Command SETENV
>Guidance
Performs SETENV(name,value).
If envoked without parameters, shows all current and default values.
>Action kasete
>Parameter
+
name 'Variable name' C D=' '
value 'Variable value' C D=' '
*******************************************************************
>Command PHSP
>Guidance
Generates phase space particles
>Action KAPHSP
>Parameter
CPART 'Arte name of the wanted particle' C D='mu-'
PMIN  'minimal momentum' R D=10.
PMAX  'maximal momentum' r D=10.
THMIN 'minimal polar angle' R D=0.010
THMAX 'maximal polar angle' R D=0.250
PHIMIN 'minimal azimut angle' R D=0.
PHIMAX 'maximal azimut angle' R D=6.283185307




*************************************************************************
>Menu /HBGEAN/SHOW
>Guidance
Shows detector characteristics.
******************************
>Command PICT
>Guidance
Draws a perspective view of the  HERA-B-detector or of parts of it.
Possible parameters: DET SI OTR ITR PT CAL MUON BEAM
>Action PIMAIN
>Parameter
DET  ' Detector part (DET SI OTR ITR PT TRD CAL MUON BEAM) ' C D='DET'
PERS 'Perspective (p) or cut (cx or cy) view' C D='P'
NAM  'Superlayer name' C
LAY  'Layer number' I
SEC  'Sector number, 0 means all sectors' I D=0
******************************
>Command PICOTR
>Guidance
Draws a perspective view of the WT chambers.
>Action PICOTR
>Parameter
PERS 'Perspective (p) or cut (c) view' C D='C'
NAM  'Superlayer name' C
LAY  'Layer number' I
SEC  'Sector number, 0 means all sectors' I D=0
*******************************
>Command PICITR
>Guidance
Draws a perspective view of the MT chambers.
>Action PICITR
>Parameter
PERS 'Perspective (p) or cut (c) view' C D='C'
NAM  'Superlayer name' C
LAY  'Layer number' I
SEC  'Sector number, 0 means all sectors' I D=0
******************************
>Command PICSIL
>Guidance
Draws a perspective view of one Si-superlayer.
>Action PICSIL
******************************
>Command PICCAL
>Guidance
Draws a perspective view of the calorimeter.
>Action PICCAL
******************************
>Command PICMUO
>Guidance
Draws a perspective view of the muon system.
>Action PICMUO
*******************************
>Command PITEXT
>Guidance
Draws text.
If invoked with zero coordinates, asks for graphical input.
>Action PITEXT
>Parameter
x      'x' R D=0.
y      'y' R D=0.
string 'String to draw' C D=' '
+
color     'color (0 means no change)' R D=0.
height    'height (0 means 0.03 of viewport)' R D=0
font      '10*font+precision (see HIGZ manual, p.39)' I D=-130
alignment 'alignment: 0=10=left, 20=cent, 30=right, 0=base, 1=2=top, 3=mid' I D=0
********************************
>Command PIGSET
>Guidance
Shows and sets parameters of HIGZ graphical package.
Performs CALL IGSET(attribute,value).
See HIGZ manual, p.90 for meaning of attributes.
If invoked without parameters, shows all current and default values.
>Action PIGSET
>Parameter
+
attribute  'Attribute' C D='SHOW'
parameter  'Parameter' R D=0.

**************************
>Command GEANPRIS
>Guidance
Draws a Geant view over existing PRISM picture
Parameter MODE=1 means Geant DCUT command (cut view),
          MODE=2 means Geant DRAW command (3D view).
Supported Prism views are: 0 (xy plane), 1 (xz), 2 (yz), 3 (3D view).

At the end displays the corresponding interactive Geant command.
To use it interactively, perform a graphical reset before it (command GRESET),
and perform FLUSH after it.
>Action PIGEPR
>Parameter
+
VOLNAM 'Volume name to draw' C D='MOTH'
CUTVAL 'Cut value for DCUT' R D=0.
MODE   'Mode number' I D=1 R=1:2
HBGEAN 'Wether to draw HbGeant: 0 - not to draw' I D=1 R=0:1


>Command FLUSH
>Guidance
Flushes HIGZ graphical buffer: finally you can see your GEANT drawing!
>Action PIFLUS
>Parameter

>Command GRESET
>Guidance
Perform graphical reset after PRISM stuff.
(Switch to normalization transformation NT=1
returning to default Geant user coordinates U and V).
See also Prism command SELNT.
>Action PIGRST
>Parameter
******************************
>Menu Particle_colours
>Guidance
The following colours are used for drawing the particle tracks:
  Leptons from J/Psi                            black *
  K0s products from J/Psi                       green *
  Tagging particles                             yellow *
  Hadrons                                       red
  Electrons/photons                             blue
  Muons                                         violet

  charged particles                             solid lines
  neutral particles                             dotted lines (if drawn)

  * if golden particles are selected
*************************************************************************
********************************************************************
>MENU /HBGEAN/GEOM
>Guidance 
Geometry commands
***************************
>Command VERS
>Guidance
Definition of the geometry version for HBGEAN
>Action KAGEOV
>Parameter
GEOMVERS 'GEOMETRY version' R D=0.
***************************
>COMMAND INGS
>GUIDANCE
Extend / modify Table of superlayers.
>ACTION KAGESL
>PARAMETER
NAME 'Superlayer name' C
+
ITYP 'component identifier' I
SHAPE 'shape (BOX ,TRD2,TUBE,CONE,SPHE' C
COLOR   'color for drawing' I
NLAY 'number of layers' I
MFL  'Magnetic flag 0= no magn. field, 1= magnetic field' I
X1 'left corner/inner radius' R 
X2 'right corner/tubeor sphere center' R
Y1 'upper corner/inner radius' R 
Y2 'lower corner/tubeor sphere center' R
Z1 'zstart' R 
Z2 'zend' R
AX 'additional informations for specific shapes' R D=0. 
AY 'additional informations for specific shapes' R D=0.

**************************
>Command DETV
>Guidance
 This card indicates which detector variant should be taken. For most of
 detectors there will be two or three variant of installation available,
 selected by a keyword:
 a short one with only the materials in,
 a long one with detailed stuctures and
 a third one for special users.
 The following keywords are accepted:
 +--------------+-----------------+--------------+--------------------+
 |DETECTOR GROUP| Detailed version| Short version|  Special version   |
 +--------------+-----------------+--------------+--------------------+
 |TARGET        | TARL (wires)    |TARS/pointlike|                    |
 |Si-Vertex-Det | SIDL            | SIDS         |  SIDU              |
 |WT/TC chambers| WTDL            | WTDS         |  WTDU              |
 |MT = MSGC     | MTDL            | MTDS         |  MTDU              |
 |PTL chambers  | PTLL            | PTLS         |  PTDU              |
 |RICH          | RICL            | RICS         |  RICU              |
 |Forward TRD   | TRDL            | TRDS         |  TRDU              |
 |Calorimeter   | CALL            | CALS         |  CALU              |
 |Muon chambers | MUDL            | MUDS         |  MUDU              |
 |Magnetic field| FLDL (from tape)| FLDS (const) |                    |
 |e-beam tube   | EBIM    (in)    | out          |                    |
 +--------------+-----------------+--------------+--------------------+
 For the special versions there are dummy routines in the library.
 Modify them only in your private libraries. If you use them without
 modifikation it will act as if the given detector is switched off.
 The default value for the detectors are TARL, SIDL, WTDL, MTDL, PTLS
 RICS, TRDS, CALL, MUDL, TARL, FLDL
>Action GEOACT
>Parameter
DETV 'short, long or user versions for detectors' C VARARG LOOP
***************************
>Command MAGNET
>Guidance
switches magnet ON or OFF
>Action KAMAGN
>Parameter
MAGNFL 'MAGNET_FLAG' C
***************************
>COMMAND GMAT
>GUIDANCE
Extend / modify Table of detector MATerials.
>ACTION KAGMAT
>PARAMETER
NAME 'material name' C
A_MEAN 'mean atomic number' R D=-999.
Z_MEAN 'mean charge' R D=-999.
DENS   'density' R D=-999.
RADLEN 'radiation length in cm' R D=-999.
ABSLEN 'Absorption length' R D=-999.
DEDX   'ionisation loss per cm' R D=-999. 
MEDFLG 'combined sensitivity/magnet field flag' I D=0
NMIX   'number of materials in a mixture' I D=1
+
X_MIX  'loop over material parameters in a mixture' R D=-999.

********************
>COMMAND WIRE
>Guidance
changes the effectivity of wire materials.
>ACTION kawire%C
>PARAMETER
+
SELPAR 'selection parameter (1all, 1i,1o,1t,1b, 2i, 2o, 2t, 2b or MAT' C D=' '
VALPAR 'effectivity for wires or material name for MAT' C D=' '


********************************************************************
********************************************************************
>MENU /HBGEAN/TRACE
>Guidance 
Tracing  commands
***************************
>COMMAND CAFM
>Guidance
Switches CAlorimeter Fast Montecarlo on or off 
>Action KACAFM
>Parameter
CCAFM 'fast mc for calorimeter on or off' C D='OFF'
***************************
>COMMAND TURB
>Guidance 
switch on fast electron tracing in muon system
>ACTION KATURB
>PARAMETER
TURB   'switch off slow electron tracing in muon system' C D='off'
********************
>COMMAND CKOV
>GUIDANCE
switch off cerenkov photon generation .
>ACTION katrace%C
>PARAMETER
+
CKOV 'switch for Cerenkov generation' C  D='ON'

***************************
>COMMAND TRD
>GUIDANCE
switch off TRD photon generation .
>ACTION katrace%C
>PARAMETER
+
TR48 'switch on/off' C  D='OFF'

***************************
>COMMAND NSPIRL
>Guidance
defines the maximal angle for spiraling particles
>ACTION KASPRL
>PARAMETER
ANGSPR 'maximal angle for spiraling particles' R D=94.25

***************************
>COMMAND GEN_TIME
>GUIDANCE
switches generation time smearing 
>ACTION KAGTIM
>PARAMETER
ITGTIM   'switch on or off of generation time' C D='off' R='on','off'
+
SIGMA    'sigma in ns for bunch spread' R  D=1.
MEAN     'time shift in ns'             R  D=0. 



********************************************************************
********************************************************************
>MENU /HBGEAN/PTL
>Guidance
commands for high pt cchambers
>Command PTLPRINT 
>Guidance 
  Print information about PTL chambers and walls (using only PTGE table)
  Perform scan PTGE table from row FIRST to row LAST and print information
  about all objects which satisfy the selection criteria: 
        NAME , OBJECTS, SUPERLAYER and MOTHER
  Suitable for fast finding of the object. 
  FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
  LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLPRINT 1 50 ALL WALL ALL ALL TPL TABLE  - will scan first 50 rows in 
     PTGE table and print information about all OBJECTS of type=WALL  
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be printed                          ' I D=1 
LAST        'Last  object to be printed                          ' I D=10000 
NAME        'Name of object to be printed                        ' C D='ALL'  
OBJECTS     'Chambers?Walls?All?                                 ' C D='ALL'  
SUPERLAYER  'Print objects which belongs to THIS superlayer only ' C D='ALL' 
MOTHER      'Print objects which belongs to THIS mother only     ' C D='ALL'
DESTINATION 'Printer destination: any combination of T , P and L ' C D='TPL'
FORMAT      'Format: FILE or TABLE                               ' C D='TABLE'

>Command PTLLIST 
>Guidance 
  List  information about PTL chambers and walls (using only PTGE table)
  action is almost the same as for PTLPRINT command. 
  Perform scan PTGE table from row FIRST to row LAST and list information
  about all objects which satisfy the selection criteria: 
            NAMES , OBJECTS , SUPERLAYER and MOTHER
   Suitable for detailed description and for ASCII-file creation.  
   FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
   LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLLIST 1 0 PTC1 ALL ALL ALL TPL FILE  - will scan all PTGE table, 
   and list information about all OBJECTS with name PTC1 
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be listed                           ' I D=1 
LAST        'Last  object to be listed                           ' I D=10000 
NAME        'Name of object to be listed                         ' C D='ALL'  
OBJECTS     'Only Chambers? Only Walls? All?                     ' C D='ALL'  
SUPERLAYER  'List objects which belongs to THIS superlayer only  ' C D='ALL' 
MOTHER      'List objects which belongs to THIS mother only      ' C D='ALL'
DESTINATION 'List destination: any combination of T , P and L    ' C D='TPL'
FORMAT      'Format: FILE-like or TABLE-like                     ' C D='FILE'

>Command PTLDRAW
>Guidance 
 call GDRAW or GDRAWC for PT SUPERLAYERS 
>Action  PTLDRW
>Parameters 
PERS    ' DRAW(D) or CUT(c) view ' C D=D
SUPL    ' Superlayer name        ' C D='PTL1' R='PTL1','PTL2','PTL3','MAGN','MOTH'
THETA    'angle THETA for GDRAW  ' R D=20.0
PHI      'angle PHI   for GDRAW  ' R D=45.0
PSI      'angle PSI   for GDRAW  ' R D=0.0
AXE      'Axis of the GDRAWC     ' I D=3 
CUT      'cut value for GDRAWC   ' R D=0.0
U0       'U0                     ' R D=10.0  
V0       'V0                     ' R D=10.0  
SU       'SU                     ' R D=0.1  
SV       'SV                     ' R D=0.1  

>Command PTLREAD  
>Guidance 
Force the reading of PT-geometry information and put it into Arte table PTGE. 
Existing PTGE table will be removed. New information in PTGE Arte table 
*can differ* from existing GEANT JVOLUM structure. Therefore be carefull 
using this command. Currently onlu SOURCE=File is implemented.   
Being frequently used within one ineractive job this command *can force* 
Arte  termination via "no place for rotation matrix in CRROTM" error. 
>Action PTLREA 
>Parameters 
+
SOURCE 'where the information should be read from?File?DBase?' C D='FILE' 




***************************
>MENU DIGIT
>Guidance 
Digitization commands
>COMMAND DGMOD
>Guidance
Sets long or short version for digitization
>Action KADGMD
>Parameter
DGMOD 'short, long or user versions for detector digitization' C VARARG LOOP



