
      SUBROUTINE NSPIRL

************************************************************************
*-- Author :    Siegmund Nowak   04/03/93
*
* This routines avoids long spirals in magnetic field
* ISTOP will be set to 1 in this case
*
* called from GUSTEP
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* ANGLE       in          maximal accepted spiraling angle in magnet   
************************************************************************

      IMPLICIT NONE

#include "gean/gckine.fi"
#include "gean/gcflag.fi"
#include "gean/gctrak.fi"
#include "gean/gcvolu.fi"
#include "gean/gconst.fi"
*
      INTEGER IFIRST,J,IFLMG,IDCNAM
      REAL ANGSPR,FIELD(3),FLD0,EC,PHI,SLEN0
      PARAMETER (EC = 2.9979251E-4)
      SAVE IFIRST
      COMMON /ZGSPRL/ ANGSPR
      DATA IFIRST/0/

      IF (IFIRST.EQ.0) THEN
         CALL UCTOH('MAGN',IDCNAM,4,4)
         IFIRST = 1
      ENDIF
*
      IF(ANGSPR.EQ.0.) GO TO 99
      IF(NSTEP.EQ.0) IFLMG = 0
*      
      IF(NAMES(2).NE.IDCNAM) GO TO 99
      IF(VECT(7).GT.1.) GO TO 99
      IF(ABS(CHARGE).LE..5) GO TO 99
      CALL GUFLD(VECT,FIELD)
*
      IF(ABS(FIELD(2)).LT.1.E - 3) GO TO 99
*
      IF(IFLMG.EQ.0) THEN
         SLEN0 = SLENG
         FLD0 = FIELD(2)
         IFLMG = 1
         PHI = 0.
         GO TO 99
      ENDIF
*
      DO 32 J=1,NMEC
      IF(LMEC(J).NE.4) GO TO 32
      PHI = PHI + (SLENG - SLEN0)*EC*CHARGE*0.5*(FIELD(2)+FLD0)/ 
     +              (VECT(7)*SQRT((1.-VECT(5))*(1.+VECT(5))))
      IF(ABS(PHI).GT.ANGSPR) GO TO 90
      FLD0 = FIELD(2)
      SLEN0 = SLENG
      GO TO 99
   32 CONTINUE
*
   99 RETURN
*
  90  ISTOP=1
      RETURN
      END
