#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/zgeom.h"

int zgdet::maxdet[33] ;
int zgdet::nrdet[33] ;
hgdet *zgdet::ptdet[33];

/*************************************************************************/
void zgdet::ini(int n){ 
        ptdet[zgvol::ind_pt] = new hgdet[n];
        if(ptdet[zgvol::ind_pt]==NULL) {
           arteMsg << "no hgdet[n] allocated";
           arteMsg.error();      }
        maxdet[zgvol::ind_pt] = n;
        nrdet[zgvol::ind_pt] = -1;  }
/*************************************************************************/
void zgdet::fin() {   
        delete [] ptdet[zgvol::ind_pt];
        nrdet[zgvol::ind_pt] = -1; }   
/*************************************************************************/
void zgdet::increase() {
        if(nrdet[zgvol::ind_pt] < maxdet[zgvol::ind_pt]-1) 
                                    nrdet[zgvol::ind_pt]++;
        else {
        hgdet *det, *temp, *tmp; 
        int n =2*maxdet[zgvol::ind_pt];
        temp = new hgdet[n];    
        if(temp == NULL) {
             arteMsg << "no hgdet[2*n] allocated";   arteMsg.error();} 
        for(int i=0; i <= nrdet[zgvol::ind_pt]; i++) {
          det = ptdet[zgvol::ind_pt] + i ;    tmp = temp + i ;   *tmp = *det; }
        delete [] ptdet[zgvol::ind_pt];        
        ptdet[zgvol::ind_pt] = temp;
        maxdet[zgvol::ind_pt] = 2* maxdet[zgvol::ind_pt]; 
        nrdet[zgvol::ind_pt]++;}}
/*************************************************************************/
void zgdet::Set_default() {
     hgdet *det = detpointer(size()-1) ;
     memset(det,0,sizeof(hgdet));
     det->sides = 1; 
}
/*************************************************************************/ 
void zgdet::Copy_previous() {
     if (nrdet[zgvol::ind_pt] >0 ) {
        hgdet *det = detpointer(size()-1) ;
        hgdet *old = det -1;       
        *det = *old; 
     }
     else { 
        arteMsg <<"zgdet::Copy previous: previous does not exist";
        arteMsg.error();
     }
}
/*************************************************************************/
void zgdet::Set_vol_det_Rel() {
     zgvol ZGVOL;
     hgvol *vol = ZGVOL.volpointer(ZGVOL.size()-1);
     hgdet *det = detpointer(size()-1);
     vol->index_hgdet = size()-1;
     det->index_hgvol = ZGVOL.size()-1;
}
/*************************************************************************/
void zgdet::Read_sens_dim(char *card) {
     zgvol ZGVOL; 
     hgvol *vol = ZGVOL.volpointer(ZGVOL.size()-1) ;
     hgdet *det = detpointer(size()-1);
     if(vol->npar == 3) {
       int nitem=sscanf(card,"%f %f",&det->sensdx,&det->sensdy); 
       if (nitem!=2) {
          arteMsg <<"check data on sens_dimension cards";
          arteMsg.error();
       } 
     }   
}
/*************************************************************************/
void zgdet::Read_sens_offset(char* card){ 
     zgvol ZGVOL;
     hgvol *vol = ZGVOL.volpointer(ZGVOL.size()-1);
     hgdet *det = detpointer(size()-1);
     if(vol->npar == 3) {
       int nitem=sscanf(card,"%f%f",&det->sens_offset_x,&det->sens_offset_y); 
       if (nitem!=2) {
          arteMsg <<"check data on sens_offset cards";
          arteMsg.error();
       } 
     }   
}
/*************************************************************************/
void zgdet::Read_sides(char *card) {
     hgdet *det = detpointer(size()-1) ;
     int nitem=sscanf(card,"%d",&det->sides);
     if (nitem!=1) {
        arteMsg <<"check data on side cards";        arteMsg.error();
     } 
}
/*************************************************************************/
void zgdet::Read_x_wire(char *card) {
     zgvol ZGVOL;
     hgvol *vol = ZGVOL.volpointer(ZGVOL.size()-1);
     hgdet *det = detpointer(size()-1);
     float xw;
     for (int i=0;i<det->sides;i++) {
         int nitem=sscanf(card,"%f",&xw);
         det->x_wire[i] = xw + vol->rel_px;
         if (nitem!=1) {
            arteMsg <<"check data on x_wire cards";
            arteMsg.error();
         } 
         card+=itemlength(card,nitem);
     }
}
/*************************************************************************/
void zgdet::Read_z_wire(char *card) {
     zgvol ZGVOL;
     hgvol *vol = ZGVOL.volpointer(ZGVOL.size()-1);
     hgdet *det = detpointer(size()-1);
     float zw;
     for (int i=0;i<det->sides;i++) {
         int nitem=sscanf(card,"%f",&zw);
         det->z_wire[i] = zw + vol->rel_pz;
         if (nitem!=1) {
            arteMsg <<"check data on z_wire cards";      arteMsg.error();
         } 
         card+=itemlength(card,nitem);
     }
}
/*************************************************************************/
  void  zgdet::Read_n_wire(char *card) {
         hgdet *det = detpointer(size()-1);
         for (int i=0;i<det->sides;i++) {
            int nitem=sscanf(card,"%d",&det->n_wire[i]);
            if (nitem!=1) {
                arteMsg <<"check data on n_wire cards";
                arteMsg.error();} 
            card+=itemlength(card,nitem);}}
/*************************************************************************/
  void  zgdet::Read_y1_wire(char *card) {
         hgdet *det = detpointer(size()-1);
         for (int i=0;i<det->sides;i++) {
            int nitem=sscanf(card,"%f",&det->y1_wire[i]);
            if (nitem!=1) {
                arteMsg <<"check data on y1_wire cards";
                arteMsg.error();} 
            card+=itemlength(card,nitem);}}
/*************************************************************************/
  void  zgdet::Read_y2_wire(char *card) {
         hgdet *det = detpointer(size()-1);
         for (int i=0;i<det->sides;i++) {
            int nitem=sscanf(card,"%f",&det->y2_wire[i]);
            if (nitem!=1) {
                arteMsg <<"check data on y2_wire cards";
                arteMsg.error();} 
            card+=itemlength(card,nitem);}}
/*************************************************************************/
  void  zgdet::Read_wire_orientation(char *card){  
         hgdet *det = detpointer(size()-1);
         for (int i=0;i<det->sides;i++) {
              int nitem=sscanf(card,"%f",&det->wire_orient[i]);
              if (nitem!=1) {
                arteMsg <<"check data on wire_orient cards";
                arteMsg.error();}
              card+=itemlength(card,nitem); }}
/*************************************************************************/
  void  zgdet::Read_polarity(char *card)    {
         hgdet *det = detpointer(size()-1);
         for (int i=0;i<det->sides;i++) {
              int nitem=sscanf(card,"%f",&det->polarity[i]);
              if (nitem!=1) {
                 arteMsg <<"check data on polarity card";
                 arteMsg.error();} 
              card+=itemlength(card,nitem);}}
/*************************************************************************/
  void  zgdet::Read_pitch(char *card) {
        hgdet *det = detpointer(size()-1);
        for (int i=0;i<det->sides;i++) {
             int nitem=sscanf(card,"%f",&det->pitch[i]);
             if (nitem!=1) {
                 arteMsg <<"check data on pitch cards";
                 arteMsg.error();}         
             card+=itemlength(card,nitem);}}
/*************************************************************************/
  void  zgdet::Read_effectivity(char *card) {
        hgdet *det = detpointer(size()-1);           
        int nitem=sscanf(card,"%f",&det->effectivity);
        if (nitem!=1) {
            arteMsg <<"check data on effectivity cards";
            arteMsg.error();}  }
/*************************************************************************/
  void  zgdet::Read_accuracy(char *card) {
        hgdet *det = detpointer(size()-1);
        int nitem=sscanf(card,"%f",&det->accuracy);
        if (nitem!=1) {
            arteMsg <<"check data on accuracy cards";
            arteMsg.error();}  }
/*************************************************************************/
  void  zgdet::Read_double_hit_res(char *card) {
        hgdet *det = detpointer(size()-1);
        int nitem=sscanf(card,"%f",&det->double_hit_res);
        if (nitem!=1) {
            arteMsg <<"check data on double_hit_res cards";
            arteMsg.error();}   }
/*************************************************************************/
void zgdet::Get_sens_dim(int &nr, float &sens_dx, float &sens_dy) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     sens_dx = det->sensdx;
     sens_dy = det->sensdy;
}
/*************************************************************************/
void zgdet::Get_sens_offset(int &nr,float &sens_of_x,float &sens_of_y) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     sens_of_x = det->sens_offset_x;
     sens_of_y = det->sens_offset_y;
}
/*************************************************************************/
int  zgdet::Get_sides(int &nr) {
     zgvol ZGVOL; 
     return detpointer(ZGVOL.volpointer(nr)->index_hgdet)->sides;
}
/*************************************************************************/
void zgdet::Get_x_wire(int &nr,float x_wire[],int n_el ) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         x_wire[i] = det->x_wire[i];
     }
} 
/*************************************************************************/
void zgdet::Get_z_wire(int &nr,float z_wire[],int n_el ) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         z_wire[i] = det->z_wire[i];
     }
} 
/*************************************************************************/
void zgdet::Get_n_wire(int &nr,int   n_wire[],int n_el ) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         n_wire[i] = det->n_wire[i];
     }
} 
/*************************************************************************/
void zgdet::Get_y1_wire(int &nr,float y1_wire[],int n_el ) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         y1_wire[i] = det->y1_wire[i];
     }
} 
/*************************************************************************/
void zgdet::Get_y2_wire(int &nr,float y2_wire[],int n_el ) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         y2_wire[i] = det->y2_wire[i];
     }
} 
/*************************************************************************/
void zgdet::Get_wire_orientation(int &nr,float wire_orient[],int n_el){  
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         wire_orient[i] = det->wire_orient[i];
     }
} 
/*************************************************************************/
void zgdet::Get_polarity(int &nr,float polarity[],int n_el)    {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         polarity[i] = det->polarity[i];
     }
} 
/*************************************************************************/
void zgdet::Get_pitch(int &nr, float pitch[],int n_el) {
     zgvol ZGVOL;
     hgdet *det = detpointer(ZGVOL.volpointer(nr)->index_hgdet);
     for (int i=0;i<n_el;i++) { 
         pitch[i] = det->pitch[i];
     }
} 
/*************************************************************************/
float zgdet::Get_effectivity(int &nr) {
     zgvol ZGVOL;
     return detpointer(ZGVOL.volpointer(nr)->index_hgdet)->effectivity;
}
/*************************************************************************/
float zgdet::Get_accuracy(int &nr) {
     zgvol ZGVOL;
     return detpointer(ZGVOL.volpointer(nr)->index_hgdet)->accuracy;
}
/*************************************************************************/
float zgdet::Get_double_hit_res(int &nr) {
     zgvol ZGVOL;
     return detpointer(ZGVOL.volpointer(nr)->index_hgdet)->double_hit_res;
}
/*************************************************************************/




