*-- Author :    Hartwig Albrecht   21/05/95

      SUBROUTINE KADRAN (IFLAG)

************************************************************************
*
* Description: range commands
*
* Called from: KADIRA, KADILO, KADIUP, KADFRA, KADDLO, KADFUP, KADNBI
*
* External references:
*
* Arguments: IFLAG: which range specification
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDCOM.fi"
#include "arte/ZDDEFP.fi"

      INTEGER IFLAG

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (NDDTYP .EQ. 0)  THEN
        CALL MEERRC (5631467,
     +   'DD range specification must follow DATTRIB statement')
        GO TO 90
      END IF

      IF (NDDTYP .EQ. 3)  THEN
        CALL MEERRC (12845,
     +    'DD range: no range specification for type H')
        GO TO 90
      END IF

      IF (NDDTYP .EQ. 1 .AND. IFLAG .LE. LDDEF_IUP)  GO TO 20
      IF (NDDTYP .EQ. 2 .AND. IFLAG .EQ. LDDEF_NBI)  GO TO 20
      IF (NDDTYP .NE. 4)  GO TO 10
      IF (IFLAG .GE. LDDEF_FRA .AND. IFLAG .LE. LDDEF_FUP)  GO TO 20
 10   CALL MEERRC (762354, 'DD range specification: wrong data type')
      GO TO 90

 20   CALL KADZZI (IFLAG)

C integer
      IF (NDDTYP .EQ. 1)  THEN

        IQ(L_L(JDDEF_RFLG,JDDEF)) = -ILARGEST
        IQ(L_L(JDDEF_DIV ,JDDEF)) =  ILARGEST
        IF (IFLAG .EQ. LDDEF_ILO)  THEN
          CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
        ELSE
          IF (IFLAG .EQ. LDDEF_IRA)
     +      CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
          CALL KUGETI (IQ(L_L(JDDEF_DIV,JDDEF)))
        END IF

C float
      ELSE IF (NDDTYP .EQ. 4)  THEN

        Q(L_L(JDDEF_FLO,JDDEF)) = - FLARGEST
        Q(L_L(JDDEF_FUP,JDDEF)) = FLARGEST
        IF (IFLAG .LE. LDDEF_FLO)  CALL KUGETR (Q(L_L(JDDEF_FLO,JDDEF)))
        IF (IFLAG .NE. LDDEF_FLO)  CALL KUGETR (Q(L_L(JDDEF_FUP,JDDEF)))
        CALL KUGETR (Q(L_L(JDDEF_FAC,JDDEF)))

C bit
      ELSE

        CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))

      END IF

 90   END

************************************************************************
* End of KADRAN
************************************************************************
