*CMZ :          10/09/96  19.38.05  by  Fedor Ratnikov
*CMZ :  1.00/07 22/10/95  15.18.48  by   Ivan Belyaev
*CMZ :  1.00/02 20/08/95  15.05.57  by   Ivan Belyaev
*CMZ :  1.00/01 19/08/95  19.14.12  by   Ivan Belyaev
*CMZ :  1.00/00 16/12/94  16.20.42  by  Fedor Ratnikov
*CMZ :  0.01/03 17/09/94  19.00.41  by  Fedor Ratnikov
*CMZ :  0.01/02 22/08/94  13.50.10  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  17.04.17  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1MCUFA
* written by Dominik Ressing, 24/07/94 16.23.08
*
* This routines action:
* Performes a fast simulation of the MCU task
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* JobPo       in          pointer to job
* itime       out         time at completion
* ierr        out         error flag
*
************************************************************************
c
      SUBROUTINE L1MCUFA(JobPo,itime,ierr)
c
      IMPLICIT NONE
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/l1kindf.fi"
#include "l1si/l1kuip.fi"
#include "l1si/l1user.fi"
c
      INTEGER JobPo,itime,ierr,MePo,iPcPo,iBX,MePo2,
     &        ltype,ltype2,icpoi,icpoi2,itrig,il2max,
     &        il2,maxpairs,iMCU,imes
      REAL amass,Energy,Eratio,t1kinma,amassB,dP2,
     & PtB1,PtB2,Easym,PB1,PB2,EtoP1,EtoP2
      CHARACTER*4 cltype
      EXTERNAL t1kinma
#include "l1si/l1mcuda.ff"
#include "l1si/l1mesdf.ff"
c
      ierr = 0
      maxpairs = 0
      itime = L1RUNcutime + L1DEFmcucyc*L1DEFmcuNcyc  ! add execution time
c
      MePo  = L1JOBstore(JobPo+L1JOBmess)             ! this message
      iPcPo = L1MEstor(MePo+L1MEnextPC)               ! this processor
      iBX = L1MEstor(MePo+L1MEprbx)		      ! BX number
      L1PCstor(iPcPo+L1PCbusy) = L1RUNcutime+L1DEFmcucyc ! this cycle this MCU is busy
      iMCU = L1PCstor(iPcPo+L1PCnum) ! get MCU num
      IF (L1PARprnlev.GE.1) THEN
         WRITE (L1LUNprn,998) iMCU
 998     FORMAT(1x,'L1MCUFA==> BEGIN ',25('#'),' MCU',i03,1x,25('#'))
      ENDIF
c
      ltype = L1MEstor(MePo+L1MEpartID)
c
      IF (ltype.GT.0) THEN      ! accepted track
         IF (L1PARprnlev.GE.1) THEN
            WRITE(L1LUNprn,*)
     &           'L1MCUFA==>  New candidate: type/No/iBX:  ',
     &           C1MCUtypeDEF(ltype),iBX
         ENDIF
c
c      Is new candidate the copy of another one?
c
         IF(L1PARdltdbl.NE.0)   THEN
            MePo2 = L1MEBXfirst(iBX)
            DO imes = 1,L1MEBXtotal(iBX) ! loop over all messages
               IF(L1MEstor(MePo2+L1MEactive).EQ.-L1MEacMCU.AND.
     &              L1MEstor(MePo2+L1MEpartID).EQ.ltype)  THEN !the same
                                !particle
                  dP2 =
     &              (T1MEstor(MePo+L1MEpx)-T1MEstor(MePo2+L1MEpx))**2+
     &              (T1MEstor(MePo+L1MEpy)-T1MEstor(MePo2+L1MEpy))**2+
     &              (T1MEstor(MePo+L1MEpz)-T1MEstor(MePo2+L1MEpz))**2
                  dP2 = sqrt(dP2)
c                  CALL L1USRUSR(MePo,MePo2)
                  IF(dP2.LT.T1PARmcuPPdiff)    THEN ! reject candidate
                     IF(L1PARprnlev.GE.1)		THEN
                        WRITE(L1LUNprn,*)
     &                       'L1MCUFA==> reject new candidate. dP:',dP2
                        WRITE(L1LUNprn,'(''  Old     Pxyz:'',3F7.2)')
     &                       T1MEstor(MePo2+L1MEpx),
     &                       T1MEstor(MePo2+L1MEpy),
     &                       T1MEstor(MePo2+L1MEpz)
                        WRITE(L1LUNprn,'(''Rejected  Pxyz:'',3F7.2)')
     &                       T1MEstor(MePo+L1MEpx),
     &                       T1MEstor(MePo+L1MEpy),
     &                       T1MEstor(MePo+L1MEpz)
                     ENDIF
                     CALL l1mesde(MePo,L1MEDEusr)   ! Delete
                                ! massage+user action
                     GOTO 888
                  ENDIF
               ENDIF
               MePo2 = L1MEBXnext(MePo2) ! next message
            ENDDO
         ENDIF
         CALL L1SVTRA(MePo)    ! Fill ARTE tables
         CALL L1USRTR(MePo)    ! Store track information
c
         DO itrig=1,L1MCUntriggers             ! LOOP over triggers

            IF (ltype.EQ.L1MCUtrig(L1MCUtriitype1,itrig)) THEN
               ltype2 = L1MCUtrig(L1MCUtriitype2,itrig)         ! requested second type
            ELSEIF (ltype.EQ.L1MCUtrig(L1MCUtriitype2,itrig)) THEN
               ltype2 = L1MCUtrig(L1MCUtriitype1,itrig)
            ELSE
               GOTO 777         ! go to the next trigger
            ENDIF
            IF (L1PARprnlev.GE.1)		THEN
               WRITE(L1LUNprn,*)
     &             'L1MCUFA==>  Looking for trigger:',itrig,' ->(',
     &             C1MCUtrig(L1MCUtrictype1,itrig),
     &             C1MCUtrig(L1MCUtrictype2,itrig),')'
            ENDIF
            MePo2 = L1MEBXfirst(iBX)
            DO imes = 1,L1MEBXtotal(iBX)  ! loop over all messages
               IF(L1MEstor(MePo2+L1MEactive).EQ.-L1MEacMCU.AND.
     &              L1MEstor(MePo2+L1MEpartID).EQ.ltype2)  THEN !requested pair
                  IF (L1PARprnlev.GE.1)		THEN
                     WRITE (L1LUNprn,*)
     &            'L1MCUFA==>  mass calculation: e/px/py/pz/(e+brem):'
                     WRITE (L1LUNprn,'(11X,5f10.3)')
     &                    T1MEstor(MePo+L1MEp),
     &                    T1MEstor(MePo+L1MEpx),
     &                    T1MEstor(MePo+L1MEpy),
     &                    T1MEstor(MePo+L1MEpz),
     &                    T1MEstor(MePo+L1MEp)*
     &                    T1MEstor(MePo+L1MEBremRatio)
                     WRITE (L1LUNprn,'(11X,5f10.3)')
     &                    T1MEstor(MePo2+L1MEp),
     &                    T1MEstor(MePo2+L1MEpx),
     &                    T1MEstor(MePo2+L1MEpy),
     &                    T1MEstor(MePo2+L1MEpz),
     &                    T1MEstor(MePo2+L1MEp)*
     &                    T1MEstor(MePo2+L1MEBremRatio)
                  ENDIF
c
                  amass = t1kinma(T1MEstor(MePo+L1MEp),
     &                 T1MEstor(MePo+L1MEpx),
     &                 T1MEstor(MePo+L1MEpy),
     &                 T1MEstor(MePo+L1MEpz),
     &                 T1MEstor(MePo2+L1MEp),
     &                 T1MEstor(MePo2+L1MEpx),
     &                 T1MEstor(MePo2+L1MEpy),
     &                 T1MEstor(MePo2+L1MEpz),
     &                 L1APPROXseco)
c
                  amassB = amass*sqrt(
     &                 T1MEstor(MePo +L1MEBremRatio)*
     &                 T1MEstor(MePo2+L1MEBremRatio))
c
                  IF (L1PARprnlev.GE.1)		THEN
                     WRITE (L1LUNprn,*) 'L1MCUFA==>  Found pair:'
                     WRITE (L1LUNprn,900)
     &                    C1MCUtypeDEF(L1MEstor(MePo+L1MEpartID)),
     &                    C1MCUtypeDEF(L1MEstor(MePo2+L1MEpartID)),
     &                    amass,amassB
 900                 FORMAT(13X,A4,' & ',A4,' M:',F10.3,
     &                    ' M-Brems:',F10.3)
                  ENDIF
c

                  PtB1 = SQRT(
     &             T1MEstor( MePo  + L1MEpx        ) *
     &             T1MEstor( MePo  + L1MEpx        ) +
     &             T1MEstor( MePo  + L1MEpy        ) *
     &             T1MEstor( MePo  + L1MEpy        ) ) *
     &             T1MEstor( MePo  + L1MEBremRatio )
                  PtB2 = SQRT(
     &             T1MEstor( MePo2 + L1MEpx        ) *
     &             T1MEstor( MePo2 + L1MEpx        ) +
     &             T1MEstor( MePo2 + L1MEpy        ) *
     &             T1MEstor( MePo2 + L1MEpy        ) ) *
     &             T1MEstor( MePo2 + L1MEBremRatio )

                  PB1 = SQRT(
     &             T1MEstor( MePo  + L1MEpx        ) *
     &             T1MEstor( MePo  + L1MEpx        ) +
     &             T1MEstor( MePo  + L1MEpy        ) *
     &             T1MEstor( MePo  + L1MEpy        ) +
     &             T1MEstor( MePo  + L1MEPz        ) *
     &             T1MEstor( MePo  + L1MePz        ) ) *
     &             T1MEstor( MePo  + L1MEBremRatio )
                  PB2 = SQRT(
     &             T1MEstor( MePo2 + L1MEpx        ) *
     &             T1MEstor( MePo2 + L1MEpx        ) +
     &             T1MEstor( MePo2 + L1MEpy        ) *
     &             T1MEstor( MePo2 + L1MEpy        ) +
     &             T1MEstor( MePo2 + L1MEPz        ) *
     &             T1MEstor( MePo2 + L1MePz        ) ) *
     &             T1MEstor( MePo2 + L1MEBremRatio )

                  Easym = ABS(
     &             ( T1MEstor( MePo  + L1MEp ) -
     &               T1Mestor( MePo2 + L1MEp ) ) /
     &             ( T1MEstor( MePo  + L1MEp ) +
     &               T1Mestor( MePo2 + L1MEp ) ) )

                  IF(L1MEstor(MePo+L1MEpartID).EQ.L1PREelec) THEN       !electron
                   EtoP1 = T1MEstor(MePo+L1MEpren)/T1MEstor(MePo+L1MEp)
                  ELSE
                   EtoP1 = 1.                      ! perfect for nonelectrons
                  ENDIF  
                  IF(L1MEstor(MePo2+L1MEpartID).EQ.L1PREelec) THEN       !electron
                   EtoP2 = T1MEstor(MePo2+L1MEpren)/
     &                  T1MEstor(MePo2+L1MEp)
                  ELSE
                   EtoP2 = 1.                      ! perfect for nonelectrons
                  ENDIF  


                  IF (
     &             amassB .GT. T1MCUtrig( L1MCUtrilow     , itrig )
     &             .AND.
     &             amassB .LT. T1MCUtrig( L1MCUtrihigh    , itrig )
     &             .AND.
     &             PtB1   .GE. T1MCUtrig( L1MCUtri1lowPT  , itrig )
     &             .AND.
     &             PtB1   .LE. T1MCUtrig( L1MCUtri1highPT , itrig )
     &             .AND.
     &             PtB2   .GE. T1MCUtrig( L1MCUtri2lowPT  , itrig )
     &             .AND.
     &             PtB2   .LE. T1MCUtrig( L1MCUtri2highPT , itrig )
     &             .AND.
     &             PB1    .GE. T1MCUtrig( L1MCUtri1lowP   , itrig )
     &             .AND.
     &             PB1    .LE. T1MCUtrig( L1MCUtri1highP  , itrig )
     &             .AND.
     &             PB2    .GE. T1MCUtrig( L1MCUtri2lowP   , itrig )
     &             .AND.
     &             PB2    .LE. T1MCUtrig( L1MCUtri2highP  , itrig )
     &             .AND.
     &             Easym  .LE. T1MCUtrig( L1MCUtriEasym   , itrig )
     &                                  ) THEN ! trigger accepted
c
                   IF(
     &                  T1EVEinner(iBX).LT.t1k_einner.AND.    ! Einner cut
     &                  EtoP1.GT.t1k_epmin.AND.               ! EtoP cuts
     &                  EtoP1.LT.t1k_epmax.AND.
     &                  EtoP2.GT.t1k_epmin.AND.               
     &                  EtoP2.LT.t1k_epmax)
     &                                      THEN
                                
                    CALL L1MCUac(iBX,itrig,MePo,MePo2,amass,amassB)
                    CALL L1SVTRI(itrig,MePo,MePo2) ! Fill trigger table
                   ENDIF
c
                  ENDIF
               ENDIF
               MePo2 = L1MEBXnext(MePo2) ! next message
            ENDDO
 777        CONTINUE
         ENDDO
      ENDIF
      itime = itime + INT(maxpairs/4)*L1DEFmcucyc ! add time for many
                                                  ! pairs
      L1MEstor(MePo+L1MEactive) = L1MEacMCU ! last processed is MCU
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,999)
 999     FORMAT(1x,'L1MCUFA==> END ',60('#'))
      END IF
c
 888  CONTINUE
      RETURN
c
      END





