*-- Author :    Rainer Mankel   01/08/94

      subroutine prhits2()

*     **** print information for hits in table hitb
*     **** Parameters:
*     ****   hit1, hit2  - range of rows in table hitb
*     ****   pl          - associated plane
*     ****   sl          - associated superlayer
*     ****   mimp        - associated mimp
*     ****   mc          - associated MC track
*     ****   rc          - associated reconstructed track
*     ****   hitb        - associated fitted track

      implicit none
      integer id1, hit1, hit2, nch, isl, pl, ih, imc, imimp, this_mimp,
     +     mimp, nhmimp, ndetpl, nhitot, nmctot,jmc,hitmx,nhits,iih,
     +     this_hfit, sl, mc, rc, hfit1, hfit2, mimp1, mimp2, hitb,
     +     iihit, ipl, n_hits, jaux, hfit, tumchit, tuhrtra
      real xmc, ymc, mxmc, mymc, zmc, pmc

      character*80 chopts
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"

*     **** parameters
      call kugeti(hit1)
      call kugeti(hit2)
      call kugeti(pl  )
      call kugeti(sl  )
      call kugeti(mimp)
      call kugeti(mc  )
      call kugeti(rc  )
      call kugeti(hfit)
      call kugetc(chopts,nch)

*     **** fixup
      ndetpl = iq(jgede+2)
      nhitot = iq(jhitb+2)
      nmctot = iq(jmtra+2)
      if (hit2.eq.0.and.hit1.ne.0) hit2 = hit1
      hit1 = max(hit1,1)
      if (hit2.eq.0) then
       hit2 = nhitot
      else
       hit2 = min(hit2,nhitot)
      endif

*     **** print headline
      print 102,'ih','pl','sl',
     +          'z','hitb_x','hitb_q','hitb_r','it','imc',
     +          'x-mc','y-mc','mx-mc','my-mc','z-mc','p-mc'

*     **** loop over range
      n_hits = 0
      if (mimp.eq.0.and.mc.eq.0.and.rc.eq.0.and.hfit.eq.0) then
       do 10 ih=hit1,hit2
        ipl = ihitb_gede(ih)
        if (ipl.gt.ndetpl) go to 10
        if (pl.ne.0.and.ipl.ne.pl) go to 10
        isl = ogede_gesl(ipl)
        if (sl.ne.0.and.isl.ne.sl) go to 10

*       **** get associated MC
        imc = tumchit(ih)
*       **** get associated mimp
        call tuhmimp(ih,jmc,mimp,nhmimp)
        if (nhmimp.eq.1) then
         xmc  = fmimp_x(mimp)
         ymc  = fmimp_y(mimp)
         mxmc = fmimp_tx(mimp)
         mymc = fmimp_ty(mimp)
         zmc  = fmimp_z(mimp)
         pmc  = fmimp_p(mimp)
        else
         xmc = 0.
         ymc = 0.
         mxmc = 0.
         mymc = 0.
         zmc = 0.
         pmc = 0.
        endif

        print 101,ih,ihitb_gede(ih),isl,
     +             fhitb_z(ih), fhitb_x(ih), fhitb_q(ih), fhitb_r(ih),
     +             tuhrtra(ih), imc,
     +             xmc, ymc, mxmc, mymc,zmc, pmc
 101      format(   i6,i5,i3,f9.3,2f8.3,f8.5,
     +              2i5,
     +              6f8.3)
 102      format(   a6,a5,a3,a9,2a8,a8,
     +              2a5,
     +              6a8)
 10    continue ! ih
      elseif (mimp.ne.0.or.mc.ne.0) then
       if (mimp.ne.0) then
        if (mimp.lt.0.or.mimp.gt.iq(jmimp+2)) go to 999
        mimp1 = mimp
        mimp2 = mimp
       else
        mimp1 = 1
        mimp2 = iq(jmimp+2)
       endif
*      **** loop over mimps
       do 30 imimp=mimp1,mimp2
        if (mc.ne.0.and.omimp_mtra(imimp).ne.mc) go to 30
*       **** loop over hits associated with mimp
        n_hits = 0
        do 20 iihit=1,999
         if (iihit.eq.1) then
          jaux = pmimp_hitb(imimp)
         else
          jaux = xmimp_hitb(jaux)
         endif
         if (jaux.eq.0) go to 21
         ih = mmimp_hitb(jaux)
         if (ih.lt.hit1.or.ih.gt.hit2) go to 20
         ipl = ihitb_gede(ih)
         if (ipl.gt.ndetpl) go to 20
         if (pl.ne.0.and.ipl.ne.pl) go to 20
         isl = ogede_gesl(ipl)
         if (sl.ne.0.and.isl.ne.sl) go to 20
         n_hits = n_hits + 1

*        **** get associated MC
         imc = tumchit(ih)
*        **** get associated mimp
         call tuhmimp(ih,jmc,this_mimp,nhmimp)
         if (nhmimp.eq.1) then
          xmc  = fmimp_x(this_mimp)
          ymc  = fmimp_y(this_mimp)
          mxmc = fmimp_tx(this_mimp)
          mymc = fmimp_ty(this_mimp)
          zmc  = fmimp_z(this_mimp)
          pmc  = fmimp_p(this_mimp)
         else
          xmc = 0.
          ymc = 0.
          mxmc = 0.
          mymc = 0.
          zmc = 0.
          pmc = 0.
         endif

         print 101,ih,ihitb_gede(ih),isl,
     +              fhitb_z(ih), fhitb_x(ih), fhitb_q(ih), fhitb_r(ih),
     +              tuhrtra(ih), imc,
     +              xmc, ymc, mxmc, mymc,zmc, pmc
 20     continue ! iihit
 21     continue ! loop escape
 30    continue ! imimp
      else ! rc.ne.0.or.hfit.ne.0
       if (hfit.ne.0) then
        hfit1 = hfit
        hfit2 = hfit
       else
        hfit1 = 1
        hfit2 = iq(jrhit+2)
       endif
       do 40 this_hfit=hfit1,hfit2
        if (rc.ne.0.and.irhit_rtra(this_hfit).ne.rc) go to 40
        ih = orhit_hitb(this_hfit)
        if (ih.lt.hit1.or.ih.gt.hit2) go to 40
        ipl = ihitb_gede(ih)
        if (ipl.gt.ndetpl) go to 40
        if (pl.ne.0.and.ipl.ne.pl) go to 40
        isl = ogede_gesl(ipl)
        if (sl.ne.0.and.isl.ne.sl) go to 40
        n_hits = n_hits + 1

*       **** get associated MC
        imc = tumchit(ih)
*       **** get associated mimp
        call tuhmimp(ih,jmc,this_mimp,nhmimp)
        if (nhmimp.eq.1) then
         xmc  = fmimp_x(this_mimp)
         ymc  = fmimp_y(this_mimp)
         mxmc = fmimp_tx(this_mimp)
         mymc = fmimp_ty(this_mimp)
         zmc  = fmimp_z(this_mimp)
         pmc  = fmimp_p(this_mimp)
        else
         xmc = 0.
         ymc = 0.
         mxmc = 0.
         mymc = 0.
         zmc = 0.
         pmc = 0.
        endif

        print 101,ih,ihitb_gede(ih),isl,
     +             fhitb_z(ih), fhitb_x(ih), fhitb_q(ih), fhitb_r(ih),
     +             tuhrtra(ih), imc,
     +             xmc, ymc, mxmc, mymc,zmc, pmc
 40    continue ! this_hfit
      endif ! operands clause

 999  end


