//**********************************************************************/
// Created: 23.10.97,   Olya Igonkina   for   MARPLE package
//
// implementation of saveRelation() functions of RcMatchBuilder class
// for special casses 
// at the moment implemented function for :
//               RSEG_RSEG (RSEG_RBEG) relation
//               RTRA_RSEG     relation
//               RTRA_RCCL     relation
//               RSEG_RCCL     relation
//
//**********************************************************************/

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "marple/marple.hh"
#include "marple/RcMatchBuilder.hh"

/*
extern "C" 
{
  void  FORTRAN_ROUTINE(mmbrel)(int &, 
				int *, 
				int *);
}
*/
//-----------------------------------------------------------------
// RcPoint-RcPoint relation  - nothing is done, type of ARTE bank is unknown
//-----------------------------------------------------------------

void RcMatchBuilder< RcPoint, RcPoint>::saveRelation( 
                                                 const RcPoint * ptPoint1,
						 const RcPoint * ptPoint2,
						 int & iErr) const
{
  iErr = 1;
  return ;
}
//-----------------------------------------------------------------
// RSEG-RSEG relation 
//-----------------------------------------------------------------
/*void createRelation(  ArtePointer<T1> el1, ArtePointer<T2> el2,
                      ArteManRelationPointer<Relation,T2> T1::* e
                      )
{
  mmbrel_(  ArteManRelationPointer<Relation,T2>::getLink().getInt(),
            el2, el1 );
}
*/
void RcMatchBuilder< RcSegPoint, RcSegPoint>::saveRelation( 
                                                 const RcSegPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 int & iErr) const
{
  //unsigned int irow1 = ptPoint1->link().index();
  //unsigned int irow2 = ptPoint2->link().index();
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RSEG>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() )
    {
      iErr = 0;
      if( ptPoint1->link()->zf < ptPoint2->link()->zf )
	{
	  mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
		   ptPoint1->link(), ptPoint2->link());
       //FORTRAN_ROUTINE(mmbrel)( ArtePointer<RSEG_RBEG>::getLink().getRef(), 
	  //		   &irow1,
	  //		   &irow2);
        }else{
	  mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
		   ptPoint2->link(), ptPoint1->link());
       //FORTRAN_ROUTINE(mmbrel)( ArtePointer<RSEG_RBEG>::getLink().getRef(), 
	  //		   &irow2,
	  //		   &irow1);
        }
    }else{
      arteMsg << "MARPLE: unable to save relation RSEG_RBEG" ;
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}

//-----------------------------------------------------------------
// RSEG-RCCL relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcSegPoint, RcClusPoint>::saveRelation( 
                                                 const RcSegPoint * ptPoint1,
						 const RcClusPoint * ptPoint2,
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RSEG>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RSEG::rccl);
      //FORTRAN_ROUTINE(mmbrel)( ArtePointer<RSEG_RCCL>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RSEG_RCCL" ;
      arteMsg.allp();
    }
  return ;
}

void RcMatchBuilder< RcClusPoint, RcSegPoint>::saveRelation( 
                                                 const RcClusPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RCCL>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RSEG::rccl);
      //FORTRAN_ROUTINE(mmbrel)( ArtePointer<RCCL_RSEG>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RCCL_RSEG" ;
      arteMsg.allp();
    }
  return ;
}

//-----------------------------------------------------------------
// RTRA-RSEG relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcTraPoint, RcSegPoint>::saveRelation( 
                                                 const RcTraPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RTRA::rseg);
      //FORTRAN_ROUTINE(mmbrel)(
      //		      ArtePointer<RTRA_RSEG>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RTRA_RSEG" ; 
      arteMsg.allp();
    }
  return ;
}

void RcMatchBuilder< RcSegPoint, RcTraPoint>::saveRelation( 
                                                 const RcSegPoint * ptPoint1,
						 const RcTraPoint * ptPoint2,
						 int & iErr) const
{
  // replace ptPoint1 and ptPoint2
  int irow1 = ptPoint2->link().index();  // row in RTRA table
  int irow2 = ptPoint1->link().index();  // row in RSEG table

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RTRA::rseg);
      //FORTRAN_ROUTINE(mmbrel)(
      //		      ArtePointer<RTRA_RSEG>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RTRA_RSEG" ; 
      arteMsg.allp();
    }
  return ;
}

//-----------------------------------------------------------------
// RTRA-RCCL relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcTraPoint, RcClusPoint>::saveRelation( 
                                                 const RcTraPoint * ptPoint1,
						 const RcClusPoint * ptPoint2,
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RTRA::rccl);
      //FORTRAN_ROUTINE(mmbrel)(
      //		      ArtePointer<RTRA_RCCL>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      arteMsg << "MARPLE: unable to save relation RTRA_RCCL" ; 
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}

void RcMatchBuilder< RcClusPoint, RcTraPoint>::saveRelation( 
                                                 const RcClusPoint * ptPoint1,
						 const RcTraPoint * ptPoint2,
						 int & iErr) const
{
  //replace ptPoint1 and ptPoint2
  int irow1 = ptPoint2->link().index(); // row in RTRA table
  int irow2 = ptPoint1->link().index(); // row in RCCl table

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() )
    {
      createRelation( ptPoint1->link(), ptPoint2->link(), &RTRA::rccl);
      //FORTRAN_ROUTINE(mmbrel)(
      //		      ArtePointer<RTRA_RCCL>::getLink().getRef(), 
      //		      &irow1,
      //		      &irow2);
      iErr = 0;
    }else{
      arteMsg << "MARPLE: unable to save relation RTRA_RCCL" ; 
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}
//-------------------------------------------------------------
//-------------------------------------------------------------
//
//  Now we save relations between matched objectes 
//  and also between them and match rseg
//
//-------------------------------------------------------------
//-------------------------------------------------------------



void RcMatchBuilder< RcSegPoint, RcSegPoint>::saveRelationWithMatch( 
                                                 const RcSegPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 ArtePointer<RSEG> rseg,
						 int & iErr) const
{
  //unsigned int irow1 = ptPoint1->link().index();
  //unsigned int irow2 = ptPoint2->link().index();
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RSEG>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      iErr = 0;
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint1->link());
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint2->link());
    }else{
      arteMsg << "MARPLE: unable to save relation RSEG_RBEG" ;
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}

//-----------------------------------------------------------------
// RSEG-RCCL relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcSegPoint, RcClusPoint>::saveRelationWithMatch( 
                                                 const RcSegPoint * ptPoint1,
						 const RcClusPoint * ptPoint2,
						 ArtePointer<RSEG> rseg,
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RSEG>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint1->link());
      createRelation( rseg, ptPoint2->link(), &RSEG::rccl);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RSEG_RCCL" ;
      arteMsg.allp();
    }
  return ;
}

void RcMatchBuilder< RcClusPoint, RcSegPoint>::saveRelationWithMatch( 
                                                 const RcClusPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 ArtePointer<RSEG> rseg, 
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RCCL>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint2->link());
      createRelation( rseg, ptPoint1->link(), &RSEG::rccl);
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RCCL_RSEG" ;
      arteMsg.allp();
    }
  return ;
}

//-----------------------------------------------------------------
// RTRA-RSEG relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcTraPoint, RcSegPoint>::saveRelationWithMatch( 
                                                 const RcTraPoint * ptPoint1,
						 const RcSegPoint * ptPoint2,
						 ArtePointer<RSEG> rseg, 
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( rseg, ptPoint1->link(),  &RTRA::rseg);
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint2->link());
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RTRA_RSEG" ; 
      arteMsg.allp();
    }
  return ;
}

void RcMatchBuilder< RcSegPoint, RcTraPoint>::saveRelationWithMatch( 
                                                 const RcSegPoint * ptPoint1,
						 const RcTraPoint * ptPoint2,
						 ArtePointer<RSEG> rseg, 
						 int & iErr) const
{
  // replace ptPoint1 and ptPoint2
  int irow1 = ptPoint2->link().index();  // row in RTRA table
  int irow2 = ptPoint1->link().index();  // row in RSEG table
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RSEG>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( rseg, ptPoint2->link(),  &RTRA::rseg);
      mmbrel_( ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
	       rseg, ptPoint1->link());
      iErr = 0;
    }else{
      iErr = 1;
      arteMsg << "MARPLE: unable to save relation RTRA_RSEG" ; 
      arteMsg.allp();
    }
  return ;
}

//-----------------------------------------------------------------
// RTRA-RCCL relation 
//-----------------------------------------------------------------

void RcMatchBuilder< RcTraPoint, RcClusPoint>::saveRelationWithMatch( 
						 const RcTraPoint * ptPoint1,
						 const RcClusPoint * ptPoint2,
						 ArtePointer<RSEG> rseg, 
						 int & iErr) const
{
  int irow1 = ptPoint1->link().index();
  int irow2 = ptPoint2->link().index();
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( rseg, ptPoint1->link(),  &RTRA::rseg);
      createRelation( rseg, ptPoint2->link(),  &RCCL::rseg);
      iErr = 0;
    }else{
      arteMsg << "MARPLE: unable to save relation RTRA_RCCL" ; 
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}

void RcMatchBuilder< RcClusPoint, RcTraPoint>::saveRelationWithMatch( 
                                                 const RcClusPoint * ptPoint1,
						 const RcTraPoint * ptPoint2,
						 ArtePointer<RSEG> rseg, 
						 int & iErr) const
{
  //replace ptPoint1 and ptPoint2
  int irow1 = ptPoint2->link().index(); // row in RTRA table
  int irow2 = ptPoint1->link().index(); // row in RCCl table
  int irow3 = rseg.index();

  if( irow1 >0 && irow1 <= (int)ArtePointer<RTRA>::nrow() &&
      irow2 >0 && irow2 <= (int)ArtePointer<RCCL>::nrow() &&
      irow3 >0 && irow3 <= (int)ArtePointer<RSEG>::nrow() )
    {
      createRelation( rseg, ptPoint2->link(),  &RTRA::rseg);
      createRelation( rseg, ptPoint1->link(),  &RCCL::rseg);
      iErr = 0;
    }else{
      arteMsg << "MARPLE: unable to save relation RTRA_RCCL" ; 
      arteMsg.allp();
      iErr = 1;
    }
  return ;
}

