*  B.Fominykh  16.07.97
* make a Kalman filter seed and write it as a new branch
*
* input:  IPP(4)    - pointers to MU3 and MU4 pad or pixel clusters
*         IPW(4)    - pointers to MU3 and MU4 wire clusters
* output: IOUT      =0 O.K., =1 problems
C
      SUBROUTINE MURBRSD(IPP,IPW,IOUT)
C-    ================================
      IMPLICIT NONE
#include "murec/MUCONT.fi"
#include "murec/MUCKALF.fi"
#include "arte/Arte.fi"
      INTEGER IPP(4),IPW(4),IPS(8)
      INTEGER IFS,JFS,ILS,JLS,IFP,JFP,NSP,I,J,JJ
      REAL YSP,ZZ,TX,TY,CX,CY,Z1,Z2
      INTEGER ICC,IC,JC,ITP,IOUT,ICL1,JCL1,ICL2,JCL2
      REAL ERMSC1,ERMSC2,THETS,CHI,CHI1,CHI2,DD,DD1,DD2,SIGE
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      IFS=0
      ILS=0
      IFP=0
      DO I=1,4
        DO J=1,4
          COV(I,J)=0.
        ENDDO
      ENDDO
* pad or pixel seed?
      DO I=1,4
       IF(IPW(I).GT.0) GOTO 5
      ENDDO
* pixels
      CALL VZERO(IPS,8)
      ICL1=IPP(1)
      IPS(1)=ICL1
      ICL2=IPP(2)
      IPS(2)=ICL2
      JCL1=JTMP8+IQ(JTMP8+1)*(ICL1-1)+2
      JCL2=JTMP8+IQ(JTMP8+1)*(ICL2-1)+2
      ZZ=Q(JCL1+6)
      TX=(Q(JCL1+8)-Q(JCL2+8))/(Q(JCL1+6)-Q(JCL2+6))
      TY=(Q(JCL1+9)-Q(JCL2+9))/(Q(JCL1+6)-Q(JCL2+6))
      CX=Q(JCL1+8)
      CY=Q(JCL1+9)
      COV(1,1)=Q(JCL1+11)**2
      COV(2,2)=Q(JCL1+12)**2
      GOTO 10
  5   CONTINUE
* pads - combine all clusters together
      IPS(8)=IPW(1)
       IPS(7)=IPP(1)
        IPS(6)=IPP(2)
         IPS(5)=IPW(2)
          IPS(4)=IPW(3)
           IPS(3)=IPP(3)
            IPS(2)=IPP(4)
             IPS(1)=IPW(4)
* initial parameters for Kalman filter
      IFS=0
      IFP=0
      YSP=0.
      NSP=0
      DO I=1,4
        IF(IFS.EQ.0.AND.IPW(I).GT.0) IFS=I
        IF(IPW(I).GT.0) ILS=I
        IF(IPP(I).GT.0) THEN
          IF(IFP.EQ.0) IFP=I
          NSP=NSP+1
          JJ=JTMP8+IQ(JTMP8+1)*(IPP(I)-1)+2
          YSP=YSP+Q(JJ+9)
        ENDIF
      ENDDO
      JFS=JTMP8+IQ(JTMP8+1)*(IPW(IFS)-1)+2
      JFP=JTMP8+IQ(JTMP8+1)*(IPP(IFP)-1)+2
      JLS=JTMP8+IQ(JTMP8+1)*(IPW(ILS)-1)+2
      TX=(Q(JLS+8)-Q(JFS+8))/(Q(JLS+6)-Q(JFS+6))
      TY=0.
      CY=YSP/FLOAT(NSP)
      COV(1,1)=Q(JFS+11)**2
      COV(2,2)=Q(JFP+12)**2
*
      DO ICC=1,8
        IF(IPS(ICC).GT.0) THEN
          IC=IPS(ICC)
          JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
          ZZ=Q(JC+6)
          CX=Q(JC+8)
          GOTO 10
        ENDIF
      ENDDO
 10   CONTINUE
* 
* debug print
      IF(IPRSC.GE.3)
     + PRINT 1001,(IPS(J),J=1,8),IFS,ILS,NSP,ZZ,CX,CY,TX,TY
      IF(IPRLG.GE.3)
     + WRITE(LLOGF,1001) (IPS(J),J=1,8),IFS,ILS,IFP,NSP,ZZ,CX,CY,TX,TY
 1001 FORMAT(3X,'IPS:',8I4,' IFS,ILS,IFP',3I2,' NSP',I2,/,
     +       5X,'Z0,Cx,Cy,Tx,Ty',F8.1,2F8.2,2F8.3)
*
* initialization
      PARAM(1)=ZZ
      PARAM(2)=CX
      PARAM(3)=CY
      PARAM(4)=TX
      PARAM(5)=TY
      COV(3,3)=1.E-4
      COV(4,4)=3.E-4
* loops over clusters
      Z2=0.
      CHI=0.
      DO 100 ICC=1,8
        IF(IPS(ICC).LE.0) GOTO 100
        IC=IPS(ICC)
        JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
* calculate multiple scattering error
        IF(Z2.GT.0.) THEN
          Z1=Z2
        ELSE
          Z1=Q(JC+6)
        ENDIF
        Z2=Q(JC+6)
        CALL MURMSC(Z1,Z2,ERMSC1,ERMSC2,THETS)
*
        ITP=IQ(JC+5)
* the case of wire
        IF(ITP.EQ.1) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JC+6)
          SINROT =Q(JC+7)
          COSROT =SQRT(1.-SINROT*SINROT)
          DMEAS=Q(JC+8)
          SMEAS=Q(JC+11)
          ITMEAS=1
          IF(SINROT.NE.0.) ITMEAS=3
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD,SIGE,CHI1)
          CHI=CHI+CHI1
          GOTO 100
        ENDIF
*
* the case of pads and pixels
        IF(ITP.EQ.2.OR.ITP.EQ.3) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JC+6)
          SINROT =0.
          COSROT =1.
          DMEAS=Q(JC+8)
          SMEAS=Q(JC+11)
          ITMEAS=1
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD1,SIGE,CHI1)
*
          DMEAS=Q(JC+9)
          SMEAS=Q(JC+12)
          ITMEAS=2
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD2,SIGE,CHI2)
          CHI=CHI+CHI1+CHI2
        ENDIF
 100  CONTINUE
*
      IF(IPRSC.GE.3)
     + PRINT 1002, (PARAM(J),J=1,5),CHI,
     +                  ((COV(I,J),I=1,4),J=1,4)
      IF(IPRLG.GE.3)
     + WRITE(LLOGF,1002) (PARAM(J),J=1,5),CHI,
     +                  ((COV(I,J),I=1,4),J=1,4)
 1002 FORMAT(3X,'Z0,Cx,Cy,Tx,Ty:',5E10.3,' chi',E9.2,
     +         4(/,10X,4E12.4))
*
* write the seed as a new branch 
      CALL MURBRIN(8,IPS,CHI,IOUT)
*
 999  CONTINUE
      RETURN
      END




