*
* B.Fominykh  16.05.97
* updated 10.04.99 - small change for safety
*
* the program of the MUREC-A package
* z-positions of existing detectors
* reco layers: 10+8+10+10=38
* this routine is dependent on the geometry version
* 
      SUBROUTINE MURZDIN
*     ==================
      IMPLICIT NONE
      INTEGER IV,ICMP,ISL,MGSL,MUSL,LAY,I,IJ
      REAL ZD1,ZD2,DZ,YD1,YD2
*
#include "murec/MUCZDT.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      DO I=1,NMRLAY
        ZMUDT1(I)=0.
        ZMUDT2(I)=0.
      ENDDO
* number of superlayers
      MGSL = IQ(JGESL+2)
* loop over all  superlayers
      DO 100 ISL = 1,MGSL
* type of superlayer, muon types (8 and 9) are only acceptable
        ICMP = IGESL_CMP(ISL)
        IF(ICMP.NE.8.AND.
     +     ICMP.NE.9) GOTO 100
* muon superlayer number
        MUSL = IGESL_NSL(ISL)
* loops over detectors inside superlayer
        DO 50 IJ = 1, IGESL_NPL(ISL)
          IV = IGESL_FPL(ISL)+IJ-1
* layer number inside superlayer
          LAY=IGEDE_LAY(IV)
          IF(LAY.LT.1.OR.LAY.GT.4) GOTO 50
* get parameters of volume IV
          ZD1 =  FGEDE_ZMIN(IV)
          ZD2 =  FGEDE_ZMAX(IV)
          YD1 =  FGEDE_YMIN(IV)
          YD2 =  FGEDE_YMAX(IV)
*
          IF(MUSL.EQ.1) THEN
            IF(LAY.GT.1) THEN
              I=2*LAY+1
            ELSE
              IF(ABS(YD1).GE.ABS(YD2)) THEN
                I=3
              ELSE
                I=1
              ENDIF
            ENDIF
            GOTO 20
          ENDIF

          IF(MUSL.EQ.2) THEN
            I=9+2*LAY
            GOTO 20
          ENDIF

          IF(MUSL.EQ.3.OR.MUSL.EQ.4) THEN
            IF(LAY.EQ.1) I=19+10*(MUSL-3)
            IF(LAY.EQ.2) I=27+10*(MUSL-3)
            GOTO 20
          ENDIF

          GOTO 50
  20      CONTINUE
          IF(ZMUDT1(I).EQ.0.) THEN
            ZMUDT1(I)=ZD1
            ZMUDT2(I)=ZD2
            MUSLDT(I)  =MUSL
            MUSLDT(I+1)=MUSL
            IF(MUSL.EQ.3.OR.MUSL.EQ.4) THEN
              IF(LAY.EQ.1) THEN
                MUSLDT(I+2)=MUSL
                MUSLDT(I+3)=MUSL
              ENDIF
            ENDIF
            GOTO 50
          ELSE
            IF(MUSL.EQ.3.OR.MUSL.EQ.4) THEN
              IF(LAY.EQ.1)  THEN
                IF(ZD1.EQ.ZMUDT1(I))    GOTO 50
                IF(ZD1.EQ.ZMUDT1(I+1))  GOTO 50
                IF(ZD1.EQ.ZMUDT1(I+2))  GOTO 50
                IF(ZD1.EQ.ZMUDT1(I+3))  GOTO 50
                IF(ZMUDT1(I+1).EQ.0..AND.ZD1.GE.ZMUDT2(I)) THEN
                   ZMUDT1(I+1)=ZD1
                   ZMUDT2(I+1)=ZD2
                  GOTO 50
              ENDIF
              IF(ZMUDT1(I+2).EQ.0..AND.ZD1.GE.ZMUDT2(I+1)) THEN
                 ZMUDT1(I+2)=ZD1
                 ZMUDT2(I+2)=ZD2
                GOTO 50
              ENDIF
              IF(ZMUDT1(I+3).EQ.0..AND.ZD1.GE.ZMUDT2(I+2)) THEN
                 ZMUDT1(I+3)=ZD1
                 ZMUDT2(I+3)=ZD2
                GOTO 50
              ENDIF
              GOTO 50
            ENDIF
            ENDIF

            IF(ZD1.EQ.ZMUDT1(I))    GOTO 50
            IF(ZD1.EQ.ZMUDT1(I+1))  GOTO 50
            IF(ZD1+0.05.GE.ZMUDT2(I).AND.ZMUDT1(I+1).EQ.0.) THEN
              ZMUDT1(I+1)=ZD1
              ZMUDT2(I+1)=ZD2
              GOTO 50
            ENDIF
            IF(ZD2-0.05.LE.ZMUDT1(I).AND.ZMUDT1(I+1).EQ.0.) THEN
              ZMUDT1(I+1)=ZMUDT1(I)
              ZMUDT2(I+1)=ZMUDT2(I)
              ZMUDT1(I)=ZD1
              ZMUDT2(I)=ZD2
              GOTO 50
            ENDIF
            GOTO 50
          ENDIF
  50    CONTINUE
 100  CONTINUE

*      WRITE(LLOGF,1001) (ZMUDT1(J),J=1,NMRLAY)
* 1001 FORMAT(X,'Z1:',10F7.1)
*      WRITE(LLOGF,1002) (ZMUDT2(J),J=1,NMRLAY)
* 1002 FORMAT(X,'Z2:',10F7.1)

* separate wires and pads in pad chambers
      DO I=1,4
        ZMUDT1(27-2*I)=ZMUDT1(23-I)
        ZMUDT1(28-2*I)=ZMUDT1(23-I)
        ZMUDT1(37-2*I)=ZMUDT1(33-I)
        ZMUDT1(38-2*I)=ZMUDT1(33-I)
        MUSLDT(22+I)=MUSLDT(18+I)

        ZMUDT2(27-2*I)=ZMUDT2(23-I)
        ZMUDT2(28-2*I)=ZMUDT2(23-I)
        ZMUDT2(37-2*I)=ZMUDT2(33-I)
        ZMUDT2(38-2*I)=ZMUDT2(33-I)
        MUSLDT(32+I)=MUSLDT(28+I)
      ENDDO
      DO I=1,4
        DZ=0.5*(ZMUDT2(17+2*I)-ZMUDT1(17+2*I))
        ZMUDT2(17+2*I)=ZMUDT2(17+2*I)-DZ-0.05
        ZMUDT1(18+2*I)=ZMUDT1(18+2*I)+DZ+0.05
        DZ=0.5*(ZMUDT2(27+2*I)-ZMUDT1(27+2*I))
        ZMUDT2(27+2*I)=ZMUDT2(27+2*I)-DZ-0.05
        ZMUDT1(28+2*I)=ZMUDT1(28+2*I)+DZ+0.05
      ENDDO
      DO I=1,NMRLAY
        IF(ABS(ZMUDT1(I)).LT.1000.) ZMUDT1(I)=0.
        IF(ABS(ZMUDT2(I)).LT.1000.) ZMUDT2(I)=0.
      ENDDO
*
*      WRITE(LLOGF,1001) (ZMUDT1(J),J=1,NMRLAY)
*      WRITE(LLOGF,1002) (ZMUDT2(J),J=1,NMRLAY)
*

 200  CONTINUE
      RETURN
      END
