// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include <math.h>
#include "arte/arte.hh"
#include "rang/Fit.hh"
#include "rang/seg2track.hh"
#include "rang/tfmt2seg.hh"
#include "rang/tffhist.hh"
#include "rang/Geom.hh"
#include "rang/rginit.hh"


extern "C" {
  int rgfit_(const int& rs,const int &elec_corr){
    if (ArtePointer<RSEG>::nrow() <= 0) return 0;

    // geometry initialization
    rginit_();
    rangerGeom::condUpdate();

    ArtePointer<RSEG> rseg(rs);
    int fitStatus = (elec_corr) ? rangerFit(rseg,ELECTRON) : rangerFit(rseg);
    return fitStatus;
  }
}

