// 
//  Author:  Rainer Mankel                     Created:  11-Jun-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/DomLay.hh"
#include "rang/ProxyLay.hh"
#include "arte/arte.hh"

extern "C" {
  void rghlcr_(rangerDomLay* const & dl,
	       const int& tMode,
	       const double& z,const double& x,const double& y,
	       const double& tx,const double& ty,
	       const int& maxHits,
	       ArtePointer<HITB>* hitVec,
	       int& nHits);
}


extern "C" {
  void rghlcrpr_(rangerDomLay*& dl,
		 const int& tMode,
		 const double& z,const double& x,const double& y,
		 const double& tx,const double& ty,
		 const int& maxHits,
		 ArtePointer<HITB>* hitVec,
		 int& nHits) {

    nHits = 0;

    // get hitlist for dl
    rghlcr_(dl,tMode,z,x,y,tx,ty,maxHits,hitVec,nHits);

    // loop over proxy layers
    for (vector<rangerProxyLay*>::iterator pli=dl->proxylay().begin();
	 pli != dl->proxylay().end(); ++pli) {
      if ((*pli)->inside((float) y)) {
	int nHit1 = 0;
	rghlcr_((*pli)->tolay(),tMode,z,x,y,tx,ty,
		maxHits-nHits,&(hitVec[nHits]),nHit1);
	cout << "rghlcrpr: " << nHit1 << " proxy hits added" 
	     << " to " << nHits << " existing hits" << endl;
	nHits += nHit1;
      }
    }
  }
}
