// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/SeedTableau.hh"
#include "rang/DomObj.hh"
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgstabl_(const int& maxTab,
		rangerSeedTableau* tabVec[],
		int dirVec[],
		int& nTab) {

    if (!rangerDO) {
      cout << "rgstabl: rangerDO=" << rangerDO << endl;
      return;
    }

    nTab = 0;

    // loop over tableaus
    for (vector<rangerSeedTableau*>::iterator sti=rangerDO->stab().begin();
	 sti != rangerDO->stab().end(); ++sti) {
      if (nTab < maxTab) {
	tabVec[nTab] = (*sti);
	dirVec[nTab] = (*sti)->direction();
	++nTab;
      }
      else {
	arteMsg << "rgstabl: overflowing nTab=" << nTab << endl;
	arteMsg.warn();
	break;
      }
    }
  }
}




    



