// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/rgtabss.hh"
#include "rang/SeedTableau.hh"
#include "rang/SeedSet.hh"
#include "rang/DomWin.hh"

extern "C" {
  rangerSeedSet* rgtabssw_(rangerDomWin*& dw,rangerSeedTableau*& st,
			   const int& method) {
    rangerSeedSet* svec[100];
    int nseed = 0;
//     cout << "rgtabssw: call rgtabss" << endl;
    rgtabss_(st,method,100,svec,nseed);
//     cout << "rgtabssw: rgtabss returns nseed=" << nseed << endl;

    for (int i=0; i<nseed; ++i) {
//       cout << "check seed " << svec[i] << endl;
//       cout << "          window " << svec[i]->win() << endl;
      if (svec[i]->win() == dw) {
// 	cout << "seed found" << endl;
	return svec[i];
      }
    }

    cout << " rgtabssw: seed set not found " << endl;
    return 0;
  }
}
