*-- Author :    Rainer Mankel   21/10/96
*-- changed:    A. Spiridonov   24/02/98

#define NEWNAV

#ifdef NEWNAV
      subroutine tftranFn(target_domain,dz,izf,jzf,istat)
#else
      subroutine tftranF(target_domain,dz,izf,jzf,istat)
#endif

*     **** fast version for transport matrix
      implicit none
#include "arte/Arte.fi"
      integer izf, jzf, istat, ii, jj, kk, ll,
     +        mm,iii,jjj,ndimmag,ipl,imc,mimp,nnmimp,target_domain
      parameter (ndimmag=5)
      double precision dz, z_target, z_domain, rrstart
      real pnoise, dnoise
      double precision sum, dzd

#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zcut.fi"
#include "rang/zma.fi"
#include "pris/hgmagnhelp.fi"

      double precision f (ndimmag,ndimmag), f1(ndimmag,ndimmag),
     +       f2(ndimmag,ndimmag)
      double precision x_border(ndimmag)

#include "auto/HITB.fi"
#include "auto/GEDE.fi"
#include "auto/GESL.fi"
#include "auto/MIMP.fi"

      double precision fT,Tx2,Ty2,Txy,Ax,Ay
     +    ,Tx,Ty,d_z,c,qp,cd_z,cd_z2,Axqp,Ayqp
      real H(3),Xh(3)

      integer if_last,if_start,if_update, db

#ifdef NEWNAV
      integer rgdomnb
      real rgzdom
#endif

      real H_last(3),X_last(3),Dx_max,Dy_max,Dz_max
      save H_last,X_last

      data c / 0.00029975d0/                     ! assume field in kG
      data Dx_max/0.2/,Dy_max/0.1/,Dz_max/0.1/
**      data Dx_max/2.0/,Dy_max/1.0/,Dz_max/1.0/
      data X_last/3*1.2345e10/

      double precision rk_error(2)
      data rk_error/0.005,0.01/

      double precision f13,f15,f24,f25,f35,f45,x,y,z
      double precision F_1,F_2,F_3
      double precision G_1,G_2,G_3
      double precision FL_1,FL_2,FL_3
      double precision GL_1,GL_2,GL_3

      double precision c11 , c12 , c13 , c14 , c15
      double precision       c22 , c23 , c24 , c25
      double precision             c33 , c34 , c35
      double precision                   c44 , c45
      double precision                         c55
 
      double precision g11 , g12 , g13 , g14 , g15
      double precision g21 , g22 , g23 , g24 , g25
      double precision g31 , g32 , g33 , g34 , g35
      double precision g41 , g42 , g43 , g44 , g45
      double precision g51 , g52 , g53 , g54 , g55

      equivalence (f13,f(1,3)),(f15,f(1,5)),(f24,f(2,4))
     +           ,(f25,f(2,5)),(f35,f(3,5)),(f45,f(4,5))

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEDE.ff"
#include "auto/GESL.ff"
#include "auto/MIMP.ff"

      F_1(x,y,z) = x + f13*y + f15*z
      F_2(x,y  ) = x + f24*y 
      F_3(x,y  ) = x + f35*y

      G_1(x,y,z) = x + f13*y  + f15*z
      G_2(x,y  ) = x + f24*y 
      G_3(x,y  ) = x + f35*y
*
      FL_1(x,y,z) = x + f13*y 
      FL_2(x,y  ) = x + f24*y 
      FL_3(x,y  ) = x 

      GL_1(x,y,z) = x + f13*y 
      GL_2(x,y  ) = x + f24*y 
      GL_3(x,y  ) = x 
*
*================================================================

*

      istat = 0
      ipl = plane_zf(izf)

      z_target = z_zf(izf) + dz

#ifdef NEWNAV
      z_domain = rgzdom(target_domain)
      db = rgdomnb(target_domain)
#else
      z_domain = z_dm(target_domain)
      db = target_domain
#endif

      d_z = z_target - z_domain


        if(cx_db(4,4,db).lt.0.) then
        print '("tftranf z1,z2 ",f9.3,f9.3)',z_target,z_domain        
        print '("cxd 1:",5(e11.4))',(cx_db(1,ii,db),ii=1,5)
        print '("cxd 2:",5(e11.4))',(cp_zf(2,ii,db),ii=1,5)
        print '("cxd 3:",5(e11.4))',(cp_zf(3,ii,db),ii=1,5)
        print '("cxd 4:",5(e11.4))',(cp_zf(4,ii,db),ii=1,5)
        print '("cxd 5:",5(e11.4))',(cp_zf(5,ii,db),ii=1,5)
        end if
*                                                             #ifdef RT_TEST
      if (amax1(sngl(z_domain),sngl(z_target)).lt.zmin_mag_zfpar
     +     .or.amin1(sngl(z_domain),sngl(z_target)).gt.zmax_mag_zfpar)
     +                                                          then
        if_start = 1
      else
        if_start = 0
      endif
*                                                              #endif
*      if_start = 0
*      if( dabs(d_z).lt.0.5/dabs(x_db(5,db)) )  if_start = 1 
*      if( dabs(d_z).lt.1./dabs(x_db(5,db)) )  if_start = 1 

      if_update = 1

      if(cx_db(3,3,db)/cx_db(1,1,db)
     + * d_z * d_z .lt. 0.01) if_update = 0

      IF (if_start*0.eq.0.) THEN   ! start of magnet tracking

        if (abs(sngl(d_z)).lt.dzpara_mag_zfpar) then
*
          Xh(1) = x_db(1,db)  
          Xh(2) = x_db(2,db)   
          Xh(3) = z_domain 

          if_last = 0
          if(abs(Xh(3)-X_last(3)).lt.Dz_max) then
            if(abs(Xh(1)-X_last(1)).lt.Dx_max) then
              if(abs(Xh(2)-X_last(2)).lt.Dy_max) then
                H(1) = H_last(1)
                H(2) = H_last(2)
                H(3) = H_last(3)
                if_last = 1
              end if
            end if
          end if
*      
          if(if_last.eq.0) then
            call utfeld(Xh,H)
            X_last(1) = Xh(1)
            X_last(2) = Xh(2)
            X_last(3) = Xh(3)
            H_last(1) = H(1)
            H_last(2) = H(2)
            H_last(3) = H(3)
          end if
*      
          Tx = x_db(3,db)
          Ty = x_db(4,db)
          qp = x_db(5,db)
          Tx2= Tx*Tx
          Ty2= Ty*Ty
          Txy= Tx*Ty
          fT = dsqrt( 1.d0 + Tx2 + Ty2 )
          cd_z = c * d_z
          cd_z2= cd_z * d_z * 0.5
          Ax  = fT * ( Txy       *H(1) - (1.d0+Tx2) * H(2) + Ty*H(3) )
          Ay  = fT * ( (1.d0+Ty2)*H(1) - Txy        * H(2) - Tx*H(3) )
          Axqp = Ax * qp
          Ayqp = Ay * qp
*
          xp_zf(1,jzf) = x_db(1,db) + Tx*d_z + Axqp*cd_z2
          xp_zf(2,jzf) = x_db(2,db) + Ty*d_z + Ayqp*cd_z2
          xp_zf(3,jzf) = Tx + Axqp * cd_z
          xp_zf(4,jzf) = Ty + Ayqp * cd_z
          xp_zf(5,jzf) = qp
*
          f13         = d_z
          f15         = Ax * cd_z2
          f24         = d_z 
          f35         = Ax * cd_z
*
        else if (abs(sngl(d_z)).lt.dzpara_mag_zfpar*3.) then

          call rk4fast(z_domain,x_db(1,db),z_target
     +          ,xp_zf(1,jzf),f,istat)
*
        else
*
          call rk5fast(z_domain,x_db(1,db),rk_error
     +         ,z_target, xp_zf(1,jzf),f,istat)
*
        endif
        if (istat.lt.0) then
           print *,' tftranF: transport impossible (rk) '
           go to 999
        endif
*
      ELSE                                !  end of tracking inside magnet
*
        Tx = x_db(3,db)
        Ty = x_db(4,db)
        xp_zf(1,jzf) = x_db(1,db) + Tx*d_z 
        xp_zf(2,jzf) = x_db(2,db) + Ty*d_z 
        xp_zf(3,jzf) = Tx 
        xp_zf(4,jzf) = Ty 
        xp_zf(5,jzf) = x_db(5,db)

      END IF                              ! end of tracking outside magnet 
*
*     **** step 3: propagate cov matrix

      pnoise = 1./dabs(xp_zf(5,jzf))
      pnoise = amax1(pnoise,1.)

      if (fgede_ms(ipl).gt.0.) then
       dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
      elseif (igede_cmp(ipl).eq.3) then
*      **** temporary: use old MSGC value until new value available
       dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
      else
       print *,' () tftranF: no fgede_ms for ipl=', ipl
       dnoise = 0.
      endif
*
      if(if_update.ne.0) then
      c11 = cx_db(1,1,db)
      c12 = cx_db(1,2,db)
      c13 = cx_db(1,3,db)
      c14 = cx_db(1,4,db)
      c15 = cx_db(1,5,db)
      c22 = cx_db(2,2,db)
      c23 = cx_db(2,3,db)
      c24 = cx_db(2,4,db)
      c25 = cx_db(2,5,db)
      c33 = cx_db(3,3,db) + dnoise 
      c34 = cx_db(3,4,db)
      c35 = cx_db(3,5,db)
      c44 = cx_db(4,4,db) + dnoise
      c45 = cx_db(4,5,db)
      c55 = cx_db(5,5,db)
      end if
*
      IF(if_start*0.eq.0.and.if_update.ne.0) THEN     !  update in field
*
        g11 = F_1( c11 , c13 , c15 )
        g12 = F_1( c12 , c23 , c25 )
        g13 = F_1( c13 , c33 , c35 )
        g14 = F_1( c14 , c34 , c45 )
        g15 = F_1( c15 , c35 , c55 )
        
        g21 = F_2( c12 , c14       )
        g22 = F_2( c22 , c24       )
        g23 = F_2( c23 , c34       )
        g24 = F_2( c24 , c44       )
        g25 = F_2( c25 , c45       )

        g31 = F_3( c13 , c15       )
        g32 = F_3( c23 , c25       )
        g33 = F_3( c33 , c35       )
        g34 = F_3( c34 , c45       )
        g35 = F_3( c35 , c55       )

        g41 =      c14             
        g42 =      c24             
        g43 =      c34             
        g44 =      c44             
        g45 =      c45             

        g51 =      c15             
        g52 =      c25             
        g53 =      c35             
        g54 =      c45             
        g55 =      c55             

        cp_zf(1,1,jzf) = G_1( g11 , g13 , g15 )
        cp_zf(2,1,jzf) = G_1( g21 , g23 , g25 )
        cp_zf(3,1,jzf) = G_1( g31 , g33 , g35 )
        cp_zf(4,1,jzf) = G_1( g41 , g43 , g45 )
        cp_zf(5,1,jzf) = G_1( g51 , g53 , g55 )
 
        cp_zf(1,2,jzf) = cp_zf(2,1,jzf)
        cp_zf(2,2,jzf) = G_2( g22 , g24       )
        cp_zf(3,2,jzf) = G_2( g32 , g34       )
        cp_zf(4,2,jzf) = G_2( g42 , g44       )
        cp_zf(5,2,jzf) = G_2( g52 , g54       )

        cp_zf(1,3,jzf) = cp_zf(3,1,jzf)
        cp_zf(2,3,jzf) = cp_zf(3,2,jzf)
        cp_zf(3,3,jzf) = G_3( g33 , g35       )
        cp_zf(4,3,jzf) = G_3( g43 , g45       )
        cp_zf(5,3,jzf) = G_3( g53 , g55       )

        cp_zf(1,4,jzf) = cp_zf(4,1,jzf)
        cp_zf(2,4,jzf) = cp_zf(4,2,jzf)
        cp_zf(3,4,jzf) = cp_zf(4,3,jzf)
        cp_zf(4,4,jzf) = g44             
        cp_zf(5,4,jzf) = g54             

        cp_zf(1,5,jzf) = cp_zf(5,1,jzf)
        cp_zf(2,5,jzf) = cp_zf(5,2,jzf)
        cp_zf(3,5,jzf) = cp_zf(5,3,jzf)
        cp_zf(4,5,jzf) = cp_zf(5,4,jzf)
        cp_zf(5,5,jzf) =  g55             
*
#ifdef RT_TEST
      ELSE IF (if_start.eq.1.and.if_update.ne.0) then  ! update out of field

        g11 = FL_1( c11 , c13 , c15 )
        g12 = FL_1( c12 , c23 , c25 )
        g13 = FL_1( c13 , c33 , c35 )
        g14 = FL_1( c14 , c34 , c45 )
        g15 = FL_1( c15 , c35 , c55 )
        
        g21 = FL_2( c12 , c14       )
        g22 = FL_2( c22 , c24       )
        g23 = FL_2( c23 , c34       )
        g24 = FL_2( c24 , c44       )
        g25 = FL_2( c25 , c45       )

        g31 = FL_3( c13 , c15       )
        g32 = FL_3( c23 , c25       )
        g33 = FL_3( c33 , c35       )
        g34 = FL_3( c34 , c45       )
        g35 = FL_3( c35 , c55       )

        g41 =      c14             
        g42 =      c24             
        g43 =      c34             
        g44 =      c44             
        g45 =      c45             

        g51 =      c15             
        g52 =      c25             
        g53 =      c35             
        g54 =      c45             
        g55 =      c55             

        cp_zf(1,1,jzf) = GL_1( g11 , g13 , g15 )
        cp_zf(2,1,jzf) = GL_1( g21 , g23 , g25 )
        cp_zf(3,1,jzf) = GL_1( g31 , g33 , g35 )
        cp_zf(4,1,jzf) = GL_1( g41 , g43 , g45 )
        cp_zf(5,1,jzf) = GL_1( g51 , g53 , g55 )
 
        cp_zf(1,2,jzf) = cp_zf(2,1,jzf)
        cp_zf(2,2,jzf) = GL_2( g22 , g24       )
        cp_zf(3,2,jzf) = GL_2( g32 , g34       )
        cp_zf(4,2,jzf) = GL_2( g42 , g44       )
        cp_zf(5,2,jzf) = GL_2( g52 , g54       )

        cp_zf(1,3,jzf) = cp_zf(3,1,jzf)
        cp_zf(2,3,jzf) = cp_zf(3,2,jzf)
        cp_zf(3,3,jzf) = GL_3( g33 , g35       )
        cp_zf(4,3,jzf) = GL_3( g43 , g45       )
        cp_zf(5,3,jzf) = GL_3( g53 , g55       )

        cp_zf(1,4,jzf) = cp_zf(4,1,jzf)
        cp_zf(2,4,jzf) = cp_zf(4,2,jzf)
        cp_zf(3,4,jzf) = cp_zf(4,3,jzf)
        cp_zf(4,4,jzf) = g44             
        cp_zf(5,4,jzf) = g54             

        cp_zf(1,5,jzf) = cp_zf(5,1,jzf)
        cp_zf(2,5,jzf) = cp_zf(5,2,jzf)
        cp_zf(3,5,jzf) = cp_zf(5,3,jzf)
        cp_zf(4,5,jzf) = cp_zf(5,4,jzf)
        cp_zf(5,5,jzf) =  g55             
*


#endif
*
      ELSE                       ! covariance matrix without update

        do ii=1,5
          do jj=1,5
            cp_zf(ii,jj,jzf) = cx_db(ii,jj,db)
          end do
        end do
*
      END IF                    ! end of cov matrix propagation
*
        if(cp_zf(4,4,jzf).lt.0.) then
        print '("tftranf j,z1,z2",i4,2(f9.3))',jzf,z_domain,z_target        
        print '("cp 1:",5(e11.4))',(cp_zf(1,ii,jzf),ii=1,5)
        print '("cp 2:",5(e11.4))',(cp_zf(2,ii,jzf),ii=1,5)
        print '("cp 3:",5(e11.4))',(cp_zf(3,ii,jzf),ii=1,5)
        print '("cp 4:",5(e11.4))',(cp_zf(4,ii,jzf),ii=1,5)
        print '("cp 5:",5(e11.4))',(cp_zf(5,ii,jzf),ii=1,5)
        end if

      if (diag_level.ge.6) then
       print *,' tftranF: dzd, izf=',dzd,izf
       print *,' tftranF: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
       print *,' tftranF: cx_zf(,,izf)',
     +     ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
       print *,' tftranF: xp_zf=',(xp_zf(iii,jzf),iii=1,5)
       print *,' tftranF: cp_zf=',
     +     ((cp_zf(iii,jjj,jzf),iii=1,5),jjj=1,5)
      endif

 999  return
      end

       
