#if defined(USE_ARTE) && defined(USE_ROOT)

#include <iostream.h>
#include <arte/arte.hh>
#include <arte/ArteFlag.h>
#include <Arte/prototypes.hh>
#include <TString.h>
#include <CLHEP/Utilities/fortran.h>
#include <string>

#include "wax/ARTE.hh"
 
extern "C" {
  void FORTRAN_ROUTINE( kuinit )( const int &nwords );
  void FORTRAN_ROUTINE( kuexec )( char const * str, int length );
  void FORTRAN_ROUTINE( kuwhag )();
  void FORTRAN_ROUTINE( kuwhat )();
  void FORTRAN_ROUTINE( kugetr )( float & hpar );
  void FORTRAN_ROUTINE( kugeti )( int & ipar );
  void FORTRAN_ROUTINE( kugetc )( char* chpar, int & length , int );
}
  
inline void kuexec( const string& str )
{
  FORTRAN_ROUTINE(kuexec)( str.c_str(), str.length() );
}

//__________________________________________________________________
// ARTE
//
// This is the CINT interface to ARTE. Using these static functions
// you can pass a string to the arte kuip interpreter.
//
// Author: Wouter Hulsbergen && Christoph Borgmeijer
//__________________________________________________________________

ClassImp(ARTE) ;

void ARTE::kuip( char const* str )
{
  if( str!=0 ) {
    //FORTRAN_ROUTINE(kuexec)(str,strlen(str));
    kuexec( str );
  } else {
    FORTRAN_ROUTINE(kuwhat)();
  }
}

void ARTE::init()
{
  cout << "Welcome adventurer. Here you finally have it: "  << endl 
       << "           CINT instead of kuip             "    << endl 
       << "However, as the ARTE interface is heavily based" << endl 
       << "on kuip, all kuip commands are availlable via"   << endl 
       << "this `ARTE' class. Simply, type"                   << endl 
       << "           ARTE::kuip(\" <my kuip cmd> \")"      << endl 
       << "to start your familiar kuip commands. " << endl ;   
  // Call atinit
  FORTRAN_ROUTINE(atinit)();

  //CALL MEWARC (729, 'read profile commands from file profile.kumac')
  FORTRAN_ROUTINE(mewarc)(729,
			  "read profile commands from file profile.kumac",
			  32 );
  //CALL KUEXEC ('DEFAULT ''.,~/bin,hbbin'' -A')
  //CALL KUEXEC ('TRACE ON')
  kuexec("TRACE ON");
  //CALL KUEXEC ('EXEC profile')
  kuexec("EXEC profile");
			    
  //C execute program commands
  
  //C78 = PROGNAME
  //CALL CH78AC ('.kumac')
  //CALL MEWARC (285, 'read program commands from file ' // C78)
  //CALL KUEXEC ('EXEC ' // C78)

  string prog = string("EXEC ")+string(FORTRAN_COMMON(arteflag).progname);
  kuexec(prog);

  kuexec("TRACE OFF");
}

void ARTE::stop()
{
  string str("ARTE: stop in ATMAIN") ;
  FORTRAN_ROUTINE(atstop)(str.c_str(), str.length() );
} ;

#endif
