#ifndef NORMALDISTRIBUTION_HH
#define NORMALDISTRIBUTION_HH

/** The NormalDistribution class implements in private variables a few CERNLIB routines having to do with a Normal Distribution, such as the error function. **/
class NormalDistribution
{
public:
  ///
  static double Prob(double chi2, int dof) ;
  ///
  static double InvProb(double prob, int dof) ;
  ///
  static double Erf(double noSigmas) ;
  ///
  static double InvErf(double fraction) ;
  ///
  static double InvErfAlt(double fraction) ;
  ///
  static double PartialInnerWidth(double noSigmas) ;
  ///
  static double PartialOuterWidth(double noSigmas) ;
  ///
  static double PartialInnerVariance(double noSigmas) ;
  ///
  static double PartialInnerVariance(double noSigmas,int n) ;
  ///
  static double PartialOuterVariance(double noSigmas) ;
  ///
  static double PartialOuterVariance(double noSigmas,int n) ;
private:
  static double SpecialIntegral(double a, int n) ;
  static double SpecialIntegralC(double a, int n) ;
  
};

#endif
