#ifndef __OTR_ALIGNMENTPROJECTION_HH__
#define __OTR_ALIGNMENTPROJECTION_HH__

class HepVector ;
class HepSymMatrix ;
class OTrSection ;
class TH1F ;
class OTrTrackDescription ;
class OTrHit ;

#ifdef USE_ROOT
 #ifndef ROOT_Rtypes
 #include <Rtypes.h>
 #endif
#endif

class OTrAlignmentProjection
{
public:
  OTrAlignmentProjection(OTrSection*) ;
  bool Add(const OTrTrackDescription*, const OTrHit*) ;
  //bool Fit() ;
#ifdef USE_ROOT
  //ClassDef(OTrAlignmentProjection,0)
  TH1F* GetDeltaXH1() { return fDeltaXH1 ; } ;
  TH1F* GetDeltaYH1() { return fDeltaYH1 ; } ;
#endif 
private:
  OTrSection*   fSection ; // Pointer to mother section
  HepVector*    fDChi2dP ; // Derivative of chi2 to aligment parameters
  HepSymMatrix* fD2Chi2dP2 ; // Second derivative
#ifdef USE_ROOT
  TH1F* fDeltaXH1 ; // Histogram of observed (raw) X displacements
  TH1F* fDeltaYH1 ; // Histogram of observed (raw) Y displacements
#endif
};

#endif
