#ifndef __OTR_FEDBUFFER_HH__
#define __OTR_FEDBUFFER_HH__

#include "etb.h"
// #ifdef USE_ARTE
// //#ifdef USE_NEWARTE
// #include "online/etb.h"
// //#else
// // #include "etb.h"
// //#endif
// #else
//  #include "etb.h"
// #endif

/*** This is the OTr translation of the ETB_fed buffers. It makes
     dealing with the FED buffers slightly safer ***/

class OTrFedBuffer
{
public:
  ///
  OTrFedBuffer() : fRawFedBuffer(0) {} ;
  ///
  OTrFedBuffer(const ETB_fed* fb) : fRawFedBuffer(fb) {} ;
  ///
  int GetId() const { return (*fRawFedBuffer).hdr.fedid; } ;
  ///
  //int GetRecId() const { return (*fRawFedBuffer).hdr.recid; } ;
  bool GoodRecId() const { 
    return ((*fRawFedBuffer).hdr.recid && 0Xff00)==RID_NORMAL_FEDRAW ; }
  /// 
  const unsigned char* GetData() const { 
    return (const unsigned char*)((*fRawFedBuffer).data) ; } ;
  ///
  const unsigned char GetData(int chanId) const {
    return ((const unsigned char*)((*fRawFedBuffer).data))[chanId] ; };
  ///
  
private:
  ///
  const ETB_fed* fRawFedBuffer ;  
} ;
  

#endif
