#ifndef __OTR_FUNCTIONVALUE_HH__
#define __OTR_FUNCTIONVALUE_HH__

#ifndef _CLHEP_H_
#include <CLHEP/config/CLHEP.h>
#endif
#ifdef __OTR_CLASSDEF__
#ifndef ROOT_Rtypes
#include "Rtypes.h"
#endif
#endif

/** Stores the value, derivative and second derivative of a
    function at a given point */
class OTrFunctionValue
{
public:
  ///
  OTrFunctionValue():value(0.),ddx(0.),d2dx2(0.) {} ;
  ///
  OTrFunctionValue(HepDouble a, HepDouble b, HepDouble c):
    value(a),ddx(b),d2dx2(c) {} ;
  ///
  HepDouble value ;
  ///
  HepDouble ddx ;
  ///
  HepDouble d2dx2;
  /// 
  HepDouble GetValue() const { return value ; } ;
  OTrFunctionValue& operator*=(HepDouble a) {
    value *= a; ddx *= a ; d2dx2 += a; 
    return *this;
  };
#ifdef __OTR_CLASSDEF__
  ClassDef(OTrFunctionValue,0) // A calculated value
#endif
} ;

class ostream ;
ostream& operator<<(ostream& os, const OTrFunctionValue& f) ;

#endif
