*CMZ :  1.00/00 23/09/94  15.03.01  by  Fedor Ratnikov
*CMZ :  0.01/02 13/08/94  21.02.30  by  Dominik Ressing
*CMZ :  0.01/01 23/07/94  22.39.04  by  Dominik Ressing
*-- Author :    Dominik Ressing   22/07/94
************************************************************************
*
* L1CONCK
* written by Dominik Ressing, 22/07/94 18.45.28
*
* This routines action:
* - Initialize and Check connections between processors
* - Print out a table of them.
*
************************************************************************
c
      SUBROUTINE L1CONCK
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      LOGICAL tfucon(L1DEFmaxtfu),tpmcon(L1DEFmaxtpm),
     &        mcucon(L1DEFmaxmcu)
      INTEGER icon,jcon,ipcpo,num,list(20),ilis,iprc
      LOGICAL L1PRCVA
      EXTERNAL L1PRCVA
      INTEGER L1PRCPO
      EXTERNAL L1PRCPO
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      WRITE (L1LUNprn,50)
      WRITE (L1LUNprn,51)
  50  FORMAT(/' *********** Table of connections **************')
  51  FORMAT( '    processor numbers (pointers to L1PCstor) ')
      WRITE (L1LUNprn,100)
 100  FORMAT(/' PREtrigger connections to TrackFindingUnits :')
c
      DO iprc=1,L1PARnpre
         ipcpo = L1PRCPO(L1PCtpre,iprc)
         IF ( ipcpo.gt.0 ) THEN
            ilis = 1                                  ! no TFUs found
            num = L1PCstor(ipcpo+L1PCnum)             ! PRE num
            DO icon=0,L1DEFpredef(L1PREntfu,num)-1    ! loop over TFUs
               jcon = L1DEFpredef(L1PREtfus+icon,num) ! number of TFU
               IF ( L1PRCVA(L1PCttfu,jcon) ) THEN     ! TFU# valid ??
                  list(ilis) = jcon
                  L1PCstor(ipcpo+L1PCcons+ilis-1) =
     &                 L1DEFtfudef(L1TFUprcnum,jcon)  ! TFUs prc number
                  ilis = ilis + 1
               ELSE
                  WRITE (L1LUNprn,910) 'PRE',num,'TFU',jcon
               END IF
            END DO
            ilis = ilis - 1                   ! correct for last advance
            L1PCstor(ipcpo+L1PCncon) = ilis   ! number of conn. TFUs
            WRITE (L1LUNprn,900) 'PRE',num,'TFU',
     &      (list(icon),L1PCstor(ipcpo+L1PCcons+icon-1),icon=1,ilis)
         END IF
      END DO
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      WRITE (L1LUNprn,200)
 200  FORMAT(/' TrackFindingUnits connections to TrackFindingUnits :')
c
      DO iprc=1,L1PARntfu
         ipcpo = L1PRCPO(L1PCttfu,iprc)
         IF ( ipcpo.gt.0 ) THEN
            ilis = 1                                  ! no TFUs found
            num = L1PCstor(ipcpo+L1PCnum)             ! TFU ID (from l1simu.dat)
            DO icon=0,L1DEFtfutfu-1                   ! loop over connected TFUs
               jcon = L1DEFtfudef(L1TFUtfus+icon,num) ! ID of connected TFU
               IF ( jcon.ne.0 ) THEN                  ! connection used ??
               IF ( L1PRCVA(L1PCttfu,jcon) ) THEN     ! TFU# valid ??
                  list(ilis) = jcon
                  L1PCstor(ipcpo+L1PCcons+ilis-1) =
     &                 L1DEFtfudef(L1TFUprcnum,jcon)  ! TFUs prc pointer
                  ilis = ilis + 1
               ELSE
                  WRITE (L1LUNprn,910) 'TFU',num,'TFU',jcon
               END IF
               END IF
            END DO
            IF ( ilis.gt.1 ) THEN
               ilis = ilis - 1                 ! correct for last advance
               L1PCstor(ipcpo+L1PCncon) = ilis ! number of conn. TFUs
               WRITE (L1LUNprn,900) 'TFU',num,'TFU',
     &              (list(icon),L1PCstor(ipcpo+L1PCcons+icon-1),
     &                                                  icon=1,ilis)
            END IF
         END IF
      END DO
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      WRITE (L1LUNprn,300)
 300  FORMAT(/' TrackFindingUnits conns to TrackParameterModules :')
c
      DO iprc=1,L1PARntfu
         ipcpo = L1PRCPO(L1PCttfu,iprc)
         IF ( ipcpo.gt.0 ) THEN
            num = L1PCstor(ipcpo+L1PCnum)          ! TFU ID
            jcon = L1DEFtfudef(L1TFUtpm,num)       ! number of TPM
            IF ( L1PRCVA(L1PCttpm,jcon) ) THEN     ! TPM# valid ??
               ilis = L1PCstor(ipcpo+L1PCncon)     ! # of TFU conns
               L1PCstor(ipcpo+L1PCcons+ilis) =
     &              L1DEFtpmdef(L1TPMprcnum,jcon)  ! TPMs prc pointer
               L1PCstor(ipcpo+L1PCncon) = ilis+1   ! advance ...
               WRITE (L1LUNprn,900) 'TFU',num,'TPM',
     &              jcon,L1PCstor(ipcpo+L1PCcons+ilis)
            ELSE IF ( jcon.gt.0 ) THEN
               WRITE (L1LUNprn,910) 'TFU',num,'TPM',jcon
            END IF
         END IF
      END DO
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      WRITE (L1LUNprn,400)
 400  FORMAT(/' TrackParameterModules conns to MassCalculationUnits :')
c
      DO iprc=1,L1PARntpm
         ipcpo = L1PRCPO(L1PCttpm,iprc)
         IF ( ipcpo.gt.0 ) THEN
            ilis = 1                                  ! no MCUs found
            num = L1PCstor(ipcpo+L1PCnum)             ! TPM num
            DO icon=0,L1DEFtpmdef(L1TPMnmcu,num)-1    ! loop over MCUs
               jcon = L1DEFtpmdef(L1TPMmcus+icon,num) ! number of MCU
               IF ( L1PRCVA(L1PCtmcu,jcon) ) THEN     ! MCU# valid ??
                  list(ilis) = jcon
                  L1PCstor(ipcpo+L1PCcons+ilis-1) =
     &                 L1DEFmcudef(L1MCUprcnum,jcon)  ! MCUs prc number
                  ilis = ilis + 1
               ELSE
                  WRITE (L1LUNprn,910) 'TPM',num,'MCU',jcon
               END IF
            END DO
            ilis = ilis - 1                   ! correct for last advance
            L1PCstor(ipcpo+L1PCncon) = ilis   ! number of conn. MCUs
            WRITE (L1LUNprn,900) 'TPM',num,'MCU',
     &      (list(icon),L1PCstor(ipcpo+L1PCcons+icon-1),icon=1,ilis)
         END IF
      END DO
c
      WRITE (L1LUNprn,'(/)')
c
      RETURN
c
 900  FORMAT(1x,a3,i3.3,' sends to ',a3,
     &	'(PRC)s:',20(I3,'(',I5,')':','))
 910  FORMAT(1x,a3,i3.3,' is connected to invalid ',a3,I3.3)
c
      END

