*CMZ :          07/03/96  17.28.33  by  Thomas Fuljahn
*CMZ :  1.00/03 20/08/95  15.51.48  by   Ivan Belyaev
*CMZ :  1.00/01 19/08/95  19.30.33  by   Ivan Belyaev
*CMZ :  0.02/00 07/12/94  21.45.03  by  Dominik Ressing
*CMZ :  0.01/03 17/09/94  18.35.04  by  Fedor Ratnikov
*CMZ :  0.01/02 26/07/94  19.25.02  by  Dominik Ressing
*CMZ :  0.01/01 23/07/94  22.50.28  by  Dominik Ressing
*-- Author :    Dominik Ressing   21/07/94
************************************************************************
*
* L1PRCIN
* written by Dominik Ressing, 21/07/94 11.49.36
*
* This routines action:
* initializes the processor data structures for job sceduling
*
* Arguments   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* itime        in          start time for processors
*
************************************************************************
c
      SUBROUTINE L1PRCIN(itime)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1mcuda.fi"
c
      INTEGER iprc,ipcpo,itime,ico,i,ii,iCopy
      CHARACTER*4 ctype1,ctype2
      LOGICAL L1PRCVA
      EXTERNAL L1PRCVA
#include "l1si/l1prcdf.ff"
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Initialize Pretriggers
c
      ico = 1                      ! we expect next defined pretrigger number here
      DO iprc=1,L1PARnpre
         ipcpo = L1PCprep(iprc)
         L1PCstor(ipcpo+L1PCtype) = L1PCtpre   ! set PRE type
         L1PCstor(ipcpo+L1PCbusy) = itime      ! set start time
         L1PCstor(ipcpo+L1PClast) = itime
         L1PCstor(ipcpo+L1PCnfif) = 0          ! fifo is empty
         L1PCstor(ipcpo+L1PCemul) = 0          ! not emulated
c
c        --- search for next valid pretrigger definition entry
         DO WHILE (   (.not.L1PRCVA(L1PCtpre,ico))
     &           .and.(ico.le.L1DEFmaxpre) )
            ico = ico + 1
         END DO
         IF ( ico.lt.L1DEFmaxpre ) THEN
            L1PCstor(ipcpo+L1PCnum) = ico        !set PRE num in PRC
            L1DEFpredef(L1PREprcnum,ico) = ipcpo !set PRC pointer in PRE
c
c           redefine Superlayers inernally
c
            IF(L1DEFpredef(L1PREkind,ico).EQ.L1PREelec)  THEN
             L1DEFpredef(L1PREsl,ico) = L1DEFsupECAL  ! e - pretrig
            ELSEIF(L1DEFpredef(L1PREkind,ico).EQ.L1PREmuon)  THEN
             L1DEFpredef(L1PREsl,ico) = L1DEFsupMUPRE  ! mu - pretrig
            ELSEIF(L1DEFpredef(L1PREkind,ico).EQ.L1PREpxmuon)  THEN
             L1DEFpredef(L1PREsl,ico) = L1DEFsupMXPRE  ! mu pixel - pretrig
            ELSEIF(L1DEFpredef(L1PREkind,ico).EQ.L1PREpipi)  THEN
             L1DEFpredef(L1PREsl,ico) = L1DEFsupPTL3  ! PP - pretrig
            ELSE
             WRITE(L1LUNprn,*)
     &            ' L1PRCIN ==> FATAL: unknown PRE type:',
     &            L1DEFpredef(L1PREsl,ico)
            ENDIF
         ELSE
c           --- this can not happen if everything works correct !!!
            WRITE(L1LUNprn,*)
     &        ' L1PRCIN ==> FATAL: found no definition for PRE ',iprc
            L1PCstor(ipcpo+L1PCnum) = 0        ! set PRE num to invalid
         END IF
         ico = ico + 1                         ! next pretrigger definition
      END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c        Initialize TFUs
c
      ico = 1
      DO iprc=1,L1PARntfu
         ipcpo = L1PCtfup(iprc)
         L1PCstor(ipcpo+L1PCtype) = L1PCttfu  ! is of type TFU
         L1PCstor(ipcpo+L1PCbusy) = itime     ! set start time
         L1PCstor(ipcpo+L1PClast) = itime
         L1PCstor(ipcpo+L1PCnfif) = 0          ! fifo is empty
         L1PCstor(ipcpo+L1PCemul) = 0          ! not emulated
c
         DO WHILE (   (.not.L1PRCVA(L1PCttfu,ico))
     &           .and.(ico.le.L1DEFmaxtfu) )
            ico = ico + 1
         END DO
         IF ( ico.lt.L1DEFmaxtfu ) THEN
            L1PCstor(ipcpo+L1PCnum) = ico        !set TFU num in prc
            L1DEFtfudef(L1TFUprcnum,ico) = ipcpo !set PRC pointer in TFU
         ELSE
c           --- this can not happen if everything works correct !!!
            WRITE(L1LUNprn,*)
     &        ' L1PRCIN ==> FATAL: found no definition for TFU ',iprc
            L1PCstor(ipcpo+L1PCnum) = 0        ! set TFU num to invalid
         END IF
         ico = ico + 1                         ! next TFU definition
      END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c        Initialize TPMs
c
      ico = 1
      DO iprc=1,L1PARntpm
         ipcpo = L1PCtpmp(iprc)
         L1PCstor(ipcpo+L1PCtype) = L1PCttpm  ! is of type TPM
         L1PCstor(ipcpo+L1PCbusy) = itime     ! set start time
         L1PCstor(ipcpo+L1PClast) = itime
         L1PCstor(ipcpo+L1PCnfif) = 0          ! fifo is empty
         L1PCstor(ipcpo+L1PCemul) = 0          ! not emulated
c
         DO WHILE (   (.not.L1PRCVA(L1PCttpm,ico))
     &           .and.(ico.le.L1DEFmaxtpm) )
            ico = ico + 1
         END DO
         IF ( ico.lt.L1DEFmaxtpm ) THEN
            L1PCstor(ipcpo+L1PCnum) = ico        ! set TPM num in PRC
            L1DEFtpmdef(L1TPMprcnum,ico) = ipcpo !set PRC pointer in TPM
         ELSE
c           --- this can not happen if everything works correct !!!
            WRITE(L1LUNprn,*)
     &        ' L1PRCIN ==> FATAL: found no definition for TPM ',iprc
            L1PCstor(ipcpo+L1PCnum) = 0        ! set TPM num to invalid
         END IF
         ico = ico + 1                         ! next TPM definition
      END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c        Initialize MCUs
c
      ico = 1
      DO iprc=1,L1PARnmcu
         ipcpo = L1PCmcup(iprc)
         L1PCstor(ipcpo+L1PCtype) = L1PCtmcu  ! is of type MCU
         L1PCstor(ipcpo+L1PCbusy) = itime     ! set start time
         L1PCstor(ipcpo+L1PClast) = itime
         L1PCstor(ipcpo+L1PCnfif) = 0          ! fifo is empty
         L1PCstor(ipcpo+L1PCemul) = 0          ! not emulated
c
         DO WHILE (   (.not.L1PRCVA(L1PCtmcu,ico))
     &           .and.(ico.le.L1DEFmaxmcu) )
            ico = ico + 1
         END DO
         IF ( ico.lt.L1DEFmaxmcu ) THEN
            L1PCstor(ipcpo+L1PCnum) = ico        ! set MCU num
            L1DEFmcudef(L1MCUprcnum,ico) = ipcpo !set PRC pointer in MCU
         ELSE
c           --- this can not happen if everything works correct !!!
            WRITE(L1LUNprn,*)
     &        ' L1PRCIN ==> FATAL: found no definition for MCU ',iprc
            L1PCstor(ipcpo+L1PCnum) = 0        ! set MCU num to invalid
         END IF
         ico = ico + 1                         ! next MCU definition
      END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c      initialize test boards
c
c      the pointers in L1PCstor form the original processors are used to
c      change the processors which are covered by the test boards to
c      emulated by TEB type.
c
      DO iprc=1,L1TEBconPREnum
         ipcpo = L1DEFpredef(L1PREprcnum,L1TEBpres(iprc))
         L1PCstor(ipcpo+L1PCemul) = L1PCtteb   ! set TEB type
      END DO
      DO iprc=1,L1TEBconTFUnum
         ipcpo = L1DEFtfudef(L1TFUprcnum,L1TEBtfus(iprc))
         L1PCstor(ipcpo+L1PCemul) = L1PCtteb   ! set TEB type
      END DO
      DO iprc=1,L1TEBconTPMnum
         ipcpo = L1DEFtpmdef(L1TPMprcnum,L1TEBtpms(iprc))
         L1PCstor(ipcpo+L1PCemul) = L1PCtteb   ! set TEB type
      END DO
      DO iprc=1,L1TEBconMCUnum
         ipcpo = L1DEFmcudef(L1MCUprcnum,L1TEBmcus(iprc))
         L1PCstor(ipcpo+L1PCemul) = L1PCtteb   ! set TEB type
      END DO
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     fill definition table
c
      DO i=0,L1MCUNtypes
         IF ( i.eq.L1MCUeplus ) THEN
            C1MCUtypeDEF(i) = C1MCUeplus
         ELSE IF ( i.eq.L1MCUeminus ) THEN
            C1MCUtypeDEF(i) = C1MCUeminus
         ELSE IF ( i.eq.L1MCUmuplus ) THEN
            C1MCUtypeDEF(i) = C1MCUmuplus
         ELSE IF ( i.eq.L1MCUmuminus ) THEN
            C1MCUtypeDEF(i) = C1MCUmuminus
         ELSE IF ( i.eq.L1MCUpiplus ) THEN
            C1MCUtypeDEF(i) = C1MCUpiplus
         ELSE IF ( i.eq.L1MCUpiminus ) THEN
            C1MCUtypeDEF(i) = C1MCUpiminus
         ELSE
            C1MCUtypeDEF(i) = C1MCUdummy
         END IF
      END DO
c
c        Initialize Trigger
c
      IF (L1PARprnlev.GE.1)	THEN
        PRINT 905,'Trig No','Part 1','Part 2',
     &     'M min','M max','Pt cut 1','Pt cut 2','EAsym.cut'
 905    FORMAT (8A10)
      ENDIF
      L1MCUntriggers = 0
      DO i=1,L1MCUmaxtriggers
        CALL CLTOU(C1MCUtrig(L1MCUtrictype1,i)) !translate into upper case
        ctype1 = C1MCUtrig(L1MCUtrictype1,i)
        CALL CLTOU(C1MCUtrig(L1MCUtrictype2,i)) !translate into upper case
        ctype2 = C1MCUtrig(L1MCUtrictype2,i)

        IF ((ctype1.EQ.C1MCUeplus.OR.ctype1.EQ.C1MCUeminus.OR.
     &      ctype1.EQ.C1MCUmuplus.OR.ctype1.EQ.C1MCUmuminus.OR.
     &      ctype1.EQ.C1MCUpiplus.OR.ctype1.EQ.C1MCUpiminus).AND.
     &      (ctype2.EQ.C1MCUeplus.OR.ctype2.EQ.C1MCUeminus.OR.
     &      ctype2.EQ.C1MCUmuplus.OR.ctype2.EQ.C1MCUmuminus.OR.
     &      ctype2.EQ.C1MCUpiplus.OR.ctype2.EQ.C1MCUpiminus))  THEN
          L1MCUntriggers = L1MCUntriggers+1
c
c       Translate c-type into i-type
c
          IF (ctype1.EQ.C1MCUeplus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUeplus
          ELSEIF (ctype1.EQ.C1MCUeminus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUeminus
          ELSEIF (ctype1.EQ.C1MCUmuplus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUmuplus
          ELSEIF (ctype1.EQ.C1MCUmuminus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUmuminus
          ELSEIF (ctype1.EQ.C1MCUpiplus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUpiplus
          ELSEIF (ctype1.EQ.C1MCUpiminus)	THEN
            L1MCUtrig(L1MCUtriitype1,i) = L1MCUpiminus
          ENDIF
          IF (ctype2.EQ.C1MCUeplus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUeplus
          ELSEIF (ctype2.EQ.C1MCUeminus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUeminus
          ELSEIF (ctype2.EQ.C1MCUmuplus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUmuplus
          ELSEIF (ctype2.EQ.C1MCUmuminus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUmuminus
          ELSEIF (ctype2.EQ.C1MCUpiplus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUpiplus
          ELSEIF (ctype2.EQ.C1MCUpiminus)	THEN
            L1MCUtrig(L1MCUtriitype2,i) = L1MCUpiminus
          ENDIF
c
          IF (i.GT.L1MCUntriggers)	THEN
            CALL UCOPY(L1MCUtrig(1,i),L1MCUtrig(1,L1MCUntriggers),
     &                  L1MCUtriglength)	!copy trigger parameter
          ENDIF
          IF (L1PARprnlev.GE.1)	THEN
            PRINT 906 , L1MCUntriggers ,
     &       C1MCUtrig( L1MCUtrictype1 , L1MCUntriggers ) ,
     &       C1MCUtrig( L1MCUtrictype2 , L1MCUntriggers ) ,
     &       T1MCUtrig( L1MCUtrilow    , L1MCUntriggers ) ,
     &       T1MCUtrig( L1MCUtrihigh   , L1MCUntriggers ) ,
     &       T1MCUtrig( L1MCUtri1lowPT , L1MCUntriggers ) ,
     &       T1MCUtrig( L1MCUtri2lowPT , L1MCUntriggers ) ,
     &       T1MCUtrig( L1MCUtriEasym  , L1MCUntriggers )
 906        FORMAT ( I10 , 2A10 , 5F10.3 )
          ENDIF
        ELSEIF (ctype1.EQ.C1MCUdummy)	THEN	!skip nondefined trigger
        ELSE
          PRINT 907, 'Error==>',
     &            C1MCUtrig(L1MCUtrictype1,i),
     &            C1MCUtrig(L1MCUtrictype2,i),
     &            T1MCUtrig(L1MCUtrilow,i),
     &            T1MCUtrig(L1MCUtrihigh,i)
 907        FORMAT (A8,2A10,2F10.3)
        ENDIF
      ENDDO
c
      CALL l1prcve(2,ii)
c
      L1PCcyc(L1PCtpre) = 0
      L1PCcyc(L1PCttfu) = L1DEFtfucyc  ! re-fill TFU cycle time
      L1PCcyc(L1PCttpm) = L1DEFtpmcyc  ! re-fill TPM cycle time
      L1PCcyc(L1PCtmcu) = L1DEFmcucyc  ! re-fill MCU cycle time
      WRITE(L1LUNprn,910) (L1PCcyc(i),i=1,L1PCtypes)
 910  FORMAT(' L1PRCIN ==> cycle times: ',10i4:)
c
      RETURN
c
      END
